<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:my="http://blog.matfyz.sk"
    xmlns:func="http://exslt.org/functions"
    extension-element-prefixes="my func">
  <xsl:import href="templates.xsl" />
  <xsl:variable name="userID" select='/user/@ID|//userID' />
  <xsl:variable name="title"  />
  <xsl:variable name="subtitle" />
  <xsl:variable name="blogTitle" />
  <xsl:variable name="nick" />
  <xsl:variable name="avatar" />
  <xsl:variable name="header" />
  <xsl:variable name="q" />
  <xsl:param name="description" />
  <xsl:param name="keywords" />
  <xsl:param name="svnVersion" />
  
  <!-- Preklad -->
  <xsl:variable name="Lang">
    <xsl:choose>
      <xsl:when test="$lang='ensk'">en</xsl:when>
      <xsl:otherwise><xsl:value-of select="$lang" /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="StringFile" select="document('./translations/pages.xml')"/>
  <xsl:variable name="StringFileDefault" select="document('./translations/layout.xml')"/>
  
  <xsl:template match="/">
    <html>
      <head>
        <title>
          <xsl:value-of select="$title" />
        </title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta name="description" content="{$description}" />
        <meta name="keywords" content="{$keywords}" />
        <link rel="stylesheet" href="./css/style.css" type="text/css" media="screen" />
        <link rel="stylesheet" href="./css/languages.css" type="text/css" media="screen" />
        <link rel="stylesheet" href="./css/main.css" type="text/css" media="screen" />
				
				<!-- rozne dizajny pre rozne stavy -->
				<xsl:if test="$type='blogView' or $type='postView' or $type='loginForm'">
					<link rel="stylesheet" href="./css/style_2column_narrow.css" type="text/css" media="screen" />				
				</xsl:if>
				<xsl:if test="$type='userPosts' or $type='uploadForm' or $type='editPost' or $type='commentForm' or $type='addPost'">
					<link rel="stylesheet" href="./css/style_1column_wide.css" type="text/css" media="screen" />				
				</xsl:if>
				<xsl:if test="$type='settingsForm'">
					<link rel="stylesheet" href="./css/style_1column_narrow.css" type="text/css" media="screen" />				
				</xsl:if>		
				
				<!-- pre XML editor -->
				<xsl:if test="($type='editPost') or ($type='addPost' and $inCourse)">				
					<link rel="stylesheet" href="./xml_editor/style.css" type="text/css" media="screen" />				
				</xsl:if>		
				
        <xsl:if test="$nick != ''">
          <link rel="alternate" href="http://{$nick}.{$base}/?type=rss" type="application/rss+xml" />
          <link rel="alternate" href="http://{$nick}.{$base}/?type=rss&amp;lang=en" type="application/rss+xml" />
          <link rel="alternate" href="http://{$nick}.{$base}/?type=rss&amp;lang=ensk" type="application/rss+xml" />
        </xsl:if>
        <link rel="alternate" href="http://{$base}/?type=rss" type="application/rss+xml" />
        <link rel="alternate" href="http://{$base}/?type=rss&amp;lang=en" type="application/rss+xml" />
        <link rel="alternate" href="http://{$base}/?type=rss&amp;lang=ensk" type="application/rss+xml" />
        <script type="text/javascript" src="ajax/preview.js"></script>
        <script type="text/javascript" src="ajax/tags.js"></script>
        <script type="text/javascript" src="ajax/sort.js"></script>
        <link rel="shortcut icon" href="./css/favicon.png"/>
        <script type="text/javascript" src="ajax/checkUserName.js" />
      </head>
      <body>
        <div class="wrap-t lt">
          <span class="rt">
            <span class="i"></span>
          </span>
        </div>
				
        <div class="wrap-env">
        <div class="wrap">
         
						<div class="wheader f1">
							<div class="l">
								<div class="t">
									<div class="b">
										<div class="r">
											<div class="lt">
												<div class="lb">
													<div class="rt">
														<div class="rb wmenu">
															<div id="header">
																<div id="logo-wrapper"><h1 id="logo"><a href="http://{$base}">blog.matfyz.sk<span></span></a></h1></div>
															
																<!--<a href="http://{$base}"><img alt="blog.matfyz.sk" src="./css/logo_white.png"  /></a>-->
																<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
																</script>
																<script type="text/javascript">
																_uacct = "UA-965430-2";
																urchinTracker();
																</script>
																<div class="loginArea">
																<xsl:choose>
																	<xsl:when test="$loggedUser">
																		<p><xsl:call-template name="getStringDefault">
																			<xsl:with-param name="stringName" select="'Logged as'"/>
																		</xsl:call-template>: <strong><xsl:value-of select="$loggedUser" /></strong> | <a href="http://{$base}/?type=logout&amp;url={$url}" class="raquo"><xsl:call-template name="getStringDefault">
																			<xsl:with-param name="stringName" select="'Logout'"/>
																		</xsl:call-template></a></p>
																	</xsl:when>
																	<xsl:otherwise>
																		<p><a href="http://{$base}/login?from={$urlEncoded}" title="Prihlasovací formulár na samostatnej podstránke" class="raquo"><xsl:call-template name="getStringDefault">
																			<xsl:with-param name="stringName" select="'Login'"/>
																		</xsl:call-template></a></p>
																	</xsl:otherwise>
																</xsl:choose>
																</div>
																<div id="searchBox">
																<xsl:variable name="searchStringValue"><xsl:call-template name="getStringDefault">
																	<xsl:with-param name="stringName" select="'Search'"/>
																</xsl:call-template></xsl:variable>
																	<form id="searchForm" action="http://{$base}/search" method="get">
																		<fieldset>
																			<input type="text" name="q" id="q" value="{$q}" class="inputbox" maxlength="64"/>
																			<input type="submit" id="searchSubmit" class="submit" value="{$searchStringValue}"/>
																		</fieldset>
																	</form>
																</div>
															</div>  
															<div id="menu"> 
																<div class="wmenu2">
																	<div class="wmenu3">
																		<div class="wmenu4">
																			<div class="wmenuLeft">
																			
																					<a href="./?postLang=sk" class="skLang skLangTop" title="Slovenské príspevky">Slovensky</a> | <a href="./?postLang=en" class="enLang enLangTop" title="English articles">English</a> | <a href="./?postLang=ensk" title="All languages">All languages</a>
																					
																				<!-- prepinanie jazykov pomocou select boxu -->
																				<!-- 
																				<form id="languageForm" action="./" method="get">
																					<fieldset>
																					<xsl:call-template name="getStringDefault">
																						<xsl:with-param name="stringName" select="'Posts'"/>
																					</xsl:call-template><xsl:text>: </xsl:text>
																					<select name="postLang" onchange="submit()">
																						<xsl:element name="option">
																							<xsl:attribute name="value">sk</xsl:attribute>
																							<xsl:attribute name="class">sk</xsl:attribute>
																							<xsl:if test="$lang='sk'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
																							<xsl:call-template name="getStringDefault">
																								<xsl:with-param name="stringName" select="'slovak'"/>
																							</xsl:call-template>
																						</xsl:element>
																						<xsl:element name="option">
																							<xsl:attribute name="value">en</xsl:attribute>
																							<xsl:attribute name="class">en</xsl:attribute>
																							<xsl:if test="$lang='en'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
																							<xsl:call-template name="getStringDefault">
																								<xsl:with-param name="stringName" select="'english'"/>
																							</xsl:call-template>
																						</xsl:element>
																						<xsl:element name="option">
																							<xsl:attribute name="value">ensk</xsl:attribute>
																							<xsl:if test="$lang='ensk'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
																							<xsl:call-template name="getStringDefault">
																								<xsl:with-param name="stringName" select="'all'"/>
																							</xsl:call-template>
																						</xsl:element>
																					</select>
																					<xsl:variable name="changeSubmit"><xsl:call-template name="getStringDefault">
																						<xsl:with-param name="stringName" select="'Change'"/>
																					</xsl:call-template></xsl:variable>
																					<input type="submit" id="languageSubmit" value="$changeSubmit"/>
																					</fieldset>
																				</form>
																				<script type="text/javascript">
																					var lngsubmit = document.getElementById('languageSubmit');
																					lngsubmit.style.display = 'none';
																				</script>
																			-->
																			</div>
																			<div class="wmenuRight">
																				<xsl:choose>
																					<xsl:when test="$loggedUser">
																						<xsl:choose>
																							<xsl:when test="$inCourse">
																								<a href="http://{$base}">Titulka</a> |
																								<a href="http://{$loggedUser}.{$base}">Môj blog</a> |
																								<a href="http://{$loggedUser}.{$base}/newpost"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'New post'"/>
																								</xsl:call-template></a>/<a href="http://{$loggedUser}.{$base}/newcomment">komentár</a> |
																								<a href="http://{$loggedUser}.{$base}/settings"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Settings'"/>
																								</xsl:call-template></a> |
																								<a href="http://{$loggedUser}.{$base}/upload"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Files'"/>
																								</xsl:call-template></a> |
			<a href="http://wiki.matfyz.sk/">Wiki</a> |
																								<a href="http://{$loggedUser}.{$base}/studentHelp"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Help'"/>
																								</xsl:call-template></a>
																							</xsl:when>
																							<xsl:otherwise>
																								<a href="http://{$base}"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Homepage'"/>
																								</xsl:call-template></a> |
																								<a href="http://{$loggedUser}.{$base}"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'My blog'"/>
																								</xsl:call-template></a> |
																								<a href="http://{$loggedUser}.{$base}/posts"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Posts'"/>
																								</xsl:call-template></a> |
																								<a href="http://{$loggedUser}.{$base}/settings"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Settings'"/>
																								</xsl:call-template></a> |
																								<a href="http://{$loggedUser}.{$base}/upload"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Files'"/>
																								</xsl:call-template></a> |
																								<a href="http://{$base}/about"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'About'"/>
																								</xsl:call-template></a> |
			<a href="http://wiki.matfyz.sk/">Wiki</a> |
																								<a href="http://{$loggedUser}.{$base}/help"><xsl:call-template name="getStringDefault">
																									<xsl:with-param name="stringName" select="'Help'"/>
																								</xsl:call-template></a>
																							</xsl:otherwise>
																						</xsl:choose>
																					</xsl:when>
																					<xsl:otherwise>
																						<xsl:if test="$type!='portalView'">
																						<a href="http://{$base}" title=""><xsl:call-template name="getStringDefault">
																							<xsl:with-param name="stringName" select="'Homepage'"/>
																						</xsl:call-template></a> |
																						</xsl:if>
																						<a href="http://{$base}/about"><xsl:call-template name="getStringDefault">
																							<xsl:with-param name="stringName" select="'About'"/>
																						</xsl:call-template></a> |
	<a href="http://wiki.matfyz.sk/">Wiki</a> |
																						<a href="http://{$base}/help"><xsl:call-template name="getStringDefault">
																							<xsl:with-param name="stringName" select="'Help'"/>
																						</xsl:call-template></a> |
																						<a href="http://{$base}/registration" title=""><xsl:call-template name="getStringDefault">
																							<xsl:with-param name="stringName" select="'Registration'"/>
																						</xsl:call-template></a>
																					</xsl:otherwise>
																				</xsl:choose>
																			</div>
																		</div>
																	</div>
																</div>
															</div><!-- END OF menu -->
														</div>
													</div>
												</div>
											</div>
										</div>
								</div>
							</div>
						</div>
						<xsl:if test="$type='blogView' or $type='postView' or $type='settingsForm'">
							<div class="ie7_rulezzzzzz"><span></span></div>
							<xsl:element name="div">
								<xsl:attribute name="class">heading</xsl:attribute>
								<xsl:if test="$header='true'">
									<xsl:attribute name="style">background: transparent url('http://<xsl:value-of select="$nick" />.<xsl:value-of select="$base" />/header.jpg') no-repeat; height:<xsl:value-of select="$headerHeight" />px;</xsl:attribute>
								</xsl:if>
								<xsl:choose>
									<xsl:when test="$type='blogView'">
										<h3 class="text"><span><xsl:value-of select="$blogTitle" /></span></h3>
									</xsl:when>
									<xsl:otherwise>
										<h3 class="text"><a href="{$blogURL}"><xsl:value-of select="$blogTitle" /></a></h3>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:element>
							<div class="clear"></div>
						</xsl:if>
						</div>
						<div id="heading">
						</div>
						
						<!-- START 3 column Layout -->
						<div id="outer-column-container">
							<div id="inner-column-container">
								<div id="page-container">
										<xsl:if test="
												$type != 'portalView' and
												$type != 'tagView' and
												$type != 'blogView' and
												$type != 'postView' and
												$type != 'userPosts' and
												$type != 'loginForm' and
												$type != 'search'">
											<h2><xsl:value-of select="$title" /></h2>
										</xsl:if>
										<xsl:apply-templates />
										
									<div class="clear-columns"><!-- do not delete --></div>
								</div><!-- END OF page-container -->																	
							</div><!-- END OF source-order-container -->
						</div><!-- END OF outer-column-container -->
						<!-- END OF 3 column Layout-->
						
						<div class="clear"></div>
				</div><!-- END OF wrap -->
			</div><!-- END OF wrap-env -->
		
			<!-- rounded corners - bottom of 3 column layout -->
			<div class="wrap-b lb">
				<span class="rb">
					<span class="i"></span>
				</span>
			</div>
			
			<!-- FOOTER start-->			
        
			<!-- rounded corners - top of footer -->
			<div class="wrap-t lt">
				<span class="rt">
					<span class="i"></span>
				</span>
			</div>
			<div class="wrap-env">
			<div class="wrap">
				<div class="f1">
					<div class="l">
						<div class="t">
							<div class="b">
								<div class="r">
									<div class="lt">
										<div class="lb">
											<div class="rt">
												<div class="rb">
													<div id="footer">
														<div id="footer-menu">
															<a href="http://{$base}"><img alt="blog.matfyz.sk" src="css/logo-160.png" width="160" height="55" /></a>
<!--															<a href="http://modis.ispras.ru/sedna/" title="Sedna, native XML database"><img src="http://wikixmldb.dyndns.org/style/sedna_logo_4.gif" /></a>-->
															<div>
															<a href="http://blog.matfyz.sk/"><xsl:call-template name="getStringDefault">
																<xsl:with-param name="stringName" select="'Homepage'"/>
															</xsl:call-template></a> |
															<a href="http://blog.matfyz.sk/about"><xsl:call-template name="getStringDefault">
																<xsl:with-param name="stringName" select="'About'"/>
															</xsl:call-template></a> |
															<a href="http://blog.matfyz.sk/legal"><xsl:call-template name="getStringDefault">
																<xsl:with-param name="stringName" select="'Rights and assurances'"/>
															</xsl:call-template></a> |
															<a href="http://blog.matfyz.sk/trac"><xsl:call-template name="getStringDefault">
																<xsl:with-param name="stringName" select="'Report bug'"/>
															</xsl:call-template></a>
															<xsl:if test="$svnVersion">
																| <span>SVN: <xsl:value-of select="$svnVersion" /></span>
															</xsl:if>
			</div>
														</div>
					<!--
														<a href="http://modis.ispras.ru/sedna/" title="Sedna, native XML database"><img src="http://wikixmldb.dyndns.org/style/sedna_logo_4.gif" 
																																							style="float:right;
																																										margin-left:1em;
																																										position:absolute;
																																										margin-left:-160px;
																																										margin-top:2px"  /></a>-->
														<p>
															http://blog.matfyz.sk/
															<br />© <a href="http://team.matfyz.sk/">team matfyz.sk</a>, 2007-2009
														<br /><br />
														<xsl:call-template name="getStringDefault">
															<xsl:with-param name="stringName" select="'Posts'"/>
														</xsl:call-template>: 
														<a href="./?postLang=sk" class="skLang"><xsl:call-template name="getStringDefault">
															<xsl:with-param name="stringName" select="'slovak'"/>
														</xsl:call-template></a> | <a href="./?postLang=en" class="enLang"><xsl:call-template name="getStringDefault">
															<xsl:with-param name="stringName" select="'english'"/>
														</xsl:call-template></a> | <a href="./?postLang=ensk"><xsl:call-template name="getStringDefault">
															<xsl:with-param name="stringName" select="'all'"/>
														</xsl:call-template></a>
														</p>
														<div style="height:6px;font-size:0;clear:both;"></div>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			</div><!--wrap-->
			
			<div class="wrap-b lb">
				<span class="rb">
					<span class="i"></span>
				</span>
			</div>
			<div>
				<a href="http://modis.ispras.ru/sedna/" title="Sedna, native XML database"><img src="/css/sedna_logo.gif" alt="Sedna" /></a>
			</div>				
			
      </body>
    </html>
  </xsl:template>
  
  
<func:function name="my:urlpostfix">
  <xsl:param name="what" />
  <xsl:variable name="up" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:variable name="lo" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="space" select="'_ ?.!:=-()/'"/>
  <xsl:variable name="other" select="'          '"/>
  <xsl:variable name="dia" select="'áéíóuýčďľĺňôöřšťž'"/>
  <xsl:variable name="nor" select="'aeiouycdllnoorstz'"/>
  <xsl:variable name="diab" select="'ÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ'"/>
  <xsl:variable name="norb" select="'aeiouycdllnorstz'"/>
  <func:result>
    <xsl:value-of select="
    translate(
      normalize-space(
        translate(
          translate(
       	   translate(
          	  translate(
                $what, $up, $lo
          	  ), $space, $other
        	   ), $dia, $nor
          ), $diab, $norb
    	  )
      ), ' ', '-'
    )" />
  </func:result>
</func:function>

<xsl:template name="getString">
  <xsl:param name="stringName"/>
  <xsl:variable name="str" 
     select="$StringFile/strings/str[@name=$stringName]"/>
  <xsl:choose>
    <xsl:when test="$str[lang($Lang)]">
      <xsl:value-of select="$str[lang($Lang)][1]"/>
    </xsl:when>
    <xsl:when test="$str[lang($PrimaryLang)]">
      <xsl:value-of select="$str[lang($PrimaryLang)][1]"/>
    </xsl:when>
    <xsl:when test="$str">
      <xsl:value-of select="$str[1]"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:message terminate="no">
        <xsl:text>Warning: no string named '</xsl:text>
        <xsl:value-of select="$stringName"/>
        <xsl:text>' found.</xsl:text>
      </xsl:message>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="getStringDefault">
  <xsl:param name="stringName"/>
  <xsl:variable name="str" 
     select="$StringFileDefault/strings/str[@name=$stringName]"/>
  <xsl:choose>
    <xsl:when test="$str[lang($Lang)]">
      <xsl:value-of select="$str[lang($Lang)][1]"/>
    </xsl:when>
    <xsl:when test="$str[lang($PrimaryLang)]">
      <xsl:value-of select="$str[lang($PrimaryLang)][1]"/>
    </xsl:when>
    <xsl:when test="$str">
      <xsl:value-of select="$str[1]"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:message terminate="no">
        <xsl:text>Warning: no string named '</xsl:text>
        <xsl:value-of select="$stringName"/>
        <xsl:text>' found.</xsl:text>
      </xsl:message>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<!-- template na "ak sa nenasli ziadne posty" -->
<xsl:template name="noPostsWarning">
	<div class="warning">
		<xsl:choose>
			<xsl:when test="$lang='ensk'">
				No matching posts found.
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'noPostsInThisLanguage'"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</div>
</xsl:template>

</xsl:stylesheet>
