<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:date="http://exslt.org/dates-and-times"
                xmlns:fn="http://www.w3.org/2005/xpath-functions"
                xmlns:math="http://exslt.org/math"
                xmlns:my="http://blog.matfyz.sk"
                exclude-result-prefixes="math xsl fn"
                extension-element-prefixes="my date fn">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:variable name="userID" select='/user/@ID' />
  <xsl:variable name="title">O matfyze, o živote...</xsl:variable>
  <xsl:variable name="subtitle">a nie len pre matfyzákov</xsl:variable>
  <xsl:param name="tag" />
  <xsl:param name="page" />
  <xsl:param name="type" />
  <xsl:param name="sstr" />
  <xsl:param name="lang" />
  <xsl:param name="sort" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>

  <xsl:template match="portalView">
    <div id="portal">
		
		
			<!-- 3column design skidoo -->
			<div id="source-order-container">
			
				<!-- (1) MIDDLE COLUMN -->
				<div id="middle-column">
					<div class="inside">
					
						<xsl:if test="$type = 'search'">
							<h2><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'Search'"/>
							</xsl:call-template>: <xsl:value-of select="$q" /></h2>
						</xsl:if>
						<xsl:if test="$tag != ''"> 
							<xsl:call-template name="tagBrowser"/>
						</xsl:if>
	    
						<div id="newPosts">
							<xsl:choose>
							<xsl:when test="$type = 'portalView' and (not($page) or $page = 0) and not($tag)"> <!-- titulka, tu berieme z cache-->
								<div id="top5naTitulke">
									<!-- <p id="top5naTitulkeOdporucane">Zaujalo nás:</p> -->
									<xsl:apply-templates select="document('../cron/cache/newPosts.xml')/postList/posts[@lang=$lang]/newPosts/post[dateTop][not(dateTopOut)]" />
								</div>
									<!-- <p id="top5naTitulkeOstatne">Ostatné príspevky:</p> -->
								<xsl:apply-templates select="document('../cron/cache/newPosts.xml')/postList/posts[@lang=$lang]/newPosts/post[not(dateTop) or dateTopOut]" />
								<xsl:choose>
									<!-- ak sa nenasli ziadne posty -->
									<xsl:when test="count(document('../cron/cache/newPosts.xml')/postList/posts[@lang=$lang]/newPosts/post) = 0">
										<xsl:call-template name="noPostsWarning"/>
									</xsl:when>
									<xsl:otherwise>
										<p class="paging"><a href="http://{$base}/?page=1" class="raquo"><xsl:call-template name="getString">
											<xsl:with-param name="stringName" select="'postsOld'"/>
										</xsl:call-template></a></p>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise><!-- bud niesme na prvej stranke alebo je zvoleny nejaky tag, v tomto pripade ale mame zoznam postov pre zvoleny tag, jazyk a stranku, staci ich len vypisat-->
								<xsl:choose>
									<!-- ak sa nenasli ziadne posty -->
									<xsl:when test="count(/portalView/newPosts/post) = 0">
										<xsl:call-template name="noPostsWarning"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:if test="$page > 0">
											<xsl:call-template name="paging" />
										</xsl:if>										
									</xsl:otherwise>
								</xsl:choose>
								<xsl:apply-templates select="/portalView/newPosts" />
								<xsl:call-template name="paging" />
							</xsl:otherwise>
							</xsl:choose>
						</div>
						
					</div>
				</div>
				<!-- end of MIDDLE -->	


				<!-- (2) LEFT COLUMN -->
				<div id="left-column">
					<div class="inside">
								
						<div class="portlet">
							<div id="newUsers">
								<h3><xsl:call-template name="getString">
									<xsl:with-param name="stringName" select="'Blogers'"/>
									</xsl:call-template></h3>
								<xsl:for-each select="document('../cron/cache/newUsers.xml')/list/newUsers/user">
									<xsl:sort select="my:urlpostfix(lastName)" />
									<xsl:variable name="position" select="position()-1" />
									<xsl:if test="my:urlpostfix(substring(lastName,1,1)) != my:urlpostfix(substring(document('../cron/cache/newUsers.xml')/list/newUsers/user[position()=$position]/lastName,1, 1))" >
										<span class="capital"><xsl:value-of select="substring(lastName,1,1)" /></span>
									</xsl:if>
									<a href="http://{nick}.{$base}"><xsl:value-of select="./realName"/></a>
									<br />
								</xsl:for-each>
							</div>
						</div>
						
					</div>
				</div>
				<!-- end of LEFT -->
		
		
				<div class="clear-columns"><!-- do not delete --></div>
			</div><!-- ///source-column-container - tento div spaja 1. + 2. div (middle+left) -->
					
		
			<!-- (3) RIGHT COLUMN -->
			<div id="right-column">
				<div class="inside">
				
				<div class="portlet">
					<h3><xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Campaigns'"/>
					</xsl:call-template></h3>
					<!--
					<a href="http://www.beania.info/" title="Beania 2008 FMFI UK">
            <img id="beania_logo" src="http://blog.matfyz.sk/banners/beania_logo.jpg" alt="Beania 2008 FMFI UK" width="200" />
          </a>
					-->
					<a href="http://wiki.matfyz.sk/" title="wiki.matfyz.sk">
            <img src="http://wiki.matfyz.sk/skins/common/images/wiki.png" alt="wiki.matfyz.sk" style="margin: 5px 0 5px 0;" />
          </a>
          <a href="http://team.blog.matfyz.sk/p2430-pridaj-sa-a-bloguj" title="Bloguj aj ty na matfyze.">
            <img src="http://team.blog.matfyz.sk/bloguj.png" alt="Bloguj aj ty na matfyze." width="180" />
          </a>
          <a href="https://anketa.uniba.sk/fmph/" title="Študentská anketa 2007">
            <img src="./banners/anketa.png" alt="Študentská anketa 2007" width="180" />
          </a>
				</div>
          <div class="postList">
				
           	<div class="portlet">
							<h3><xsl:call-template name="getString">
									<xsl:with-param name="stringName" select="'Best rated'"/>
								</xsl:call-template></h3>
							<ol>
								<xsl:for-each select="//highestReputationPosts/post">
									<xsl:variable name="nazov" select="my:urlpostfix(title)" />
									<xsl:variable name="sstr">
										<xsl:if test="$q">?q=<xsl:value-of select="$q" /></xsl:if>
										<xsl:if test="not($q)"></xsl:if>
									</xsl:variable>
									<li class="noFormat"><a href="http://{user/nick}.{$base}/{@ID}-{$nazov}{$sstr}"><div class="formatted"><xsl:value-of select="title" /></div></a> [<xsl:value-of select="ranks/reputationScore" />]</li>
								</xsl:for-each>
							</ol>
						</div>
						
						<div class="portlet">
            <h3><xsl:call-template name="getString">
                <xsl:with-param name="stringName" select="'mostViewedPosts'"/>
              </xsl:call-template></h3>
            <ol>
              <xsl:for-each select="//mostViewedPosts/post">
                <xsl:variable name="nazov" select="my:urlpostfix(title)" />
                <xsl:variable name="sstr">
                  <xsl:if test="$q">?q=<xsl:value-of select="$q" /></xsl:if>
                  <xsl:if test="not($q)"></xsl:if>
                </xsl:variable>
                <li class="noFormat"><a href="http://{user/nick}.{$base}/{@ID}-{$nazov}{$sstr}"><div class="formatted"><xsl:value-of select="title" /></div></a> [<xsl:value-of select="@accessCount" />]</li>
              </xsl:for-each>
            </ol>
						</div>
          </div>
					
					<div class="portlet">
						<div class="tagCloud">
						<h3><xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'Tags'"/>
							</xsl:call-template></h3>
							<xsl:for-each select="document('../cron/cache/tagCloud.xml')/tagcloud/cloud[@lang=$lang]/tag">
								<xsl:variable name="curTag" select="." />
								<xsl:variable name="tagClass">
									<xsl:if test="(string($tag) = string(.))">highlightedkey</xsl:if>
									<xsl:if test="not($tag)"></xsl:if>
								</xsl:variable>
								<a href="./?tag={.}"><span style="font-size: {80+150*@percent}%;" class="tag {$tagClass}" title="{.}"><xsl:value-of select="normalize-space(.)" /></span></a>
								<xsl:text> </xsl:text>
							</xsl:for-each>
						</div>
          </div>
					
        </div>
      </div>
			<!-- end of RIGHT -->
			
			
			
			

			
			
			
      
    </div>
  </xsl:template>
  <xsl:template match="post">
    <xsl:variable name="lastpost"><xsl:if test="position() = last()"> last</xsl:if></xsl:variable>
    <div class="post{$lastpost}">
		
			<div class="date">
				<xsl:if test="dateTop">
					<xsl:attribute name="class">date dateTop</xsl:attribute>
				</xsl:if>			
				<p>
					<xsl:if test="@lang">
						<img src="./css/flags/{@lang}.png" width="16" height="11" alt="{@lang} flag" class="flag"/>
						|
					</xsl:if>
					<span class="created">
						<xsl:value-of select="substring(date,9,2)" />.
						<xsl:value-of select="substring(date,6,2)" />.
						<xsl:value-of select="substring(date,1,4)" /><xsl:text> </xsl:text>
						<xsl:value-of select="substring(date,12,2)" />:<xsl:value-of select="substring(date,15,2)" />
					</span>
					<xsl:if test="lastUpdate">
						(<xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'Changed'"/>
						</xsl:call-template>: <xsl:value-of select="substring(lastUpdate,9,2)" />.
						<xsl:value-of select="substring(lastUpdate,6,2)" />.
						<xsl:value-of select="substring(lastUpdate,1,4)" /><xsl:text> </xsl:text>
						<xsl:value-of select="substring(lastUpdate,12,2)" />:<xsl:value-of select="substring(lastUpdate,15,2)" />)
					</xsl:if>
					<xsl:if test="dateTop">
						<span class="display_none"> | </span>
						<span class="markTopPost">
							<xsl:if test="dateTop and dateTopOut">
								<xsl:attribute name="class">markTopPost markTopPostOut</xsl:attribute>
							</xsl:if>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'topPost'"/>
							</xsl:call-template>
						</span>
						<img class="imageTopPost" src="./css/topPost.gif" alt="top post" title="top post" />
					</xsl:if>
				</p>
				<div class="clear"></div>
			</div>
		
      <xsl:variable name="nazov" select="my:urlpostfix(title)" />
      <xsl:variable name="sstr">
        <xsl:if test="$q">?q=<xsl:value-of select="$q" /></xsl:if>
        <xsl:if test="not($q)"></xsl:if>
      </xsl:variable>
			
			<div class="postContent">
      <h2 class="noFormat"><a href="http://{user/nick}.{$base}/{@ID}-{$nazov}{$sstr}"><div class="formatted"><xsl:value-of select="title" /></div><xsl:if test="(string-length(subtitle) &gt; 0) and (string-length(subtitle) &lt; 100) ">: <xsl:copy-of select="subtitle/node()" /></xsl:if></a></h2><!-- TODO - Subtitle v h2??? A nevadi raz symbol "&gt;" a raz ">" ???-->
<!--      kategorie (prelozit):
      <xsl:choose>
        <xsl:when test="count(topics/topic[@scope='global'])=0">
          <a href="http://{$base}/?topic=0">ine (prelozit)</a>
	</xsl:when>
	<xsl:otherwise>
          <xsl:for-each select="topics/topic[@scope='global']">
            <a href="http://{$base}/?topic={@id}"><xsl:value-of select="name"/></a>
          </xsl:for-each>
	</xsl:otherwise>
      </xsl:choose>//-->
      <xsl:choose>
        <xsl:when test="contains(content,'--break--')">
          <div class="formatted">
            <xsl:copy-of select="substring-before(content/node(),'--break--')" />
          </div>
        </xsl:when>
        <xsl:otherwise>
          <xsl:if test="content/p">
            <div class="para searchhighlight">
              <xsl:variable name="preview" select="content/p[1]/node()" />
              <xsl:choose> 
                <xsl:when test="string-length(content/*[1]) &lt; 350">
                  <xsl:copy-of select="content/p[1]" />
                </xsl:when>
                <xsl:otherwise>
                   <xsl:value-of select="substring(normalize-space(content/p[1]),1,250)" />...
                </xsl:otherwise>
              </xsl:choose>
            </div>
          </xsl:if>
          <xsl:if test="not(content/p)">
            <div class="formatted">
              <xsl:copy-of select="substring(content/node(),1,150)" />...
            </div>
          </xsl:if>
        </xsl:otherwise>
      </xsl:choose>
      <div class="clear"></div>
      <a href="http://{user/nick}.{$base}/{@ID}-{$nazov}" class="raquo"><xsl:call-template name="getString">
        <xsl:with-param name="stringName" select="'WholePost'"/>
      </xsl:call-template></a>
			</div>
			
      <div class="status">
        <span>
          <a href="http://{user/nick}.{$base}/"><xsl:value-of select="user/realName" /></a> |
          <xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'Views'"/>
          </xsl:call-template>: <span class="accesscount"><xsl:value-of select="@accessCount" /></span>
          |
          <xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'Reactions'"/>
          </xsl:call-template>: <span class="react"><xsl:value-of select="count(.//comment)" /></span>
          <xsl:if test="ranks/reputationScore > 0">
          | 
           <xsl:call-template name="getString">
             <xsl:with-param name="stringName" select="'Score'"/>
           </xsl:call-template>: 
           <xsl:value-of select="ranks/reputationScore" />
          </xsl:if>
        </span>
    </div>
  </div>
</xsl:template>
  
<xsl:template name="paging">
  <xsl:variable name="pagepos">
    <xsl:choose>
      <xsl:when test="$page >= 0"><xsl:value-of select="$page" /></xsl:when>
      <xsl:otherwise>0</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="prev">
    <xsl:choose>
      <xsl:when test="$pagepos = 0">0</xsl:when>
      <xsl:otherwise><xsl:value-of select="$pagepos -1" /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:if test="$pagepos > 0 or /portalView/newPosts/@end &lt; /portalView/newPosts/@last">
  <p class="paging">
    <xsl:if test="$pagepos > 0">
      <a href="http://{$base}/?page={$prev}&amp;tag={$tag}" class="laquo"><xsl:call-template name="getString">
        <xsl:with-param name="stringName" select="'postsNew'"/>
      </xsl:call-template></a>
    </xsl:if>
    <xsl:if test="/portalView/newPosts/@end &lt; /portalView/newPosts/@last">
      <a href="http://{$base}/?page={($pagepos +1)}&amp;tag={$tag}" class="raquo"><xsl:call-template name="getString">
        <xsl:with-param name="stringName" select="'postsOld'"/>
      </xsl:call-template></a>
    </xsl:if>
    <!--<xsl:value-of select="//newPosts/@start" />-<xsl:value-of select="//newPosts/@end" />/<xsl:value-of select="//newPosts/@last" />-->
  </p>
  </xsl:if>
  
</xsl:template>

<xsl:template name="tagBrowser">
	<h2>Tag browser (BETA)</h2>
	<!--<xsl:if test="$tag!=''">
		Selected tag: <xsl:value-of select="$tag"/><br/>
	</xsl:if>-->
	<div style="position:relative;height:25em;">
	
	<object type="image/svg+xml" height = "100%" width="100%" data="?type=getTagBrowserSVG&amp;tag={$tag}" pluginspage="http://www.adobe.com/svg/viewer/install/">
		Súvisiace tagy:<br/>
		<!-- fallback -->
		<xsl:for-each select="//tagBrowser/tag">
			<a href="?tag={.}" style="font-size: {0.7+@percent*3}em;" title="{.}">
				<xsl:value-of select="." />
			</a>
			<xsl:text> </xsl:text>
		</xsl:for-each>
	</object>
	
	</div>
	
	
	<xsl:copy-of select="//tagBrowser/debug"/>
	<br/>
</xsl:template>
  
</xsl:stylesheet>
