<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:param name="timeout" /> 
	<xsl:param name="noTitle" /><!-- ci sa formular vyplnil dobre -->	
	<xsl:param name="noStatus" /><!-- ci sa formular vyplnil dobre -->	
  <xsl:variable name="title" >
    <xsl:if test="not(/postView/post/@ID)">
			<xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'newPost'"/>
			</xsl:call-template>
		</xsl:if>
    <xsl:if test="/postView/post/@ID">
			<xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'editPost'"/>
			</xsl:call-template>
		</xsl:if>
  </xsl:variable>
  <xsl:variable name="type" >
    <xsl:if test="not(/postView/post/@ID)">addPost</xsl:if>
    <xsl:if test="/postView/post/@ID">editPost</xsl:if>
  </xsl:variable>
  <xsl:variable name="blogTitle" select='/postView/title' />
  <xsl:variable name="nick" select='/postView/nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  <xsl:template match="/*">
    <script type="text/javascript">
      function update() {
        getPreview(document.getElementById('postContent').value);
        // var t=setTimeout("update()",1000);
      }
      function enableMe(obj) {
        var sBox = document.getElementById("subtitleBox");
        var subtitle = document.getElementById("subtitle");
        if (obj.checked) {
          sBox.className = "enabled";
          subtitle.disabled = false;
        } else {
          sBox.className = "disabled";
          subtitle.disabled = true;
          subtitle.value = "";
        }
      }
      function checkPost(val) {
        var cf = document.getElementById("checkForm");
        var st = document.getElementById("submitButton");
        var title = document.getElementById("title").value;
        if (title != "") {
          cf.innerHTML = '<div class="ok" style="text-align: left;">
						<xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'correctFormFill'"/>
						</xsl:call-template>
						<xsl:text> </xsl:text>
						</div>';
          st.className = "submit";
          st.disabled = false;
        } else {
          cf.innerHTML = '<div class="fail" style="text-align: left;">
						<xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'notCorrectFormFill'"/>
						</xsl:call-template>
						<xsl:text> </xsl:text>
						</div>';
          st.className = "submit disabled";
          st.disabled = true;
        }
      
      }
    </script>
	
	<!-- Warningy, ktore polia neboli vyplnene -->
	<!--
	<xsl:if test="$noTitle=1">
		Nevyplnený nadpis
	</xsl:if>
	<xsl:if test="$noStatus=1">
		Nevyplnený status
	</xsl:if>
	-->
		
	<div id="postForm">
    <form action="{$blogURL}/?type={$type}" method="post" class="frm">
      <input type="hidden" name="postID" value="{/postView/post/@ID}" />
      <fieldset>
			
	<div class="postFormSection">
		<label for="title" class="indentLabel"><xsl:call-template name="getString">
			<xsl:with-param name="stringName" select="'Title'"/>
		</xsl:call-template>: <xsl:call-template name="questionMark"/></label>
		<input type="text" name="title" id="title" class="input_large" value="{/postView/post/title}" onkeyup="checkPost(this.value)" />
		<br />        

		<!-- Podnadpis -->	
		<!--
		<xsl:choose>
			<xsl:when test='string-length(/postView/post/subtitle)=0'>
				<div id="subtitleBox" class="disabled">
					<label for="subtitle" class="indentLabel"><xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Subtitle'"/>
					</xsl:call-template>? 
					<input type="checkbox" id="enableBox" onchange="enableMe(this)"/><xsl:call-template name="questionMark"/></label>
					<input type="text" name="subtitle" id="subtitle" class="input_large" value="" disabled="true" />
				</div>
			</xsl:when>
			<xsl:otherwise>
				<div id="subtitleBox" class="enabled">
					<label for="subtitle" class="indentLabel"><xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Subtitle'"/>
					</xsl:call-template>?
					<input type="checkbox" id="enableBox" checked="checked" onchange="enableMe(this)"/></label>
					<input type="text" name="subtitle" id="subtitle" class="input_large" value="{/postView/post/subtitle}" />
				</div>
			</xsl:otherwise>
		</xsl:choose>
		-->
		
		<!--<xsl:copy-of select="string-length(/postView/post/subtitle/text())"></xsl:copy-of>-->
	
		<!--
		<xsl:if test="/postView/post/subtitle=''">
			<script type="text/javascript">
				enableMe(document.getElementById("enableBox"));
			</script>
		</xsl:if>
		<br />
		-->	
		
		<label for="language" class="indentLabel"><xsl:call-template name="getString">
			<xsl:with-param name="stringName" select="'Language'"/>
		</xsl:call-template>: <xsl:call-template name="questionMark"/></label>
		<select name="language" class="input_large">
			<xsl:element name="option">
				<xsl:attribute name="value">sk</xsl:attribute>
				<xsl:if test="/postView/post/@lang='sk'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
				slovenský
			</xsl:element>
			<xsl:element name="option">
				<xsl:attribute name="value">en</xsl:attribute>
				<xsl:if test="/postView/post/@lang='en' or ($Lang='en' and not(/postView/post/@ID))"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
				english
			</xsl:element>
		</select>
	</div>
				
	<div class="postFormSection">
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Preview'"/>
        </xsl:call-template><xsl:text> </xsl:text><xsl:call-template name="questionMark"/></h3>
        <div id="preview" class="preview">
          <xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Preview'"/>
					</xsl:call-template>
        </div>
	<!--
        <div id="timeline"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'postSendTo'"/>
        </xsl:call-template><xsl:text> </xsl:text><iframe src="/renewSession.php" scrolling="no"/>//--><!--<xsl:value-of select="$timeout" />--><!--</div>//-->
        <label for="content"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'postText'"/>
        </xsl:call-template>: <xsl:call-template name="questionMark"/></label><br />
				
				<!-- ak ma post atribut type="xhtml" (cize bol pisany byvalym studentom) umozni zapnut XML editor -->				
				<!--
				<xsl:if test="/postView/post[@type='xhtml']">
					<script src="./xml_editor/prototype.js" type="text/javascript"></script>					
					<script src="./xml_editor/main.js" type="text/javascript" charset="utf-8"></script>
					<input type="checkbox" id="xml_editor_checkbox" onchange="change('article_content', 'xml_editor_checkbox');" />
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'xmlEditorLabel'"/>
					</xsl:call-template>
				</xsl:if>
				-->
				
				<div id="article_content">
					<textarea id="postContent" name="postContent" class="megaBox" onkeyup="getPreview(document.getElementById('postContent').value)">
						<xsl:copy-of select="/postView/post/content/node()" />
					</textarea>
				</div>
        <script type="text/javascript">update();</script>
		
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Hints'"/>
        </xsl:call-template><xsl:text> </xsl:text><xsl:call-template name="questionMark"/></h3>
				<table class="docuwikitable">
					<thead>
						<tr>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsWrite'"/>
							</xsl:call-template>:</th>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsView'"/>
							</xsl:call-template>:</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><kbd>**bold**</kbd></td>
							<td><strong>bold</strong></td>
						</tr>
						<tr>
							<td><kbd>//italic//</kbd></td>
							<td><em>italic</em></td>
						</tr>
						<tr>
							<td><kbd>[[http://matfyz.sk|<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsLink'"/>
							</xsl:call-template>]]</kbd></td>
							<td><a href="http://matfyz.sk">
								<xsl:call-template name="getString">
									<xsl:with-param name="stringName" select="'hintsLink'"/>
								</xsl:call-template>
							</a></td>
						</tr>
					</tbody>
				</table>
			
				<table class="docuwikitable">
					<thead>
						<tr>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsWrite'"/>
							</xsl:call-template>:</th>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsView'"/>
							</xsl:call-template>:</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><kbd>=====<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 2=====</kbd></td>
							<td><h3 class="noMargin"><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 2</h3></td>
						</tr>
						<tr>
							<td><kbd>====<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 3====</kbd></td>
							<td><h4 class="noMargin"><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 3</h4></td>
						</tr>
						<tr>
							<td><kbd>===<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 4===</kbd></td>
							<td><h5 class="noMargin"><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 4</h5></td>
						</tr>						
					</tbody>
				</table>
				<div class="clear"></div>
								
				<p>
          <xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'cutText1'"/>
          </xsl:call-template>
					<xsl:text> </xsl:text><strong>--break--</strong><xsl:text> </xsl:text>
					<xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'cutText2'"/>
          </xsl:call-template>
				</p>
        <ul>
          <li><a href="http://stettner.{$base}/p1-syntax-i">Syntax formátovania textu</a></li>
          <li><a href="http://stettner.{$base}/p3-syntax-ii">Zdrojové kódy - Zoznamy - Obsah</a></li>
          <li><a href="http://stettner.{$base}/p6-latex">Matfyzak bez latexu?</a></li>
        </ul>
				<div class="clear"></div>
	</div>

<!-- Kategorie -->	
<!--
	<div class="postFormSection">
	<p>
	<select name="topic1">
	  <option value="0">(Nezaradene)</option>
	  <xsl:for-each select="/postView/globalTopics/topic | /postView/topics/topic">
	  <option value="{@id}">
	    <xsl:if test="@id=/postView/post/topics/topic[1]/@id">
	      <xsl:attribute name="selected">selected</xsl:attribute>
	    </xsl:if>
	    <xsl:value-of select="name"/>
	    <xsl:if test="@scope='global'">
	    	(globalna kategoria) - prelozit
	    </xsl:if>
	  </option>
	  </xsl:for-each>
	</select>

	<select name="topic2">
	  <option value="0">(Nezaradene)</option>
	  <xsl:for-each select="/postView/globalTopics/topic">
	  <option value="{@id}">
	    <xsl:if test="@id=/postView/post/topics/topic[2]/@id">
	      <xsl:attribute name="selected">selected</xsl:attribute>
	    </xsl:if>
	    <xsl:value-of select="name"/>
	    <xsl:if test="@scope='global'">
	    	(globalna kategoria) - prelozit
	    </xsl:if>
	</option>
	</xsl:for-each>
	</select>

	</p>
	</div>//-->

		<div class="postFormSection">	
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Tags'"/>
        </xsl:call-template></h3>
				
				

				<div style="float: left; width: 48%;">
				<label for="tags"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'tagsAdd'"/>
        </xsl:call-template>: <xsl:call-template name="questionMark"/></label><br />
				<div style="margin-bottom: .3em">
					(<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'tagsAddHint'"/>
					</xsl:call-template>.)
				</div>
        <textarea id="tags" name="tags" class="tagBox">
          <xsl:for-each select="/postView/post/tags/tag">
            <xsl:value-of select="." />
            <xsl:if test="position() != last()">
              <xsl:text>, </xsl:text>
            </xsl:if>
          </xsl:for-each>
        </textarea>
				</div>				
				
				<div style="float: right; width: 48%;">
        <label for="tags"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'tagsUsed'"/>
        </xsl:call-template>: <xsl:call-template name="questionMark"/></label><br />							
				<div style="margin-bottom: .3em">
					(<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'tagsUsedHint'"/>
					</xsl:call-template>.)
				</div>
					<span id="activesort" title="name" />
					<span id="activeorder" title="desc" />
					<div class="tagArea" id="tagArea">
						<xsl:for-each select="/postView/userTags/tag">
							 <span style="font-size: {75+100 * @percent}%;" class="tagButton" title="{.}" onclick="addTag(this.innerHTML);"><xsl:value-of select="normalize-space(.)" /></span>
							 <xsl:text> </xsl:text>
						</xsl:for-each>	
				 </div>
					<!--
					<p id="sortList" style="padding-right: 10px;">
						<xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'Sort by'"/>
						</xsl:call-template>:
						<a href="javascript:void();" onclick="tagSort('name',this);"  class="asc"><xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'Alphabet'"/>
						</xsl:call-template></a>
						<a href="javascript:void();" onclick="tagSort('size',this);"><xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'Size'"/>
						</xsl:call-template></a>
						<a href="javascript:void();" onclick="tagSort('length',this);"><xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'Length'"/>
						</xsl:call-template></a>
						<script type="text/javascript">tagSort('name',this);</script>
					</p>
					// -->
        </div>
				<div class="clear"></div>
		</div>
      </fieldset>
			
	<div class="postFormSection">
      <div id="checkForm"></div>
			
			<label for="private" style="padding-right: 1em; text-align:left;">
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'showPost'"/></xsl:call-template>:
			</label>
			<div style="float: left; width: 17em;">
				<input type="radio" name="postStatus" value="notPrivate">
					<!-- ak bude php overovanie radiobuttonov tak podmienku "or not(/postView/post/@ID)" vyhodit -->
					<xsl:if test="(/postView/post/@status='published' and not(/postView/post/@private='yes')) or not(/postView/post/@ID)">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'postStatusNotPrivate'"/></xsl:call-template>
				<xsl:text> </xsl:text>
				<xsl:call-template name="questionMark"/>
				
				<br />
				<input type="radio" name="postStatus" value="private">
					<xsl:if test="/postView/post/@status='published' and /postView/post/@private='yes'">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'postStatusPrivate'"/></xsl:call-template>
				<xsl:text> </xsl:text>
				<xsl:call-template name="questionMark"/>
				
				<br />
				<input type="radio" name="postStatus" value="asDraft">
					<xsl:if test="/postView/post/@status='draft'">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'postStatusDraft'"/></xsl:call-template>
				<xsl:text> </xsl:text>
				<xsl:call-template name="questionMark"/>				
			</div>			



		
			<!-- Stary checkbox na "Zobraz iba na mojom blogu" -->
			<!--
			<input type="checkbox" name="private" value="1">
				<xsl:if test="/postView/post/@private='yes'">
					<xsl:attribute name="checked">checked</xsl:attribute>
				</xsl:if>
			</input>
			
			-->			
			<!-- Stary button -->
			<!--
			<input type="submit" name="status" id="status" class="submit" value="published" onclick="alert('jou');" />
			<input type="submit" name="status" class="submit" value="draft" />
			
			Save and publish
			Save as draft
			-->			
			<button type="submit" id="submitButton" class="submit" value="published"><xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'savePost'"/>
			</xsl:call-template></button>
			
			<button type="reset" name="reset" class="submit" value="reset" onclick="return confirm('Skutočne nastaviť predvolené hodnoty vo formulári?');">Reset</button>
			
      <script type="text/javascript">checkPost("");</script>
	</div>			
    </form>
    </div>
  </xsl:template>
	
	<!-- help otaznik -->
	<xsl:template name="questionMark">
		<a href="http://saiffer.{$base}/post-p12545" title="What does it mean?" target="_blank">
			<xsl:attribute name="title">
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'questionMark'"/>
				</xsl:call-template>
			</xsl:attribute>
			<img src="css/question_mark.gif" alt="question mark" class="question_mark" /></a>
	</xsl:template>
	
</xsl:stylesheet>
