<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output
             method="xml"
             version="1.0"
             encoding="utf-8"
             indent="yes"/>
  <xsl:param name="lang" />
  <xsl:template match="/">
    <xsl:variable name="language">
      <xsl:choose>
        <xsl:when test="$lang = 'en'">en</xsl:when>
        <xsl:when test="$lang = 'ensk'">ensk</xsl:when>
        <xsl:otherwise>sk</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <rss version="2.0">
    <xsl:choose>
    <xsl:when test="user/info/nick">
      <channel>
        <title><xsl:value-of select="user/blog/title" /></title>
        <link>http://<xsl:value-of select="user/info/nick" />.blog.matfyz.sk/</link>
        <description>Personal blog.</description>
        <language><xsl:value-of select="$language" /></language>
        <xsl:for-each select="user/blog/post[contains($language, @lang)]">
          <item>
              <pubDate><xsl:value-of select="date" /></pubDate>
              <title><xsl:value-of select="title" /></title>
              <description><xsl:value-of select="subtitle" /></description>
              <link>http://<xsl:value-of select="/user/info/nick" />.blog.matfyz.sk/<xsl:value-of select="@ID" /></link>
          </item>
        </xsl:for-each>
      </channel>
    </xsl:when>
    <xsl:otherwise>
      <channel>
        <title>Matfyz Blogportal RSS</title>
        <link>http://blog.matfyz.sk/</link>
        <description>Blogs for everyone, power to the people!</description>
        <language><xsl:value-of select="$language" /></language>
        <xsl:for-each select="document('../cron/cache/newPosts.xml')/postList/posts[@lang = $language]/newPosts/post">
          <item>
              <pubDate><xsl:value-of select="date" /></pubDate>
              <title><xsl:value-of select="user/realName" />: <xsl:value-of select="title" /></title>
              <description><xsl:value-of select="substring(content,1,250)" /></description>
              <link>http://<xsl:value-of select="user/nick" />.blog.matfyz.sk/<xsl:value-of select="@ID" /></link>
          </item>
        </xsl:for-each>
      </channel>
    </xsl:otherwise>
    </xsl:choose>
    </rss>
  </xsl:template>

</xsl:stylesheet>