<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:variable name="title" ><xsl:call-template name="getString">
    <xsl:with-param name="stringName" select="'Settings'"/>
  </xsl:call-template></xsl:variable>
  <xsl:variable name="blogTitle" select="/settingsCategories/title" />
  <xsl:variable name="nick" select="/settingsCategories/nick" />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  <xsl:variable name="changeButton"><xsl:call-template name="getStringDefault">
    <xsl:with-param name="stringName" select="'Change'"/>
  </xsl:call-template></xsl:variable>
  
  <xsl:template match="/*">
      <fieldset>
        <h3>Globálne kategórie</h3>
	<form action="{$blogURL}/index.php?type=changeCategories" method="post" class="frm">
	<xsl:for-each select="/settingsCategories/globalCategories/topic">
	<xsl:variable name="id" select="@id"/>
	<label for="{$id}">
	<input type="checkbox" name="topics[{$id}]" id="{$id}">
	<xsl:if test="/settingsCategories/userCategories/topic[@id=$id]">
		<xsl:attribute name="checked">checked</xsl:attribute>
	</xsl:if>
	</input>
	<xsl:value-of select="name"/></label><br/>
	</xsl:for-each>
	<input type="hidden" name="action" value="setVisibility"/>
	<input type="submit" name="submit" id="submit" class="submit" value="{$changeButton}" />
        <input type="reset" name="submit" id="submit" class="submit" value="Reset" />
	</form>
	
	<h3>Privátne kategórie</h3>
	<xsl:for-each select="/settingsCategories/userCategories/topic[not(@scope='global')]">
	<form action="{$blogURL}/index.php?type=changeCategories" method="post" class="frm">
	<xsl:value-of select="name"/>
	<input type="hidden" name="action" value="delete"/>
	<input type="hidden" name="topic1" value="{@id}"/>
	<input type="submit" name="submit" value="Zmazať"/>
	</form><br/>
	</xsl:for-each>
	<form action="{$blogURL}/index.php?type=changeCategories" method="post" class="frm">
	<input type="input" name="name"/>
	<input type="hidden" name="action" value="add"/>
	<input type="submit" name="submit" value="Pridaj"/>
	</form>
      </fieldset>
  </xsl:template>
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
</xsl:stylesheet>
