<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:variable name="title" >
		<xsl:call-template name="getString">
			<xsl:with-param name="stringName" select="'uploadFiles'"/>
		</xsl:call-template>
	</xsl:variable>
  <xsl:variable name="blogTitle" select="uploadForm/title" />
  <xsl:variable name="nick" select="uploadForm/nick" />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  
  <xsl:template match="/*">
    <form  action="{$blogURL}/index.php?type=uploadFile" method="post" enctype="multipart/form-data" class="frm">
      <label for="file">
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'file'"/>
				</xsl:call-template>:</label>
      <input type="file" name="file" /><br /><br />
      <label for="file">
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'saveAs'"/>
				</xsl:call-template>:</label>
      <input type="input" name="filename" /><br /><br />
      <input type="submit" name="submit" id="submit" class="submit" value="Upload">
				<xsl:attribute name="value">
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'upload'"/>
					</xsl:call-template>
				</xsl:attribute>
			</input>
			<br />
    </form>
    <h3>
			<xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'yourFiles'"/>
			</xsl:call-template>
		</h3>
    <table cellspacing="1" cellpadding="0" class="table">
      <thead>
        <tr>
          <th>
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'fileName'"/>
					</xsl:call-template>
					</th>
          <th>
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'fileSize'"/>
					</xsl:call-template>
					</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select ="/uploadForm/userFiles/file">
          <tr>
            <td><a href="{$blogURL}/{.}"><xsl:value-of select="." /></a></td>
            <td><xsl:value-of select="./@size" /></td>
          </tr>
        </xsl:for-each>
      </tbody>
      <tfooter>
        <tr>
          <td><xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'sum'"/>
					</xsl:call-template>:</td>
          <td><xsl:value-of select="/uploadForm/userFiles/@size" /></td>
        </tr>
      </tfooter>
    </table>
    <hr />
                                <br />
  </xsl:template>
</xsl:stylesheet>