<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:my="http://blog.matfyz.sk/admin"
    xmlns:func="http://exslt.org/functions"
    extension-element-prefixes="my func">

  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:param name="base"/>
  <xsl:param name="page"/>
  <xsl:param name="sstr"/>
  <xsl:param name="tag"/>
  <xsl:variable name="header">
    <link rel="stylesheet" href="http://{$base}/admin/css/articles.css" type="text/css" media="screen" />
  </xsl:variable>
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  
  <xsl:template match="/*">
    <form action="?page={$page}" method="get" name="search">
    	text: <input type="text" name="sstr" value="{$sstr}" />
    	tag: <input type="text" name="tag" value="{$tag}" />
	<input type="submit" value="filter"/>
    </form>
    <table cellspacing="1" cellpadding="0" class="table">
      <thead>
        <tr>
          <th>Autor</th>
          <th>date</th>
          <th>Jazyk</th>
          <th>Názov clanku</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select ="newPosts/post">
          <tr>
            <td><a href="http://{user/nick}.{$base}/"><xsl:value-of select="user/nick" /></a></td>
            <td><xsl:value-of select="date" /></td>
            <td><xsl:value-of select="@lang" /></td>
            <td><a href="http://{user/nick}.{$base}/{@ID}-{my:urlpostfix(title)}"><xsl:value-of select="title" /></a></td>
          </tr>
        </xsl:for-each>
      </tbody>
      <tfooter>
        <tr>
          <td class="paging" colspan="4">
	  <xsl:call-template name="paging" />,
	  <xsl:value-of select="/portalView/newPosts/@start"/> -
	  <xsl:value-of select="/portalView/newPosts/@end"/> z
	  <xsl:value-of select="/portalView/newPosts/@last"/>
	  </td>
        </tr>
      </tfooter>
    </table>
  </xsl:template>

<func:function name="my:urlpostfix">
  <xsl:param name="what" />
  <xsl:variable name="up" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:variable name="lo" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="space" select="'_ ?.!:=-()'"/>
  <xsl:variable name="other" select="'          '"/>
  <xsl:variable name="dia" select="'áéíóuýčďľĺňôöřšťž'"/>
  <xsl:variable name="nor" select="'aeiouycdllnoorstz'"/>
  <xsl:variable name="diab" select="'ÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ'"/>
  <xsl:variable name="norb" select="'aeiouycdllnorstz'"/>
  <func:result>
    <xsl:value-of select="
    translate(
      normalize-space(
        translate(
          translate(
       	   translate(
          	  translate(
                $what, $up, $lo
          	  ), $space, $other
        	   ), $dia, $nor
          ), $diab, $norb
    	  )
      ), ' ', '-'
    )" />
  </func:result>
</func:function>

<xsl:template name="paging">

<xsl:variable name="pagepos">
	<xsl:choose>
	<xsl:when test="$page >= 0"><xsl:value-of select="$page" /></xsl:when>
	<xsl:otherwise>0</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="prev">
	<xsl:choose>
	<xsl:when test="$pagepos = 0">0</xsl:when>
	<xsl:otherwise><xsl:value-of select="$pagepos -1" /></xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:if test="$pagepos > 0 or /portalView/newPosts/@end &lt; /portalView/newPosts/@last">
	<xsl:if test="$pagepos > 0">
	<a href="http://{$base}/admin/articles/?page={$prev}">Spat</a>
	<xsl:text> </xsl:text>
	</xsl:if>
	<xsl:if test="/portalView/newPosts/@end &lt; /portalView/newPosts/@last">
	<a href="http://{$base}/admin/articles/?page={($pagepos +1)}">Dalej</a>
	</xsl:if>
</xsl:if>
</xsl:template>

</xsl:stylesheet>
