<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:my="http://blog.matfyz.sk/admin"
    xmlns:func="http://exslt.org/functions"
    extension-element-prefixes="my func">

  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:param name="base"/>
  <xsl:param name="page"/>
  <xsl:param name="sstr"/>
  <xsl:variable name="header">
    <link rel="stylesheet" href="http://{$base}/admin/css/articles.css" type="text/css" media="screen" />
  </xsl:variable>
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  
  <xsl:template match="/*">
    <form action="?page={$page}" method="get" name="search">
    	<input type="text" name="sstr" value="{$sstr}" />
	<input type="submit" value="hladaj"/>
    </form>
    <form action="?action=sedelete&amp;page={$page}" method="post" name="delForm">
    <script language="JavaScript1.2">
    <xsl:comment>
	function checkAll(value){
		for (i=0; i &lt; document.delForm.length-1; i++){
			document.delForm[i].checked = value;
		}
	}
    </xsl:comment>
    </script>
    <table cellspacing="1" cellpadding="0" class="table">
      <thead>
        <tr>
          <th>Autor</th>
          <th>datum</th>
          <th>Titulok prispevku</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select ="comments/comment">
          <tr>
            <td>
	        <input type="checkbox" name="delete[{user/@ID}][{@ID}]"/>
	    	<xsl:choose>
		<xsl:when test="author/@guest">
			<xsl:value-of select="author" />
		</xsl:when>
		<xsl:otherwise>
			<a href="http://{author/nick}.{$base}/settings"><xsl:value-of select="author/nick" /></a>
		</xsl:otherwise>
		</xsl:choose>
	    </td>
            <td><xsl:value-of select="date" /></td>
            <td><a href="http://{user/nick}.{$base}/{post/@ID}-{my:urlpostfix(post/title)}">link: <xsl:value-of select="title" /></a></td>
          </tr>
        </xsl:for-each>
      </tbody>
      <tfooter>
        <tr class="paging">
	  <td>*: 
	    <a href="javascript:checkAll(true);">+</a> / 
	    <a href="javascript:checkAll(false);">-</a> =&gt;
	    <input type="submit" name="submit" value="Zmazat"/>
	  </td>
          <td colspan="2">
	  <xsl:call-template name="paging" />,
	  <xsl:value-of select="/portalView/comments/@start"/> -
	  <xsl:value-of select="/portalView/comments/@end"/> z
	  <xsl:value-of select="/portalView/comments/@last"/>
	  </td>
        </tr>
      </tfooter>
    </table>
    </form>
  </xsl:template>

<func:function name="my:urlpostfix">
  <xsl:param name="what" />
  <xsl:variable name="up" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:variable name="lo" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="space" select="'_ ?.!:=-()'"/>
  <xsl:variable name="other" select="'          '"/>
  <xsl:variable name="dia" select="'áéíóuýčďľĺňôöřšťž'"/>
  <xsl:variable name="nor" select="'aeiouycdllnoorstz'"/>
  <xsl:variable name="diab" select="'ÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ'"/>
  <xsl:variable name="norb" select="'aeiouycdllnorstz'"/>
  <func:result>
    <xsl:value-of select="
    translate(
      normalize-space(
        translate(
          translate(
       	   translate(
          	  translate(
                $what, $up, $lo
          	  ), $space, $other
        	   ), $dia, $nor
          ), $diab, $norb
    	  )
      ), ' ', '-'
    )" />
  </func:result>
</func:function>

<xsl:template name="paging">

<xsl:variable name="pagepos">
	<xsl:choose>
	<xsl:when test="$page >= 0"><xsl:value-of select="$page" /></xsl:when>
	<xsl:otherwise>0</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="prev">
	<xsl:choose>
	<xsl:when test="$pagepos = 0">0</xsl:when>
	<xsl:otherwise><xsl:value-of select="$pagepos -1" /></xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:if test="$pagepos > 0 or /portalView/comments/@end &lt; /portalView/comments/@last">
	<xsl:if test="$pagepos > 0">
	<a href="http://{$base}/admin/comments/?page={$prev}">Spat</a>
	<xsl:text> </xsl:text>
	</xsl:if>
	<xsl:if test="/portalView/comments/@end &lt; /portalView/comments/@last">
	<a href="http://{$base}/admin/comments/?page={($pagepos +1)}">Dalej</a>
	</xsl:if>
</xsl:if>
</xsl:template>

</xsl:stylesheet>
