<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:my="http://blog.matfyz.sk/admin"
    xmlns:func="http://exslt.org/functions"
    extension-element-prefixes="my func">

  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:param name="base"/>
  <xsl:param name="page"/>
  <xsl:param name="sstr"/>
  <xsl:param name="tag"/>
  <xsl:variable name="header">
    <link rel="stylesheet" href="http://{$base}/admin/css/tags.css" type="text/css" media="screen" />
  </xsl:variable>
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  
  <xsl:template match="/*">
  
    <p>
    <xsl:if test="newTags/curTag/tag/@canonical != ''">
      <span class="tag"><xsl:value-of select="newTags/curTag/tag/@canonical" /></span>
      [<xsl:value-of select="newTags/curTag/tag/@lang" />]<br />
      <form action="?page={$page}" method="post" name="delForm">
      <input type="hidden" name="delete[{newTags/curTag/tag/@id}]" />
      <input type="submit" value="zmaz" />
      </form>
      popis:<br />
      <xsl:value-of select="newTags/curTag/tag/desctiption" /><br />
      <form action="?page={$page}" method="post" name="altForm">
      alternativy:<br />
      <textarea name="alts">
      <xsl:for-each select="newTags/curTag/tag/alt">
        <xsl:value-of select="text()" />
        <xsl:if test="position() != last()">
          <xsl:text>, </xsl:text>
        </xsl:if>				 
      </xsl:for-each>
      </textarea><br />
      <input type="hidden" name="altEdit" />
      <input type="hidden" name="tagID" value="{newTags/curTag/tag/@id}" />
      <input type="submit" value="uprav" />
      </form>
    </xsl:if>
    </p>
		
		
    <table cellspacing="1" cellpadding="0" class="table">
      <thead>
        <tr>
          <th>Tag</th>
	  <th>Jazyk</th>
	  <th>Popis</th>
          <th>Zahrna (alternativy)</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select ="newTags/tag">
	<xsl:sort lang="@lang" select="@lang" order="ascending"/>
	<xsl:sort lang="@lang" select="@canonical" order="ascending"/>
	<xsl:sort select="@id" order="descending" />
          <tr>
            <td><a href="?page={$page}&amp;tag={@id}"><xsl:value-of select="@canonical" /></a></td>
            <td><xsl:value-of select="@lang" /></td>
            <td><xsl:value-of select="description" /></td>
            <td><xsl:for-each select="alt"><xsl:value-of select="text()" />
	      <xsl:if test="position() != last()">
	        <xsl:text>, </xsl:text>
	      </xsl:if></xsl:for-each>
	    </td>
          </tr>
        </xsl:for-each>
      </tbody>
      <tfooter>
        <tr>
          <td class="paging" colspan="4">
	  <xsl:call-template name="paging" />,
	  <xsl:value-of select="/portalView/newTags/@start"/> -
	  <xsl:value-of select="/portalView/newTags/@end"/> z
	  <xsl:value-of select="/portalView/newTags/@last"/>
	  </td>
        </tr>
      </tfooter>
    </table>
  </xsl:template>

<func:function name="my:urlpostfix">
  <xsl:param name="what" />
  <xsl:variable name="up" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:variable name="lo" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="space" select="'_ ?.!:=-()'"/>
  <xsl:variable name="other" select="'          '"/>
  <xsl:variable name="dia" select="'áéíóuýčďľĺňôöřšťž'"/>
  <xsl:variable name="nor" select="'aeiouycdllnoorstz'"/>
  <xsl:variable name="diab" select="'ÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ'"/>
  <xsl:variable name="norb" select="'aeiouycdllnorstz'"/>
  <func:result>
    <xsl:value-of select="
    translate(
      normalize-space(
        translate(
          translate(
       	   translate(
          	  translate(
                $what, $up, $lo
          	  ), $space, $other
        	   ), $dia, $nor
          ), $diab, $norb
    	  )
      ), ' ', '-'
    )" />
  </func:result>
</func:function>

<xsl:template name="paging">

<xsl:variable name="pagepos">
	<xsl:choose>
	<xsl:when test="$page >= 0"><xsl:value-of select="$page" /></xsl:when>
	<xsl:otherwise>0</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="prev">
	<xsl:choose>
	<xsl:when test="$pagepos = 0">0</xsl:when>
	<xsl:otherwise><xsl:value-of select="$pagepos -1" /></xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:if test="$pagepos > 0 or /portalView/newTags/@end &lt; /portalView/newTags/@last">
	<xsl:if test="$pagepos > 0">
	<a href="http://{$base}/admin/tags/?page={$prev}">Spat</a>
	<xsl:text> </xsl:text>
	</xsl:if>
	<xsl:if test="/portalView/newTags/@end &lt; /portalView/newTags/@last">
	<a href="http://{$base}/admin/tags/?page={($pagepos +1)}">Dalej</a>
	</xsl:if>
</xsl:if>
</xsl:template>

</xsl:stylesheet>
