<?php
/************************************************************************
BlogReader.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
This file was generated on Po júl 16 2007 at 10:21:08
The original location of this file is /web/diplomovka/generated/BlogReader.php
**************************************************************************/

require_once 'DataSource.php';
require_once 'User.php';


/**
 * class BlogReader
 */
class BlogReader extends DataSource
{
 
  /**
   * @access private
   */
  private $userID;
  private $user;

  /**
   * @access private
   */
  private $title;
  private $xml="<blank />";
  private $params;

  /**
   * @param int userID 
   * @return 
   * @access public
   */
  public function __construct($params)
  {
    $this->params = $params;
    $this->userID = $params['userID'];
    $this->user = new User($this->userID);
    
	    		/*    
    			if ($this->user->getUserType()=="student" && $_SESSION['session']->getUser() && in_array($_SESSION['session']->getUser()->getUserType(),array('student','teacher','administrator')) && ($params['type']!='uploadForm' && $params['type']!='settingsForm' ))
    			{
	      		$this->getBlog();
      			return;
    			}    
	    		*/
    		
    if (in_array($_SESSION['session']->getState(), array('temporaryStudentView','studentUserView')) && ($params['type']!='uploadForm' && $params['type']!='settingsForm'))
    {
      $this->getBlog();
      return; 
    }	
    
    switch($params['type'])
    {
      case "userPosts":
      case "blogView":
      {
        $this->getBlog($params['tag'], $params['topic']);
        break;
      }
      case "rss":
      {
        $this->getBlog();break;
      }
      case "postView":
      {
        $this->getPost($params['postID']);
        break;
      }
      case "editPostForm":{$this->getPost($params['postID']);break;}
      case "postForm":
      {
        $postID = array_key_exists("postID",$params) ? $params['postID'] : 0;
        $this->getPost($postID);
        break;
      }
      case "commentForm":
      {
        if (isset($params['commentID'])) $this->getComment($params['postID'],$params['commentID']);
        else $this->getPost($params['postID']);
        break;
      }
      case "settingsForm":
      {
        $this->getUserSettings();
        break;
      }
      case "postForm":
      {
        //$this->getPost($params['postID']);
        break;
      }
      case "uploadForm":
      {
        $this->getUserFiles();
        break;
      }
      case "showStudentXSL":
      {
        $this->getStudentXSL();
        break;
      }
      
      default: 
      {
        $this->getBlog($params['tag'], $params['topic']);
        break;	
      }
    }
  } // end of member function __construct

	/**
    * Vrati pocet postov pre dany tag
		* @param string tag
    * @access public
    * @return int
    */
  public function getPostsCount($tag = "")
  {
		$count = 0;
		formatText($tag, false);
		if($tag!="") {
			$xquery = '
			return count(distinct-values(
				for $alts in collection("weblog")/tags/tag[@canonical="'. $tag .'"]/alt,
					$ID in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[tags/tag = $alts]/@ID
				return $ID
				))
			';
			$count = $GLOBALS['system']->getDB()->fetchNode($xquery);
		} else {
			$xquery = 'count(collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post)';
			$count = $GLOBALS['system']->getDB()->fetchNode($xquery);
		}
		return $count;
  }

	/**
    * Genereju data pre tag cloud, s poctami pre jedotlive tagy
    * @access public
    * @return xml
    */
  public function getTagCloud()
  {
  		$browser = new TagBrowser($this->params);
  		return($browser->getUserTags($this->userID));
  }

	/**
    * Vrati posty podla zadaneho tagu
		* @param string tag
    * @access public
    * @return xml
    */
  public function getFilteredPosts($tag, $topic)
  {
	  	$tag = formatText($tag, false);
		$topicfilter = "";
		if ($topic=="0") $topicfilter = '[count(topics/topic)=0]';
		elseif ($topic!="") $topicfilter = '[topics/topic[@id="'.formatText($topic, false).'"]]';
		if($tag=="") {
			$xquery='collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post'.$topicfilter;
			$posts = $GLOBALS['system']->getDB()->fetchNode($xquery);
		} else {
			
			$xquery = '
			let $IDS := distinct-values(for $alts in collection("weblog")/tags/tag[@canonical="'. $tag .'"]/alt,
					$ID in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[tags/tag = $alts]/@ID
				return $ID
				)
			return collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[@ID=$IDS]
			';
			$posts = $GLOBALS['system']->getDB()->fetchNode($xquery);
		}
		return $posts;
  }

  /**
	 * @param string tag
   * @param int start 
   * @param int offset 
   * @param int filter 
   * @return blog xml
   * @access public
   */
  public function getBlog( $tag="", $topic="", $start=0,  $offset=10 )
  {
    $start = intval($start);
    $offset = intval($offset);

	$posts = $this->getFilteredPosts($tag, $topic);
		
	//
	if ($this->user->getTemplate() == 'studentTemplate') {$showStylesheetPortlet = 'true';} else {$showStylesheetPortlet = 'false';}
	
   	$xquery='let $user := collection("weblog")/user[@ID="'.formatText($this->userID, false).'"],
		$globalTopics := collection("weblog")/topics/*
	    return
	      <user>
	      	{$user/@ID}
					<blog>{$user/blog/@*}
	      		{$user/blog/*[name()!="post"]}
						<post/>
					</blog>
	      	{$user/info}
          <cloud lang="'.formatText($_SESSION['session']->getLang()).'">'.$this->getTagCloud().'</cloud>
	      	<stylesheetPortlet>'.$showStylesheetPortlet.'</stylesheetPortlet>
		<userTopics>{$user/blog/topics/*}</userTopics>
		<globalTopics>{$globalTopics}</globalTopics>
	      </user>';

   $this->xml = $GLOBALS['system']->getDB()->fetchNode($xquery);
   $this->xml = str_replace("<post/>",$posts,$this->xml);	//skaredy hack, ked bol $posts v xquery, tak tam boli {{}} interpretovane co je bug a diera
   //dump($this->xml);
   $xml = new SimpleXMLElement($this->xml);
   $neighbours = $xml->xpath('/user/info/ranks/neighbours/*');

 //  dump($neighbours);
  /* if (is_array($neighbours))
   foreach ($neighbours as $user)
   {
     //dump($user['userID']);
     $xquery='collection("weblog")/user[@ID="'.$user['userID'].'"]/info';
     $neighbour = $GLOBALS['system']->getDB()->fetchNode($xquery);
   }*/
   //dump($xml);
    //dumpxml($this->xml);
  } // end of member function getBlog

  /**
   * @param int postID 
   * @return 
   * @access public
   */
  public function getPost($postID)
  {
    $xquery = 'for $i in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[@ID!="'.formatText($postID, false).'"]
                order by $i/date descending
                return
                <post>
                  {$i/@status}
                  {$i/@private}
                  {$i/@ID}
                  {$i/title}
                  {$i/date}
                </post>';
    $postInfo = $GLOBALS['system']->getDB()->fetchNode($xquery);

		// vypocet 'tagcloudu' pre posting:
		$xquery = '
		let $tags:=
			for $tag in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[@ID="'.formatText($postID, false).'"]/tags/tag,
				$canonical in collection("weblog")/tags/tag[alt=$tag]
				return
					<tag>{$tag}</tag>
		for $tag in distinct-values($tags)
			return <tag>{$tag}</tag>
		';
		$tags = $GLOBALS['system']->getDB()->fetchNode($xquery);
		// end tagcloud vypocet

		$browser = new TagBrowser($this->params);
		if ($_SESSION['session']->isLogged()) {
				$userTags = $browser->getUserTags($_SESSION['session']->getUser()->getID());	 //nefunguje postView pre neprihlaseneho cloveka pretoze nema session - preto ta podmienka o riadok vyssie
		} else {				
				$userTags = $browser->getUserTags($this->userID);
		}
		
		
		
    $xquery ='let $i := collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[@ID="'.formatText($postID, false).'"] | collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/title | collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/info,
              $user :=collection("weblog")/user[@ID="'.formatText($this->userID, false).'"],
	      			$globalTopics := collection("weblog")/topics/*,
	      			$topics := collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/topics/*
              return
              <postView>
                {$user/blog/@css}
                {$user[@ID="'.formatText($this->userID).'"]/@type}
                {$user[@ID="'.formatText($this->userID).'"]/blog/title}
                {$user[@ID="'.formatText($this->userID).'"]/info/*}
                <postID>'.formatText($postID).'</postID>
                <userID>'.formatText($this->userID).'</userID>
                {$i}
								<tags>'.$tags.'</tags>
								<userTags>'.$userTags.'</userTags>
	      				<globalTopics>{$globalTopics}</globalTopics>
					<userTopics>{$topics}</userTopics>
                <otherPosts>'.$postInfo.'</otherPosts>
                './*$GLOBALS['system']->getSystemWideTags().*/'
								<systemTags>'.$this->getTagCloud().'</systemTags>
              </postView>';
    //dumpxml($xquery);
		//dumpxml($this->getTagCloud());
    
    $this->xml = $GLOBALS['system']->getDB()->fetchNode($xquery);
    //dumpxml($this->xml);
  } // end of member function getPost

  /**
   *
   * @return 
   * @access public
   */
  public function getAllComments() {
    
  } // end of member function getAllComments

  /**
   * @return 
   * @access public
   */
  public function getComment($postID, $commentID)
  {
    $xquery = 'for $i in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[@ID="'.formatText($postID, false).'"]//comment[@ID="'.formatText($commentID, false).'"]
               let $post := $i/ancestor::post,
               $user := collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]
                return
                <commentForm>
                  {$user/blog/@css}
                  {$user/blog/title}
                  <userID>'.formatText($this->userID).'</userID>
                  {$user/info/nick}
                  <postID>'.formatText($postID).'</postID>
                  {$i}
                  {$post}
                </commentForm>';
    $this->xml = $GLOBALS['system']->getDB()->fetchNode($xquery);
   // dumpxml($this->xml);
    
    
  } // end of member function getComment
  
 

  /**
   * @return 
   * @access public
   */
   
  public function getUserSettings()
  {    	     
    if ($this->user->getTemplate() == 'studentTemplate') {$checked = 'true';} else {$checked = 'false';}      
    $xquery = '
        let $user:=collection("weblog")/user[@ID="'.$this->userID.'"]
        return
        <settingsForm>
    {$user/blog/@css}    
    <userID type="{$user/@type}">'.$this->userID.'</userID>
    <template checked="'.$checked.'">'.$this->user->whenWasStudent().'</template>
   {$user/info/*}     
    {$user/blog/title} 
    </settingsForm>';
    $this->xml = $GLOBALS['system']->getDB()->fetchNode($xquery);    
    //dumpxml($this->xml); 
  } // end of member function getUserSettings 
  
  
  /**
   * @return 
   * @access public
   */
  public function getStudentXSL()
  {
		echo 'xxx';
    $this->xml = readfile('files/' . $this->params['user'] . '/blog.xsl');;
    //dumpxml($this->xml);
  } // end of member function getStudentXSL

  /**
   * @return 
   * @access public
   */
  public function getData()
  {
    $data = new DOMDocument();
    if (!empty($this->xml))
      $data->loadXML($this->xml);
    $doc = $data->documentElement;
    
    // odstranenie hesla z vypisu
    if ($doc) 
    {
      $passHash = $doc->getElementsByTagName('account');
      if ($passHash) $passHash = $passHash->item(0);
      if ($passHash) $passHash->parentNode->removeChild($passHash);
      if ($this->user->getUserType()=="student" && ($this->params['type']!='uploadForm' && $this->params['type']!='settingsForm' )) 
      {
        $email = $doc->getElementsByTagName('email');
        if ($email) $email= $email->item(0);
        if ($email) $email->parentNode->removeChild($email);
      }
    }
   
    return $data;
    
  } // end of member function getData

  /**
   * @return 
   * @access public
   */
  public function getUserData()
  {
    
  } // end of member function getUserData
  
   /**
   * @return 
   * @access public
   */
  
  
  
  public function getUserFiles($onlyFilesNode=false)
  {
    $sum=0;
    $dir = "./files/".$this->user->getNick();
    $files = @scandir($dir);
    $filesXML="";
    unset($files[0]);unset($files[1]);
    if (is_array($files))
      foreach($files as $file)
      {
        $filesize = filesize($dir.'/'.$file);
        $sum +=$filesize;
        $filesize = size_readable($filesize);
        $filesXML .="<file size=\"{$filesize}\">".formatText($file)."</file>";
      }
    $filesXML = "<userFiles size=\"".size_readable($sum)."\">".$filesXML."</userFiles>"; 
    if ($onlyFilesNode) return $filesXML;
    $xquery = '
        let $user:=collection("weblog")/user[@ID="'.formatText($this->userID).'"]
        return
    <uploadForm >
      {$user/blog/@css}
      <userID>'.formatText($this->userID).'</userID>
      {$user/info/*}
      {$user/blog/title}
      '.$filesXML.'
    </uploadForm>';
    $this->xml = $GLOBALS['system']->getDB()->fetchNode($xquery);
    
  } // end of member function getUserData
      




} // end of BlogReader
?>