<?php
/************************************************************************
  			BlogWriter.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
This file was generated on Po júl 16 2007 at 10:21:08
The original location of this file is /web/diplomovka/generated/BlogWriter.php
**************************************************************************/



/**
 * class BlogWriter
 * BlogEditor modifies data in Blog. Creates new posts and comments.
 */
require_once 'Topics.php';

class BlogWriter
{

  /**
   * @access private
   */
  private $xml="<blank />";

   /*** Attributes: ***/
  public $userID;

  /**
   *
   * @param int userID 
   * @return 
   * @access public
   */
  public function __construct($params)
  {
    $this->userID = $params['userID'];
    $postID = array_key_exists("postID",$_POST) ? $_POST['postID'] : 0;
    $commentID = array_key_exists("commentID",$_POST) ? $_POST['commentID'] : 0;
    $title = array_key_exists("title",$_POST) ? $_POST['title'] : "";
    $comment = array_key_exists("comment",$_POST) ? $_POST['comment'] : "";
    $content = array_key_exists("postContent",$_POST) ? $_POST['postContent'] : "";
    $tags = array_key_exists("tags",$_POST) ? explode(",",$_POST['tags']) : "";
    $description = array_key_exists("description",$_POST) ? $_POST['description'] : "";
    $subtitle = array_key_exists("subtitle",$_POST) ? $_POST['subtitle'] : "";
    $language = array_key_exists("language",$_POST) ? $_POST['language'] : "";
    $status = array_key_exists("status",$_POST) ? $_POST['status'] : "";
    $private = array_key_exists("private",$_POST) ? (bool)$_POST['private'] : false;
		
		/* Zmena $statuso a $private kvoli radiobuttonom v newPost/editPost */		
		$postStatus = array_key_exists("postStatus",$_POST) ? $_POST['postStatus'] : "";
		if ($postStatus == 'notPrivate') {
			$status = 'published';
			$private = false;
		}	elseif ($postStatus == 'private') {
			$status = 'published';
			$private = true;
		}	elseif ($postStatus == 'asDraft') {
			$status = 'draft';
			$private = false;		
		}
		
    if (array_key_exists('type',$params))
      switch($params['type'])
      {
        case "addComment":
        {
          $this->newComment($postID, $commentID, $title, $comment);
          break;
        }
        case "addPost":
        {
          $params['postID']=$this->newPost($title, $content, $tags, $description, $subtitle, $language, $status, $private);
	  $topics=new Topics($params);
          break;
        }
        case "editPost":
        {
          $this->editPost($postID, $title, $content, $tags, $description, $subtitle, $language, $status, $private);
	  $params['postID']=$postID;
	  $topics=new Topics($params);
          break;
        }
        case "deleteComment":
        {
          $this->deleteComment($postID, $commentID);
          break;
        }
        case "deletePost":
        {
          $this->deletePost($postID);
         break;
        }
        case "changeSettings":
        {
          if (isset($_POST['blogTitle'])) $this->setTitle($_POST['blogTitle']);
          break;
        }
        case "changePostStatus":
        {
          $this->setStatus($postID, $_POST['status']);
					break;
        }
				case "makeTop":
				{
					$this->makeTop($postID);
					break;
				}
				case "makeTopOut":
				{
					$this->makeTopOut($postID);
					break;
				}
      }
      
  } // end of member function __construct

  public function makeTop($postID){
  	//zaradi post medzi Top posty kvoli titulke
     $xquery = 'update delete collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/dateTop';
     $GLOBALS['system']->getDB()->fetchNode($xquery);
     $xquery = 'update delete collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/dateTopOut';
     $GLOBALS['system']->getDB()->fetchNode($xquery);
     
     $xquery='update insert
          <dateTop timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</dateTop>
	  into collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]';
     $GLOBALS['system']->getDB()->fetchNode($xquery);

     $xquery='let $lang:=collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/@lang
     		return data(
			subsequence(
				for $i in collection("weblog")/user/blog/post[dateTop][not(dateTopOut)][@lang=$lang]
		     		order by $i/date/@timestamp descending
				return $i/@ID,6,1
			)
		)';
     $post=$GLOBALS['system']->getDB()->fetchNode($xquery);

     if ($post){
     	$this->makeTopOut($post);
     }
  }

  public function makeTopOut($postID){
     //post zostane TOP ale uz bude vyradeny
     $xquery = 'update delete collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/dateTopOut';
     $GLOBALS['system']->getDB()->fetchNode($xquery);

     $xquery='update insert
	     <dateTopOut timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</dateTopOut>
	     into collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"][dateTop]';
     $GLOBALS['system']->getDB()->fetchNode($xquery);
  }

 /**
   *
   * @return 
   * @access public
   */
  public function newPost($title, $content, $tags, $description="", $subtitle="", $language="sk", $status='published', $private=true)
  {
	
		//ak nie su vyplnene nadpis a zvoleny stav prispevku (published+na titulke/published+private/draft) tak sa vrat na formular a vypis upozornenie
		/*
		if ($title == "" or $postStatus == NULL) {
			if ($title == '') {$noTitle = 1;} else {$noTitle = 0;}
			if ($postStatus == NULL) {$noStatus = 1;} else {$noStatus = 0;}
			$parametre = array("noTitle"=>$noTitle, "noStatus"=>$noStatus);
			redirect("http://".$_SESSION['session']->getUser()->getNick().".".BASE."/newpost", $parametre);
		}
		*/
    //platne statusy su len published a draft
    if ($status!='published' && $status!='draft') return;
   
		
	 
    $max = $GLOBALS['system']->getMaxID();
	
	//pridanie novych tagov
	 $tb = new TagBrowser("");
     if (is_array($tags))
       foreach ($tags as $tag){$tb->addTag($tag,$language);}
    
    $tagsXML = "";
    if (is_array($tags))
      foreach ($tags as $tag)
      {
        $tagsXML .= '<tag>'.formatText(trim($tag)).'</tag>';
      }
    
    if ($private==true) $private="yes";
    else $private="no";

    $query = 'update insert
        <post ID="p'.($max+1).'" accessCount="0" lang="'.formatText($language).'" status="'.formatText($status).'" private="'.formatText($private).'">
          <title>'.formatText($title).'</title>
          <subtitle>'.formatText($subtitle).'</subtitle>
          <content> '.formatText($content).' </content>
          <tags>'.$tagsXML.'</tags>
          <date timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</date>
          <comments/>
	  <topics/>
        </post>
        into collection("weblog")/user[@ID="'.$this->userID.'"]/blog';
    if ($GLOBALS['system']->getDB()->fetchNode($query)) return "p".($max+1);
  } // end of member function newPost

  /**
   *
   * @return 
   * @access public
   */
  public function newComment($postID, $commentID, $title, $text)
  {
    $guest = array_key_exists("guest",$_POST) ? $_POST['guest'] : "Anonym";
    $max = $GLOBALS['system']->getMaxID();
    //dumpxml($query);
    if ($_SESSION['session']->isLogged()) $authorXML =
          '<author userID="'.formatText($_SESSION['session']->getUser()->getID()).'">
            {collection("weblog")/user[@ID=\''.formatText($_SESSION['session']->getUser()->getID(), false).'\']/info/nick}
            {collection("weblog")/user[@ID=\''.formatText($_SESSION['session']->getUser()->getID(), false).'\']/info/realName}
           </author>';
    else $authorXML = '<author guest="true">'.formatText($guest).'</author>';
    $query = 'update insert
        <comment ID="p'.formatText($max+1).'">'.
           $authorXML.
          "<content> ".formatText($text).' </content>
            <title>'.formatText($title).'</title>
            <date timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</date>
        </comment>';
    if (!empty($commentID))
      $query .= 'into collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.formatText($postID, false).'"]//comment[@ID="'.formatText($commentID, false).'"]';
    else
      $query .= 'into collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.formatText($postID, false).'"]/comments';
    $GLOBALS['system']->getDB()->fetchNode($query);
    //dumpxml($query);
    // header("Location: ?type=postView&userID=".$this->userID."&postID=$postID");
  } // end of member function newComment

  /**
   *
   * @return 
   * @access public
   */
  public function editPost($id,$title, $content, $tags, $description="", $subtitle="", $language='sk', $status='published', $private=true)
  {
    if (strtolower($status)=='reset') $status='published' ; // riadi sa to podla buttonov, a je tam aj button reset, a taky stav nechceme;
    //platne statusy su len published a draft
    if ($status!='published' && $status!='draft') return;

	//pridanie novych tagov
	 $tb = new TagBrowser("");
     if (is_array($tags))
       foreach ($tags as $tag){$tb->addTag($tag,$language);}
        
    
	$tagsXML = "";
    if (is_array($tags))
      foreach ($tags as $tag)
        $tagsXML .= '<tag>'.formatText(trim($tag)).'</tag>';

    if ($private==true) $private="yes";
    else $private="no";

    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.$id.'"]
        with
	if ($i/@type) then
        <post ID="'.formatText($id).'" accessCount="{$i/@accessCount+1}" lang="'.formatText($language).'" status="'.formatText($status).'" private="'.formatText($private).'">
        {$i/@type}
        {$i/@submitted}
        <title>'.formatText($title).'</title>
        <subtitle>'.formatText($subtitle).'</subtitle>
	<content> '.formatText($content).' </content>
        <tags>'.$tagsXML.'</tags>
        <lastUpdate timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</lastUpdate>
        {$i/date}
        {$i/comments}
	{$i/dateTop}
	{$i/dateTopOut}
        <topics/>
        </post>
	else
	<post ID="'.($id).'" accessCount="{$i/@accessCount+1}" lang="'.formatText($language).'" status="'.formatText($status).'" private="'.formatText($private).'">
        {$i/@type}
        {$i/@submitted}
        <title>'.formatText($title).'</title>
        <subtitle>'.formatText($subtitle).'</subtitle>
	<content> '.formatText($content).' </content>
        <tags>'.$tagsXML.'</tags>
        <lastUpdate timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</lastUpdate>
        {$i/date}
        {$i/comments}
        {$i/topics}
	{$i/dateTop}
	{$i/dateTopOut}
        </post>';
        
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function editPost
  
   /**
   * Nastavenia stavu prispevku draft/published
   * @return 
   * @access public
   */    
  public function setStatus($id, $status)
  {
    if (strtolower($status)=='reset') return ; // riadi sa to podla buttonov, a je tam aj button reset, a taky stav nechceme;
    //platne statusy su len published a draft
    if ($status!='published' && $status!='draft') return;

    $currentStatus =  $GLOBALS['system']->getDB()->fetchNode('collection("weblog")/user/blog/post[@ID="'.formatText($id, false).'"]/@status/normalize-space()');
    if ($status=='published' && $currentStatus=="draft")
    { 
      $xquery = 'update replace $i in collection("weblog")/user/blog/post[@ID="'.formatText($id, false).'"]/date with  <date timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</date>';
      $GLOBALS['system']->getDB()->fetchNode($xquery);
    }

    $xquery = 'update replace $i in collection("weblog")/user/blog/post[@ID="'.$id.'"]/@status
         with attribute status {"'.formatText($status).'"}';
    $GLOBALS['system']->getDB()->fetchNode($xquery);
  }

  /**
   * Zmazanie prispevku
   * @return 
   * @access public
   */
  public function deletePost($postID)
  {
    $query = 'update delete collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.formatText($postID, false).'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function deletePost

  /**
  *
  * @return
  * @access public
  */
  public function deleteComment($postID,$commentID)
  {
    $query = 'update delete collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post//comment[@ID="'.formatText($commentID, false).'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function deletePost
  
  /**
    * funkcia pre admin rozhranie
    * @return
    * @access public
    */
  public function deleteTag($tagID)
  {
    $query = 'update delete collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function deleteTag
  
  /**
    * funkcia pre admin rozhranie
    * @return
    * @access public
    */
  public function editTag($tagID, $alts)
  {    
    // fetch definition, we'll need this later
    $query = 'collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]/description';
    $definition = $GLOBALS['system']->getDB()->fetchNode($query);
    
    $query = 'update delete collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]/description';
    $GLOBALS['system']->getDB()->fetchNode($query);
    
    // delete <alt> from other <tag> elements
    foreach($alts as $key=>$item) {
      $query = 'update delete collection("weblog")/tags/tag/alt[text()="'.formatText(trim($item), false).'"]';
      $GLOBALS['system']->getDB()->fetchNode($query);
    }
    
    // delete every <alt> from the <tag>, we are going to edit
    $query = 'update delete collection("weblog")/tags/tag[@id="'. formatText($tagID, false)  .'"]/alt';
    $GLOBALS['system']->getDB()->fetchNode($query);
    
    // write definition to the right place
    $query = 'update insert
                <definition>'.$definition.'</definition>
              into collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);				    
    
    // put new <alt> under the new <tag>
    foreach($alts as $key=>$item) {
      $query = 'update insert
              <alt type="caps">'.formatText(trim($item)).'</alt>
              into collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]';
      $GLOBALS['system']->getDB()->fetchNode($query);
    }
  } // end of member function editTag		  
  
  /**
    *
    * @return
    * @access public
    */
  public function hideTag($tagID, $alts)
  {    
    // fetch definition, we'll need this later
    $query = 'collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]/description';
    $definition = $GLOBALS['system']->getDB()->fetchNode($query);
    
    $query = 'update delete collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]/description';
    $GLOBALS['system']->getDB()->fetchNode($query);
    
    // delete <alt> from other <tag> elements
    foreach($alts as $key=>$item) {
      $query = 'update delete collection("weblog")/tags/tag/alt[text()="'.formatText(trim($item), false).'"]';
      $GLOBALS['system']->getDB()->fetchNode($query);
    }
    
    // delete every <alt> from the <tag>, we are going to edit
    $query = 'update delete collection("weblog")/tags/tag[@id="'. formatText($tagID, false)  .'"]/alt';
    $GLOBALS['system']->getDB()->fetchNode($query);
    
    // write definition to the right place
    $query = 'update insert
                <definition>'.formatText($definition).'</definition>
              into collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);				    
    
    // put new <alt> under the new <tag>
    foreach($alts as $key=>$item) {
      $query = 'update insert
              <alt type="caps">'.formatText(trim($item)).'</alt>
              into collection("weblog")/tags/tag[@id="'.formatText($tagID, false).'"]';
      $GLOBALS['system']->getDB()->fetchNode($query);
    }
  } // end of member function hideTag

  /**
  * @access public
  */
  public function setTitle($title)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/title with <title>'.formatText($title).'</title>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setTitle

  /**
  *
  * @return 
  * @access public
  */
  public function getUserData( ) {
    
  } // end of member function getUserData
      
  /**
  *
  * @return 
  * @access public
  */ // OK
  public function incPostAccessCount($postID) 
  {
    /*$xquery = "collection('weblog')/user[@ID=\"".$this->userID."\"]/blog/post[@ID=\"".$postID."\"]/@accessCount/normalize-space()";
    $count = $GLOBALS['system']->getDB()->fetchNode($xquery);
    @$count++; */
    if (empty($count)) ;//$xquery = "update insert accessCount /user[@ID=\"".$this->userID."\"]/blog/post[@ID=\"".$postID."\"]/@accessCount with $count";;
    $xquery = 'update replace $i in collection("weblog")/user[@ID="'.formatText($this->userID, false).'"]/blog/post[@ID="'.formatText($postID, false).'"]/@accessCount with attribute accessCount {$i+1}';
    $GLOBALS['system']->getDB()->fetchNode($xquery); 
  } // end of member function
  
   /**
  *
  * @return 
  * @access public
  */ // OK
  public function incPostVotesCount($postID) 
  {
    $xquery = "/user/blog/post[@ID=\"".formatText($postID, false)."\"]/votes/@count";
    $count =intval($GLOBALS['system']->getDB()->fetchNode($xquery));
    //
    if (!$count) $xquery = "update insert <votes count='1'></votes> into /user/blog/post[@ID=\"".formatText($postID, false)."\"]";
    else 
    {
      @$count++; 
      $xquery = "update replace /user/blog/post[@ID=\"".$postID."\"]/votes/@count with '$count'";
    }
    $GLOBALS['system']->getDB()->fetchNode($xquery); 
  } // end of member function





} // end of BlogWriter
?>
