<?php

require_once 'System.php';
require_once 'XSLT.php';
require_once 'Collaboration.php';
require_once 'User.php';
require_once 'Portlet.php';
require_once 'XSLT.php';
require_once 'HookManager.php';

/*
<output>
<portletTop10 col="" pos="">
</portletTop10>
</output>
*/

//$GLOBALS['controler']->registerCallBack('addPost',&$aaa->addPost);
//klikne -> init -> spracovanie vstupu -> XML -> sablona -> vystup

class Controler {
	private $system;
	private $hooks;
	private $plugins = array(
/*	'actions',
	'article',
	'top10',
	'tags',*/
	'login',
	'campaigns',
	'lang',
	'search',
	'menu',
	'post',
	'articles',
	'users',
	'bestRated',
	'mostRead',
	'tagCloud',
	'layout'
	);
	private $portlets=array();
		
	public function __construct(){
		$this->system = new System();
		$this->hooks = new HookManager();
		$GLOBALS['system'] = $this->system;
		$GLOBALS['hooks'] = $this->hooks;
	}

	public function registerPortlet($name){
		$this->portlets[]=$name;
	}

	public function serve($params){
		//include pluginov
		foreach ($this->plugins as $key=>$item)
			require_once 'modules/'.$item.'.php';
		
		//inicializacia portletov
		foreach ($this->portlets as $key=>$item){
			$this->portlets[$key] = new $item($params);
		}

		//inicializacia portletov
		foreach ($this->portlets as $key=>$item){
			$item->init($params);
		}
		
		if (isset($params['type'])){
			$this->hooks->callHook($params['type'], $params);
		}

		//ziskanie vysledneho XML
		$xml = new DOMDocument();
		$root = $xml->appendChild($xml->createElement('output'));
		foreach ($this->portlets as $key=>$item){
			$data = $item->getXML($params);
			if (empty($data)) continue;
			$tmp = new DOMDocument();
			$tmp->loadXML($data);
			$tmp = $xml->importNode($tmp->documentElement,true);
			$root->appendChild($tmp);
		}
		$xml = $xml->saveXML();

		//ziskanie sablon
		$XSLfiles=array();
		$XSLParams=array();
		foreach ($this->portlets as $key=>$item){
			$files=$item->getXSLlist($params);
			$param=$item->getXSLParams($params);
			if (is_array($files)) $XSLfiles = array_merge($XSLfiles, $files);
			else $XSLfiles[]=$files;
			
			if (is_array($param)) $XSLParams = array_merge($XSLParams, $param);
		}
		
		//vyrobit vysledne XSLT, podstrcit mu XML a vyhodit na vystup
		//pre RAW xml budeme mat proste sablonu co ho bude vypisovat
		$xslt = new XSLT();
		$template = $xslt->createTemplate($XSLfiles);
		echo $xslt->applyTemplate($xml, $template, $XSLParams);
		
		//TODO: podpora statistik pre DEBUG?
	}
}

?>
