<?php
/************************************************************************
                        DokuWiki2HTML.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
 **************************************************************************/


function concat($a,$b)
{
  return $a.$b;
}


function incUnparsedIndex()
{
  return  "&unparsedBlock&##".$GLOBALS['unparsedIndex']++."##";
}

function incCodeIndex($matches)
{
  return  "&codeBlock&##".$GLOBALS['codeIndex']++."#".$matches[1]."##";
}

/**
 * class DokuWiki2HTML
 * trieda ktora formatuje vstupny DokuWiki text na html
 */
class DokuWiki2HTML
{

public function __construct()
{
}


/** Formatuje vsetky div v texte triedy formatted **/
public function outputFilter($text)
{
  $html ="";
  $texts = preg_split('|<div class="formatted">(.*)</div>|msU',$text,-1,PREG_SPLIT_DELIM_CAPTURE);
  //dump($texts);
  foreach ($texts as $key=>$block){
      if ($key%2 == 1) $texts[$key] = $this->formatBlock($block);
  }
  foreach ($texts as $key=>$block) $html.= $block;
  return $html;
}

/** Zvyraznenie bloku kodu **/
public function highlight($text,$language="php")
{
  $geshi = new GeSHi(htmlspecialchars_decode($text), $language);
  $geshi->set_header_type(GESHI_HEADER_PRE);
  $geshi->enable_classes();
  //$geshi->enable_line_numbers(GESHI_FANCY_LINE_NUMBERS, 5);
  $geshi->set_overall_style('color: #000066; border: 1px solid #d0d0d0; background-color: #f0f0f0;font-size:11px;padding:0.5em;', true);
  $geshi->set_line_style('font: normal normal 95% \'Courier New\', Courier, monospace; color: #003030;', 'font-weight: bold; color: #006060;', true);
  $geshi->set_code_style('color: #000020;', 'color: #000020;');
  $geshi->set_link_styles(GESHI_LINK, 'color: #000060;');
  $geshi->set_link_styles(GESHI_HOVER, 'background-color: #f0f000;');
  return $geshi->parse_code();
}

public 	function formatBlock($text)
{
  $originalText = $text;
  $GLOBALS['codeIndex']=0;
  $GLOBALS['unparsedIndex']=0;
  $text = trim($text);
  if (strlen($text)==0) return "";
  
  $unparsed = Array();
  $code = Array();

  /* Neparsovane casti */
  //preg_match_all('|&lt;nowiki(\s\w*)?&gt;(.*)&lt;/nowiki&gt;|Umse', $text, $unparsed1);
  preg_match_all('|%%(.*)%%|Umse', $text, $unparsed);

	$text = str_replace("\r\n", "\n", $text);
  //$unparsed = array_merge($unparsed2,$unparsed1);
  $text = preg_replace("|([\s\n])*--break--([\s\n])*|U","",$text,1);

  //$text = preg_replace_callback("|&lt;nowiki(\s\w*)?&gt;(.*)&lt;/nowiki&gt;|Usm","incUnparsedIndex", $text);
  $text = preg_replace_callback("|%%(.*)%%|Usm","incUnparsedIndex", $text);

  preg_match_all('|&lt;code(\s\w*)?&gt;(.*)&lt;/code&gt;|Umse', $text, $code);
  $text = preg_replace_callback("|&lt;code\s?(\w*)?&gt;(.*)&lt;/code&gt;|Ums","incCodeIndex", $text);
  //echo $text;
  $text = preg_replace("|\[tex\](.+)\[/tex\]|Umse","latex_content('$0')", $text);
  $text = preg_replace("|\[youtube\](.+)\[/youtube\]|Ums","<object width=\"425\" height=\"350\" ><param name=\"movie\" value=\"http://www.youtube.com/v/$1\"></param><embed src=\"http://www.youtube.com/v/$1\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\"></embed></object>", $text);
  $text = preg_replace("|\[youtube (\d+)\](.+)\[/youtube\]|Ums","<object width=\"$1\" ><param name=\"movie\" value=\"http://www.youtube.com/v/$2\"></param><embed src=\"http://www.youtube.com/v/$2\" type=\"application/x-shockwave-flash\" width=\"$1\" ></embed></object>", $text);
  $text = preg_replace("|\[youtube (\d+)x(\d+)\](.+)\[/youtube\]|Ums","<object width=\"$1\" height=\"$2\" ><param name=\"movie\" value=\"http://www.youtube.com/v/$3\"></param><embed src=\"http://www.youtube.com/v/$3\" type=\"application/x-shockwave-flash\" width=\"$1\" height=\"$2\"></embed></object>", $text);
  
  //$text = latex_content($text);
  //$text = str_replace("<br /><br />","</p><p>",nl2br($text));
  //$text = preg_replace('|[\\\\]{2}\s|','<br />$1', $text);
  //$text = preg_replace('|<br>|',"<br s/>",nl2br($text));
 

  // images
  $text = preg_replace("!{{ ([^}\s]*)\?(\d+)x(\d+) }}!U",'<img src="$1" width="$2px" height="$3px" class="imgCenter" alt=""/>', $text);
  $text = preg_replace("/{{ ([^}\s]*)\?(\d+) }}/U",'<img src="$1" width="$2px" class="imgCenter" alt="" />', $text);
      
      
  $text = preg_replace("!{{ ([^}\s]*)\?(\d+)x(\d+)}}!U",'<img src="$1" width="$2px" height="$3px" class="imgRight" alt=""/>', $text);
  $text = preg_replace("/{{ ([^}\s]*)\?(\d+)}}/U",'<img src="$1" width="$2px" class="imgRight" alt="" />', $text);
  
  $text = preg_replace("!{{([^}\s]*)\?(\d+)x(\d+) }}!U",'<img src="$1" width="$2px" height="$3px" class="imgLeft" alt=""/>', $text);
  $text = preg_replace("/{{([^}\s]*)\?(\d+) }}/U",'<img src="$1" width="$2px" class="imgLeft" alt=""/>', $text);
  
  $text = preg_replace("/{{([^}\s]*)\?(\d+)x(\d+)}}/s",'<img src="$1" width="$2px" height="$3px" alt=""/>', $text);
  $text = preg_replace("/{{([^}\s]*)\?(\d+)}}/U",'<img src="$1" width="$2px" alt=""/>', $text);
  $text = preg_replace("!{{([^}\s]*)}}!U",'<span style="display:inline;vertical-align:top"><img src="$1" alt=""/></span>', $text);
  
  $text = preg_replace("!{{ ([^}\s]*)}}!U",'<img src="$1" class="imgRight" alt=""/>', $text);
  $text = preg_replace("!{{([^}\s]*) }}!U",'<img src="$1" class="imgLeft" alt=""/>', $text);
  $text = preg_replace("!{{ ([^}\s]*) }}!U",'<img src="$1" class="imgCenter" alt=""/>', $text);
  
  // linky
  $text = preg_replace("!\[\[(https?://.*)\|(.*)\]\]!Us","<a href='$1'>$2</a>", $text);//
  $text = preg_replace("!\[\[(https?://.*)\]\]!Us","<a href='$1'>$1</a>", $text);//

  $text = preg_replace('!(\s)(https?://[^\s<]*)([\s<])!',"$1<a href='$2'>$2</a>$3", $text);//
  //$text = preg_replace('!(\s)(https?://[^\s<]*)([\s<])!',"$1<a href='$2'>$2</a>$3", $text);//
 
 // $text = preg_replace("!([^/])www\.(.*)( |<)!U","$1<a href=\"http://www.$2\">www.$2</a>$3", $text);
  
  //styl
 $text = preg_replace("|&lt;del&gt;(.*)&lt;/del&gt;|Um","<del>$1</del>", $text);//
 $text = preg_replace("|&lt;sup&gt;(.*)&lt;/sup&gt;|Um","<sup>$1</sup>", $text);//
 $text = preg_replace("|&lt;sub&gt;(.*)&lt;/sub&gt;|Um","<sub>$1</sub>", $text);//
 $text = preg_replace("|\*\*(.*)\*\*|Ums","<strong>$1</strong>", $text);//
 $text = preg_replace("|([^:])//(.*)//|Usm","$1<em>$2</em>", $text);//
 $text = preg_replace("|__(.*)__|Ums","<u>$1</u>", $text);//
 $text = preg_replace('@^(======+)(.*)\1 *(?=\s|$)@m',"<h2>$2</h2>", $text);//
 $text = preg_replace('@^=====(.*)=====(?=\s|$)@m',"<h3>$1</h3>", $text);//
 $text = preg_replace('@^====(.*)====(?=\s|$)@m',"<h4>$1</h4>", $text);//
 $text = preg_replace('@^===(.*)===(?=\s|$)@m',"<h5>$1</h5>", $text);//
 $text = preg_replace('@^==(.*)==(?=\s|$)@m',"<h6>$1</h6>", $text);//

/*
$text = preg_match_all('|^(.*)$|m',$text,$li);
 $li = $li[1];

 foreach($li as $key=>$line)
 {
   if (substr($line[0],0,1)=="*")
   {
     $line = str_replace("<br />","",$line);
     $line = str_replace("<p>","",$line);
     $line = str_replace("</p>","",$line);
     $li[$key] ='<li>'.substr($line,1)."</li>\n";
   	if (array_key_exists(($key-1), $li) && substr($li[$key-1],0,4)!='<ul>' && (substr($li[$key-1],0,4)!='<li>')) $li[$key] ="<ul>".$li[$key];
   	if (array_key_exists(($key+1), $li) && substr($li[$key+1],0,1)!='*') $li[$key] = $li[$key]."</ul>";
   }
 }

 	foreach($li as $key => $line)
 	{
	 	if (substr($line[0],0,1)=="-")
	 	{
		 	$line = str_replace("<br />","",$line);
		 	$line = str_replace("<p>","",$line);
		 	$line = str_replace("</p>","",$line);
			$li[$key] ='<li>'.substr($line,1)."</li>\n";
			if (array_key_exists(($key+1), $li) && substr($li[$key+1],0,1)!='-') $li[$key] = $li[$key]."</ol>";
	 		if (array_key_exists(($key-1), $li) && substr($li[$key-1],0,4)!= '<ol>' && substr($li[$key-1],0,4)!= '<li>') $li[$key] ="<ol>".$li[$key];
	 	}
	}

  $text = implode('', $li);
*/
	$text = preg_replace('@(^|\n)\*(.*)(?=$|\n)@', '<li*>\2</li*>', $text);
	$text = preg_replace('@(?<!</li\*>)<li\*>@', "\n<ul><li*>", $text);
	$text = preg_replace('@</li\*>(?!<li\*>)@', '</li*></ul>', $text);

	$text = preg_replace('@(^|\n)\-(.*)(?=$|\n)@', '<li->\2</li->', $text);
	$text = preg_replace('@(?<!</li\->)<li\->@', "\n<ol><li->", $text);
	$text = preg_replace('@</li\->(?!<li\->)@', '</li-></ol>', $text);

	$text = preg_replace('@<(/?li)(\*|\-)>@', '<\1>', $text);
/*
	$text = preg_replace('@(?<=^|\n)\*(.*)(?=$|\n)@', '<li*>\2</li*>', $text);
	$text = preg_replace('@(?<!</li\*>\n)<li\*>@', '<ul><li*>', $text);
	$text = preg_replace('@</li\*>(\n?!<li\*>)@', '</li*></ul>', $text);

	$text = preg_replace('@(?<=^|\n)\-(.*)(?=$|\n)@', '<li->\2</li->', $text);
	$text = preg_replace('@(?<!</li\->\n)<li\->@', '<ol><li->', $text);
	$text = preg_replace('@</li\->(\n?!<li\->)@', '</li-></ol>', $text);

	$text = preg_replace('@<(/?li)(\*|\-)>@', '<\1>', $text);
*/

  //emoticons
  $text = str_replace(":-)",'<img src="css/emoticons/icon_smile.gif" alt=":-)" />',$text);
  $text = str_replace("8-)",'<img src="css/emoticons/icon_cool.gif" alt="8-)" />',$text);
  $text = str_replace(";-)",'<img src="css/emoticons/icon_wink.gif" alt=";-)" />',$text);
  $text = str_replace(":-D",'<img src="css/emoticons/icon_biggrin.gif" alt=":-D" />',$text);
  $text = preg_replace("@\blol\b@",'<img src="css/emoticons/icon_lol.gif" alt="lol" />',$text);
  $text = str_replace(":-|",'<img src="css/emoticons/icon_neutral.gif" alt=":-|" />',$text);

  
	$text = preg_replace('@</(li|ol|ul|h[1-6])>\n@', '</\1>', $text);
	$text = preg_replace('@\n<(li|ol|ul|h[1-6])>@', '<\1>', $text);
	$text = nl2br($text);

  $text = str_replace("~~TOC~~",$this->TOC($text),$text);
  $text = preg_replace("|(<h\d>)(.*)(</h\d>)|Ue","'<a name=\"'.strip_tags('$2').'\"></a>$1$2$3'",$text);
  $text = preg_replace("|&unparsedBlock&##(\d*)##|Ue",'"<pre class=\"text\">".($unparsed[1]["$1"])."</pre>"', $text);
  $text = preg_replace("|&codeBlock&##(\d*)#(.*)##|Ue",'$this->highlight(($code[2]["$1"]),"$2")', $text);
  $text = preg_replace("|<p>[\s]*</p>|U","",$text);
  $text = preg_replace("|<p>[\s]*</p>|U","",$text);
  
  return str_replace('&nbsp;', '', $text);
}

private function subTOC($titles, $prefix){

	$out='<ul class="TOC">';
	$subtoc=array();
	$counter=0;
	foreach($titles as $key=>$title){
		$out.='<li>';
		if ($titles[$key]['level']>$titles[0]['level']){
			$subtoc[]=$title;
		} elseif ($titles[$key]['level']==$titles[0]['level']) {
			if (!empty($subtoc)){
				$out.='<li>'.$this->subTOC($subtoc,$prefix.$counter.'.').'</li>';
				$subtoc=array();
			}
			$counter++;
			$out .="<li><a href=\"#".strip_tags($title['title'])."\">";
			$out .=" ".$prefix.$counter.'. '.strip_tags($title['title'])."</a></li>\n";
		} else {
			break;
		}
		$out.='</li>';
	}
	if (!empty($subtoc)){
		$out.='<li>'.$this->subTOC($subtoc,$prefix.$counter.'.').'</li>';
	}
	$out.='</ul>';
	return $out;
}

public function TOC($text)
{
  preg_match_all("|<h\d>(.*)</h\d>|U",$text,$titles);
  $titles = $titles[0];
  $level = 0;
  $toc="<div id=\"TOC\"><h4>Obsah</h4>";

  foreach($titles as $key=>$title){
    $titles[$key] = Array();
    $titles[$key]['title'] = $title;
    $titles[$key]['level'] = $title[2];
  }
  
  $toc .= $this->subTOC($titles,'');
/*  $counter = Array();
  foreach($titles as $key=>$title)
  {
    $titles[$key] = Array();
    $titles[$key]['title'] = $title;
    $titles[$key]['level'] = $title[2];
    if (array_key_exists(($key-1), $titles) && $titles[$key]['level'] > $titles[$key-1]['level'] || !array_key_exists(($key-1), $titles))
    {
      $toc .="<ul class=\"TOC\">";
      @$counter[$level++];
    }
    @$counter[$level]++;
    
    $toc .="<li>"."<a href=\"#".strip_tags($title)."\">";
    for ($i=1;$i<=$level;$i++) $toc .= $counter[$i].'.';
    $toc .=" ".strip_tags($title)."</a></li>\n";
    if (array_key_exists($key+1, $titles) && $titles[$key]['level']>$titles[$key+1][2] || !array_key_exists($key+1, $titles)) 
    {
      $toc .="</ul>";
      $counter[$level]=0;
      $counter[$level--];
    }
    
    
  }*/
  $toc .="</div>";
  //dump($titles);
  return $toc;
  //die();
}

  
} // end of DokuWiki2HTML
?>
