<?php

require "classes/Filter.php";

class SearchFilter implements Filter {
	public function getQuery($params){
		if (isset($params['q'])) return '[matches(content,"'.formatText($params['q'], false).'") or matches(title,"'.formatText($params['q'], false).'") or matches(subtitle,"'.formatText($params['q'], false).'")]';
		return "";
	}
}

class LangFilter implements Filter {
	public function getQuery($params){
		return '[contains("'.formatText($_SESSION['session']->getLang(), false).'",@lang)]';
	}
}

class PrivateFilter implements Filter {
	public function getQuery($params) {
		//if (isset($params['sstr']) || isset($params['tag'])) return "";
		return "[not(@private='yes')]";
	}
}

class TopicFilter implements Filter {
	public function getQuery($params) {
		if (isset($params['topic'])){
			if ($params['topic']=="0") $topicfilter = '[count(topics/topic[@scope="global"])=0]';
			elseif ($params['topic']!="") $topicfilter = '[topics/topic[@id="'.formatText($params['topic'], false).'"]]';
		}
		return "";
	}
}

class TagFilter implements Filter {
	public function getQuery($params){
		if (isset($params['tag'])) return '[tags/tag="'.formatText($params['tag'], false).'"]';
		return "";
	}
}

class PublishedFilter implements Filter {
	public function getQuery($params){
		return '[@status="published"]';
	}
}

class UserFilter implements Filter {
	public function getQuery($params){
		if (isset($params['userID'])) return '[../../@ID="'.formatText($params['userID'], false).'"]';
		return "";
	}
}

class ArticleFilter implements Filter {
	public function getQuery($params){
		if (isset($params['postID'])) return '[@ID="'.formatText($params['postID'], false).'"]';
		return "";
	}
}

class RankFilter implements Filter {
	public function getQuery($params){
		return '[ranks/reputationScore>5]';
	}
}

class AccessFilter implements Filter {
	public function getQuery($params){
		return '[@accessCount>50]';
	}
}

?>