<?php
/************************************************************************
  			Page.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
This file was generated on Po júl 16 2007 at 10:21:08
The original location of this file is /web/diplomovka/generated/Page.php
**************************************************************************/

require_once 'DataSource.php';
require_once 'XSLT.php';
require_once 'DokuWiki2HTML.php';
require_once 'PortalReader.php';
require_once 'BlogReader.php';

/**
 * class Page
 */
class Page
{

   /*** Attributes: ***/

  /**
   * @access private
   */
  private $dataSource;

   /**
   * @access private
   * @var XML data
   */
   private $data;

  /**
   * @access private
   */
  private $XSLT;

   /**
  * @access private
   */
  private $html;
  private $xsltProc;
  private $params;


  /**
   * The type is choosen from GET paramter.
   *
   * @param string type
   * @return
   * @access public
   */
  public function __construct($params)
  {
    $this->params = $params;
    $this->XSLT = new XSLT($params);
    switch ($params['type'])
    {
      case "blogView":
      {
        $this->dataSource = new BlogReader($params);
        break;
      }
      case "rss":
      {
        if (array_key_exists("userID",$params))
          $this->dataSource = new BlogReader($params);
        else
          $this->dataSource = new PortalReader($params);
        break;
      }
      case "postView":
      {
        $blogWriter = new BlogWriter(Array("userID"=>$params['userID']));
        $blogWriter->incPostAccessCount($params['postID']);
        $this->dataSource = new BlogReader($params);
        break;
      }
      case "commentForm":
      {
        $this->dataSource = new BlogReader($params);
        break;
      }
      case "loginForm":
      case "search":
      case "portalView":
      case "tagCloud":
      case "newUsers":
      case "newPosts":
      case "allPosts":
      case "mostRead":
      case "getTags":    //cachovanie databazy pre tag browser
	  case "getTagBrowserSVG":
      {
        $this->dataSource = new PortalReader($params);
        break;
      }
      case "editPostForm":
      {
        if (!$_SESSION['session']->getUser())
          throw new Exception(YOU_WERE_LOGOUT,SESSION_TIMEOUT);
        if ($_SESSION['session']->getUser()->getID()!=$params['userID'] && !$_SESSION['session']->getUser()->getUserPermissions('canEditOthersPosts'))
          redirect("http://".BASE."/index.php");
        $this->dataSource = new BlogReader($params);
        break;
      }
      case "userPosts":
      case "postForm":
      {
        if (!$_SESSION['session']->getUser())
          redirect("http://".BASE."/index.php");
        $this->dataSource = new BlogReader($params);
        break;
      }
      case "settingsForm":
      {
        if (!$_SESSION['session']->getUser())
          redirect("http://".BASE."/index.php");
	if (!$_SESSION['session']->getUser()->getUserPermissions('canEditOthersSettings'))
        	$params['userID'] = $_SESSION['session']->getUser()->getID();
        $this->dataSource = new BlogReader($params);
        break;
      }
      case "changeCategories":
      {
        //kontrola prav prebehla uz v kontrolery
	$this->dataSource = new Topics($params);
        break;
      }
      case "uploadForm":
      {
        if (!$_SESSION['session']->getUser())
          redirect("http://".BASE."/index.php");
        $params['userID'] = $_SESSION['session']->getUser()->getID();
        $this->dataSource = new BlogReader($params);
        break; 
      }
      case "registration":
      {
        $this->dataSource = new DataSource($params);
        break;
      }
      case "doRegistration":
      {
      }   
      default:
      {
        $this->dataSource = new BlogReader($params);
        break;
      }
      
    }

  } // end of member function __construct

  /**
   *
   * @return
   * @access public
   */
  public function output()
  {
	$array = Array("tagCloud","newUsers","allPosts","newPosts","mostRead","getTags");
    if (in_array($this->params['type'],$array))
      return;
    $this->loadDataSource();
    $this->transformDataSource();
    /*
    $dokuWiki = new DokuWiki2HTML();
    $this->html = $dokuWiki->outputFilter($this->html);
    */
    $dokuWiki = new DokuWiki2HTML();
    $this->html = $dokuWiki->outputFilter($this->html);
    if (array_key_exists("q",$_GET)) 
    {
      $pos = strpos($this->html,'<div id="main">');
      echo substr($this->html,0,$pos);
      new keyhighlighter ($_GET['q'], true, 'my_highlighter');
      echo substr($this->html,$pos);
    }
    else echo $this->html;
  } // end of member function output


  public function fetchOutput()
  {
    $array = Array("tagCloud","newUsers","allPosts","newPosts","mostRead","getTags","getTagBrowserSVG");
    if (in_array($this->params['type'],$array))
      return;
    $this->loadDataSource();
    $this->transformDataSource();
    /*
    $dokuWiki = new DokuWiki2HTML();
    $this->html = $dokuWiki->outputFilter($this->html);
    */
    $dokuWiki = new DokuWiki2HTML();
    $this->html = $dokuWiki->outputFilter($this->html);
    $ret='';
    if (array_key_exists("q",$_GET)) 
    {
      $pos = strpos($this->html,'<div id="main">');
      $ret.= substr($this->html,0,$pos);
      new keyhighlighter ($_GET['q'], true, 'my_highlighter');
      $ret.= substr($this->html,$pos);
    }
    else $ret.= $this->html;
    return $ret;
  } // end of member function output



  /**
   *
   * @return
   * @access private
   */
  private function loadDataSource( )
  {
   $this->data = $this->dataSource->getData();

  } // end of member function loadDataSource

  /**
   *
   * @return
   * @access private
   */
  private function transformDataSource( )
  {
    $this->xsltProc = new XSLTProcessor();
    $template = $this->XSLT->getXSL();
    if ($template) $this->xsltProc->importStyleSheet($template);
    
    /**** Nastavenie parametrov, ktore sa posielaju soblonam ******/
    if ($_SESSION['session']->isLogged())
    {
      $this->xsltProc->setParameter('', 'loggedUser', $_SESSION['session']->getUser()->getNick());
      $this->xsltProc->setParameter('', 'loggedUserID', $_SESSION['session']->getUser()->getID());
      $this->xsltProc->setParameter('', 'inCourse', $_SESSION['session']->getUser()->isInCourse());
    }
    else $this->xsltProc->setParameter('', 'loggedUser', false);
    $this->xsltProc->registerPHPFunctions('getUserPermissions');
    $this->xsltProc->setParameter('', 'base', BASE);
    $this->xsltProc->setParameter('', 'url', "http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]);
    /* encodovane url pre posielanie cez get */
    $this->xsltProc->setParameter('', 'urlEncoded', urlencode("http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]));
    if (isset($_GET['user']))
    {
      $header = "./files/".$_GET['user']."/header.jpg";
      if (file_exists($header))
      {
        $this->xsltProc->setParameter('', 'header', "true");
        $size = getimagesize($header, $info);
        $this->xsltProc->setParameter('', 'headerHeight', $size[1]);
      }
      $avatar = "./files/".$_GET['user']."/avatar.jpg";
      if (file_exists($avatar))
      {
        $this->xsltProc->setParameter('', 'avatar', "true");
      }
    }
    if (is_array($_GET)) 
      foreach($_GET as $key=>$paramter)
        $this->xsltProc->setParameter('', $key, $paramter);
    if (is_array($_COOKIE)) 
      foreach($_COOKIE  as $key=>$paramter)
    {
        if (substr($key,1,5)=="blog_") $this->xsltProc->setParameter('', 'cookie_'.$key, $paramter);
    }
    if ($this->params['type'] != "rss")
      $this->xsltProc->setParameter('', 'lang', $_SESSION['session']->getLang());
    if (in_array($this->params['type'],Array("postForm","editPostForm")))
      $this->xsltProc->setParameter('', 'timeout', date("H:i",mktime(date("H"),date("i")+session_cache_expire(),date("s"),date("m"),date("d"),date("Y"))));
    /* reCaptcha */
    $this->xsltProc->setParameter('', 'recaptcha_publickey', RECAPTCHA_PUBLICKEY);
    /* Svn version */
    if (!eregi("blog.matfyz.sk",$_SERVER['HTTP_HOST'])) {
      $version = shell_exec("svnversion -n");
      $this->xsltProc->setParameter('', 'svnVersion', $version);
    }
    /****/
    if ($template) {
    	$this->html = $this->xsltProc->transformToXML($this->data);
    } else {
    	$this->html = $this->data;
    }
    
    //pridanie linku na zrusenie temporaryStudentView state-u
    if ($_SESSION['session']->getState() == 'temporaryStudentView') {
	$this->html = str_replace('</body>', '<div><a href="normalView">[x]</a></a></div></body>', $this->html);
    }	    
   

  } // end of member function transformDataSource

/**
  * @return
  * @access private
*/
public function setHtml($html)
{
  $this->html = $html;
} // end of member function setHtml
    
/**
* @return html
* @access private
*/
public function getHtml()
{
  return $this->html; 
} // end of member function loadDataSource



} // end of Page
?>
