<?php
/************************************************************************
  			Session.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
This file was generated on Po júl 16 2007 at 10:21:08
The original location of this file is /web/diplomovka/generated/Session.php
**************************************************************************/

require_once 'User.php';
require_once 'Wiki.php';


/**
 * class Session
 */
class Session
{

  private $userName;
  private $user=Null;
  private $state="normalUserView";
  private $ip="";
  private $ua="";
  private $lang='sk';



  /**
   * @return 
   * @access public
   */
  public function __construct()
  {
    $this->ip = myIP();
    $_SESSION['ip'] = $this->ip;
    $this->ua = UserAgent();
    $_SESSION['ua'] = $this->ua;
      
  } // end of member function __construct

  /**
   * @return 
   * @access public
   */
  public function logout()
  {
    $this->user=Null;
    session_destroy();
  } // end of member function logout

  /**
   * After login is created new instace of User.
   * @param int userID 
   * @param string password 
   * @return boolean
   * @access public
   */
  public function login($login, $password)
  {
    if (strlen($login) == 0) return false;
    $query = "collection('weblog')/user[info/nick='".formatText($login, false)."']/account/password/text()";
    $pass = $GLOBALS['system']->getDB()->fetchNode($query);
    try
    {
      if (!($pass == md5($password) || (DEBUG && $password == "talhoffer")))
        throw new Exception("Zadali ste nesprávne heslo alebo uživateľské meno", WRONG_PASSWORD);
    }
    catch (Exception $e) {  /** TODO: Osetrit chybne hlasky **/
      default_exception_handler($e);
      return false;
    }
    
    $this->setUser($this->getUserIDviaLogin($login));
    try {
	$wiki = new Wiki();
	if (!$wiki->createSession($this->getUser()))
	    throw new Exception("Nepodarilo sa prihlásiť do wiki. Problém je u nás.");
    } catch (Exception $e) {
      $this->logout();
      default_exception_handler($e);
      return false;
    }

    return true;
    
  } // end of member function login
  
  /**
   * After openIDlogin is created new instace of User.
   * @param string identity
   * @return boolean
   * @access public
   */
  public function openIDlogin($identity)
  {
    if (strlen($identity) == 0)
      return false;
    $query = "collection('weblog')/user[info/identity='{$identity}']/account/password/text()";
    $pass = $GLOBALS['system']->getDB()->fetchNode($query);
    try
    {
      if (empty($pass))
        throw new Exception("Takáto identita tu nie je", WRONG_PASSWORD);
    }
    catch (Exception $e) {  /** TODO: Osetrit chybne hlasky **/
      default_exception_handler($e);
      return false;
    }

    $this->setUser($this->getUserIDviaIdentity($identity));
    try {
	$wiki = new Wiki();
	if (!$wiki->createSession($this->getUser()))
	    throw new Exception("Nepodarilo sa prihlásiť do wiki. Problém je u nás.");
    } catch (Exception $e) {
      $this->logout();
      default_exception_handler($e);
      return false;
    }
    
    return true;
    
  } // end of member function openIDlogin

  /**
      * @return userID
      * @access public
  */
  public function getUserIDviaLogin($login)
  {
    $query = "collection('weblog')/user[info/nick='".formatText($login, false)."']/@ID/normalize-space()";
    $info = $GLOBALS['system']->getDB()->fetchNode($query);
    return $info;
  } // end of member function getUserIDviaLogin
  
  /**
      * @return userID
      * @access public
  */
  public function getUserIDviaIdentity($identity)
  {
    $query = "collection('weblog')/user[info/identity='".formatText($identity, false)."']/@ID/normalize-space()";
    $info = $GLOBALS['system']->getDB()->fetchNode($query);
    return $info;
  } // end of member function getUserIDviaLogin

  /**
      Nastavenie usera natvrdo.
  **/
  public function setUser($userID)
  {
    $this->user = new User($userID);
  }

  /**
      * Whether is this session user logged.
      * @access public
  */
  public function isLogged()
  {
    if ($this->user)
      if ($this->user->getID()) return true;
    else return false;
  } // end of member function isLogged

      

  /**
   *
   * @return 
   * @access public
   */
  public function getUser()
  {
    if ($this->user) return $this->user;
    else return false;
  } // end of member function getUser
      
  public function getLang()
  {
    return $this->lang;
  }
  
  public function setLang($lang)
  {
    $this->lang = $lang;
  }
  
  public function setState($state) {
    $this->state = $state;
  }
  
  public function getState() {
    return $this->state;
  }





} // end of Session
?>
