<?php

require 'classes/SortQuery.php';

class RecommendedSortQuery implements SortQuery {
	public function getQuery($params){
		if ($params['order']=='ascending')
			return '
				order by (
					if ($i/dateTopOut) then
						xs:integer($i/dateTopOut/@timestamp)
					else
						(if ($i/dateTop) then (xs:integer($i/date/@timestamp)+3600*24*720)'
						.' else xs:integer($i/date/@timestamp))
				) ascending';
		else
			return '
				order by (
					if ($i/dateTopOut) then
						xs:integer($i/dateTopOut/@timestamp)
					else
						(if ($i/dateTop) then (xs:integer($i/date/@timestamp)+3600*24*720)'
						.' else xs:integer($i/date/@timestamp))
				) descending';
	}
}

class SimpleTimeSortQuery implements SortQuery {
	public function getQuery($params){
		if ($params['order']=='ascending')
			return '
				order by (
					xs:integer($i/date/@timestamp)
				)
				ascending';
		else
			return '
				order by (
					xs:integer($i/date/@timestamp)
				)
				descending';

	}
}

class NoSortQuery implements SortQuery {
	public function getQuery($params){
		return '';
	}
}

class ReputationSortQuery implements SortQuery {
	public function getQuery($params){
		if ($params['order']=='ascending')
			return 'order by (
					if ($i/ranks/reputationScore) then xs:double($i/ranks/reputationScore)
					else xs:double(0.0)
				)
				ascending';
		else
			return 'order by (
					if ($i/ranks/reputationScore) then xs:double($i/ranks/reputationScore)
					else xs:double(0.0)
				)
				descending';
	}
}

class VisitorsSortQuery implements SortQuery {
	public function getQuery($params){
		if ($params['order']=='ascending')
			return 'order by xs:integer($i/@accessCount) ascending';
		else
			return 'order by xs:integer($i/@accessCount) descending';
	}
}

class TitleSortQuery implements SortQuery {
	public function getQuery($params){
		if ($params['order']=='ascending')
			return 'order by title ascending';
		else
			return 'order by title descending';
	}
}

class CommentsSortQuery implements SortQuery {
	public function getQuery($params){
		if ($params['order']=='ascending')
			return 'order by count(.//comment) ascending';
		else
			return 'order by count(.//comment) descending';
	}
}

?>