<?php
/************************************************************************
TagBrowser.php - Wassil
**************************************************************************/
/**
 * class TagBrowser
 */
require_once 'Graph.php';

class TagBrowser {
  private $params;
  private $functions;
  /**
  * @return
  * @access public
   */
  public function __construct($params) {
	$this->params=$params;
	$this->functions='
		 declare function local:getAllTags($lang as xs:string) as element(tag)*{
		 	for
				$posts in collection("weblog")/user/blog/post[@status="published"][contains($lang,@lang)],
				$tags in $posts/tags,
				$tag in distinct-values($tags/tag),
				$tagCanonical in collection("weblog")/tags/tag[alt=$tag][normalize-space(data(@canonical))!=""][normalize-space(data(@canonical))!="Test tag"]
                        return <tag id="{$tagCanonical/@id}" post="{$posts/@ID}">{normalize-space(data($tagCanonical/@canonical))}</tag>
		 };
				
		 declare function local:getUserTags($userID as xs:string, $lang as xs:string) as element(tag)*{
		 	
			for
				$posts in collection("weblog")/user[@ID=$userID]/blog/post[@status="published"][contains($lang,@lang)],
				$tags in $posts/tags,
				$tag in distinct-values($tags/tag),
				$tagCanonical in collection("weblog")/tags/tag[alt=$tag]
                        return <tag post="{$posts/@ID}">{normalize-space(data($tagCanonical/@canonical))}</tag>
		 };

		 declare function local:filterRelatedTags($tags as element(tag)*, $tag as xs:string) as element(tag)*{
		 	for 
				$selected in collection("weblog")/tags/tag[@canonical=$tag]
			return
				$tags[@post=$tags[text()=$selected/alt/text()]/data(@post)]
		 };
		 
		 declare function local:filterUserTags($tags as element(tag)*, $user as xs:string) as element(tag)*{
		 	for 
				$userPosts in collection("weblog")/user[info/nick/text()=$user]/blog/post/@ID
			return
				$tags[@post=$userPosts]
		 };

		declare function local:countTags($tags as element(tag)*) as element(tag)*{
			for 
				$tag in distinct-values($tags)
                        order by count($tags[.=$tag]) descending
                        return 
				<tag id="{subsequence($tags[.=$tag]/@id,1,1)}" count="{count($tags[.=$tag])}">{$tag}</tag>
                };

		declare function local:log($n as xs:double) as xs:double{
			if ($n>1) then local:log($n div 2)+1 else 1
		};
	';
  }
 /*
  * titulkovy tag cloud
  */
  public function getTitleTags(){
  	$xquery=$this->functions.'
		let $tags:=subsequence(local:countTags(local:getAllTags("'.$_SESSION['session']->getLang().'")),1,80)
	    (: let $tags := for $tag in $tags	return <tag count="{$tag/@count}">{$tag/text()}</tag>  :)
        let $tags := for $tag in $tags	return <tag count="{local:log($tag/@count )}">{$tag/text()}</tag>
		    let $maxTagCount := max($tags/@count)
	       	let $minTagCount := min($tags/@count)
                let $tagsResult:= for 
					$tag in $tags
                                  order by lower-case($tag/text()) ascending
                                  return  
				  	<tag percent="{(($tag/@count - $minTagCount)div ($maxTagCount - $minTagCount+1))}">{$tag/text()}</tag>
		return 
	          $tagsResult
       	
	';
	$tags = $GLOBALS['system']->getDB()->fetchNode($xquery);
	return $tags;

  }
  /*
  * vrati zoznam related tagov ku zvolenemu tagu vo formate <tagy> <tag count={DACO}>{DACO}</tag>...  </tags>
  */
  public function getRelatedTags($tag,$lang){
	$xquery= '
		let $lang :="'.formatText($lang, false).'"		
		let $selectedTag :="'.formatText($tag, false).'"
		let $allAltTags:=	for   (: vyberiem vsetky tagy clankov so zvolenym tagom :)
				$altTag in collection("weblog")/tags/tag[@canonical=$selectedTag]/alt,
				$tag in collection("weblog")/user/blog/post[@status="published"][contains($lang,@lang)][not(@private="yes")][./tags/tag = $altTag]/tags/tag
				return $tag
				
		let $distinctAltTags:= for $tmp in distinct-values($allAltTags) return <tag>{$tmp}</tag>   (:vezmem len rozne hodnoty:)
		
		let $canonicalRepresentations:= for (:pre tieto rozne hodnoty si najdem kanonicke reprezentacie:)
				$tagData in collection("weblog")/tags/tag[contains($lang,@lang)][alt=$distinctAltTags]
				return $tagData
				
		let $allCanonicalTags:= for (: teraz vsetky tagy prelozim:)
			$tag in $allAltTags,
			$canonical in $canonicalRepresentations[alt=$tag]/@canonical
			return <tag>{data($canonical)}</tag>
		
		let $distinctCanonicalTags:= for $tmp in distinct-values($allCanonicalTags) return <tag>{$tmp}</tag>   (:vezmem len rozne hodnoty:)
		
		let $countedCanonicalTags:= for   (: agregujem vsetky tagy:)
			$tag in $distinctCanonicalTags
			order by count($allCanonicalTags[.=$tag]) descending
			return <tag count="{count($allCanonicalTags[.=$tag])}">{$tag}</tag>
		
		return
		 <tags>{
		 	$countedCanonicalTags 
		}</tags>
		';
		return $GLOBALS['system']->getDB()->fetchNode($xquery); 
  }

  /*
  * prepocita related tagy k $tagu a ulozi to do databazy
  */
  public function updateTag($tag,$lang){
		$query='let $related := '.$this->getRelatedTags($tag,$lang).'
		let $related:= for $tag in $related/tag
				return <rel type="related" strength="{$tag/@count}">{$tag/tag/text()}</rel>
		let $tag:=collection("weblog")/tags/tag[@lang="'.formatText($lang, false).'"][@canonical="'.formatText($tag, false).'"]
		
		return
			<tag id="{$tag/@id}" canonical="{$tag/@canonical}" lang="{$tag/@lang}">
				{$tag/definition}
				{$tag/alt}
				{$related}
			</tag>
		';
		$preparedTag= $GLOBALS['system']->getDB()->fetchNode($query);
		$replace = '
		update replace $tag in collection("weblog")/tags/tag[@lang="'.formatText($lang, false).'"][@canonical="'.formatText($tag, false).'"] with '.$preparedTag;
		$result= $GLOBALS['system']->getDB()->fetchNode($replace);
		echo ($result);
		
  }
  
  /*
  * userov tag cloud
  */
 public function getUserTags($userID){
  	$xquery=$this->functions.'
		let $tags:=subsequence(local:countTags(local:getUserTags("'.$userID.'","'.$_SESSION['session']->getLang().'")),1,50)
		(: let $tags := for $tag in $tags	return <tag count="{local:log($tag/@count div 100) * 100}">{$tag/text()}</tag> :)
		    let $tags := for $tag in $tags	return <tag count="{$tag/@count}">{$tag/text()}</tag>
                let $maxTagCount := max($tags/@count)
	          let $minTagCount := min($tags/@count)
                let $tagsResult:= for 
					$tag in $tags
                                  order by lower-case($tag/text()) ascending
                                  return  
				  	<tag percent="{(($tag/@count - $minTagCount)div ($maxTagCount - $minTagCount+1))}">{$tag/text()}</tag>
		return 
                   $tagsResult
	';
	$tags = $GLOBALS['system']->getDB()->fetchNode($xquery);
	return $tags;

  }
  /*
  * cachuje data pre tag browser
  */
  public function getTags(){
  	$query='string-join(collection("weblog")/tags/tag[@lang="sk"]/@canonical,\'|\')';
	$tagsJoined = $GLOBALS['system']->getDB()->fetchNode($query);
	$tags = explode('|',$tagsJoined);
	foreach($tags as $tag){
		$this->updateTag($tag,'sk');
	}		
	echo($tags);
	$query='string-join(collection("weblog")/tags/tag[@lang="en"]/@canonical,\'|\')';
	$tagsJoined = $GLOBALS['system']->getDB()->fetchNode($query);
	$tags = explode('|',$tagsJoined);
	foreach($tags as $tag){
		$this->updateTag($tag,'en');
	}	
	echo($tags);
  }
  public function addTag($tag,$language){
	$tagmax = $GLOBALS['system']->getMaxTagID();
    $xquery='collection("weblog")/tags';
    $this->xml = $GLOBALS['system']->getDB()->fetchNode($xquery);
    $xml = new SimpleXMLElement($this->xml);
    $tagPresent = 0; 
    $result = $xml->xpath('tag[@lang="'.formattext($language).'"]/alt');
	while(list( , $node) = each($result)) {  // for $alt in $tag[alt="'.$tag.'"]/alt
           if (trim((string)$node) == trim((string)$tag))
             $tagPresent = 1;
         }
				
         # tag sa v db nenachadza, musime ho pridat
         if ( $tagPresent == 0 ) {
		  $query = 'update insert
               <tag id="tag'.($tagmax+1).'" canonical="'.formatText(trim($tag)).'" lang="'.formatText($language).'">
                 <definition />
                 <alt type="caps">'.formatText(trim($tag)).'</alt>
               </tag>
               into collection("weblog")/tags';
        $GLOBALS['system']->getDB()->fetchNode($query);
	   }
	}  
  
  /*
  * toto sa defaultne zavola ked ?tag=nieco
  */
  public function getData(){
		$selectedTag = $this->params["tag"];
		$selectedLang = $_SESSION['session']->getLang();
  		$xquery=$this->functions.'let $tags:=subsequence(collection("weblog")/tags/tag[@lang="'.formatText($selectedLang, false).'"][@canonical="'.formatText($selectedTag, false).'"]/rel,1,50)
		    let $tags := for $tag in $tags	return <tag count="{local:log($tag/@strength)}">{$tag/text()}</tag>
            let $maxTagCount := max($tags/@count)
	        let $minTagCount := min($tags/@count)
            let $tagsResult:= for $tag in $tags
                                  order by lower-case($tag/text()) ascending
                                  return  
				  	<tag percent="{(($tag/@count - $minTagCount)div ($maxTagCount - $minTagCount+1))}">{$tag/text()}</tag>
		return 
                   $tagsResult
	';
	$tags = $GLOBALS['system']->getDB()->fetchNode($xquery);
	//echo($tags); die();
	$data = "<tagBrowser>".$tags;
	//$data.="<debug>".$tags."</debug>";
	$data.="</tagBrowser>";
	
	return $data;
	} 
  
  
  public function getTagBrowserSVG(){
    	if ($this->params["limit"]>0) $limit = $this->params["limit"];
			else $limit = 10;
		$selectedTag = $this->params["tag"];
		$selectedLang = $_SESSION['session']->getLang();
		//GET NODES
		$xquery = '
		let $tag := collection("weblog")/tags/tag[@lang="'.formatText($selectedLang, false).'"][@canonical="'.formatText($selectedTag, false).'"]
		let $nodes :=for $tag in subsequence($tag/rel,1,'.$limit.') 
			return 
			  <node count="{$tag/@strength}" title="{$tag}"/>
		    let $nodes :=for $node in $nodes 
			return 
			  <node data="{data($node/@title)},{$node/@count}"/>
		
		return
              	string-join($nodes/@data,\'|\')
		';	
		$queryResult = $GLOBALS['system']->getDB()->fetchNode($xquery);
		
		$graph = new Graph();
		$graph->addNode($selectedTag,0.1,true);
		
		if (strlen($queryResult)!=0){
			$nodes = array();
			$nodes = explode('|',$queryResult);
			foreach($nodes as $node){
				$nodeParam = explode (',',$node);
				if($nodeParam[0] != $selectedTag){
					$graph->addNode($nodeParam[0],log($nodeParam[1]));
					$graph->addEdge($nodeParam[0],$selectedTag);
				} else {
					$graph->nodes[$selectedTag]->size=log($nodeParam[1]);
				}
			}
		}
	
	
		//GET EDGES 
		foreach($graph->nodes as &$node){
			$xquery = '
			let $currentTag := collection("weblog")/tags/tag[@lang="'.formatText($selectedLang, false).'"][@canonical="'.formatText($node->name, false).'"]
			let $nodes :=for $tag in $currentTag/rel 
				return 
					<node data="{$tag},{$tag/@strength}"/>
			return
              	string-join(data($nodes/@data),\'|\')
		';	
		$queryResult = $GLOBALS['system']->getDB()->fetchNode($xquery);
			$nodes = array();
			$nodes = explode('|',$queryResult);
			foreach($nodes as $nodeData){
				$nodeArray = explode(',',$nodeData);
				if ($graph->hasNode($nodeArray[0])){
					if ($node->name==$nodeArray[0]){
						$node->size=log($nodeArray[1]);
						$node->mass=1+log($nodeArray[1]);
					}elseif (!$node->hasEdgeTo($nodeArray[0])){
						$graph->addEdge($node->name,$nodeArray[0]);
					}
				}
			}
		}
		
		
		$graph->makeCircle();
		$graph->make();
		$graph->normalize();
		
		$result = '<?xml version="1.0" encoding="UTF-8" standalone="no"?>
		<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 20000303 Stylable//EN" "http://www.w3.org/TR/2000/03/WD-SVG-20000303/DTD/svg-20000303-stylable.dtd">
		<svg xmlns="http://www.w3.org/2000/svg"  id="root" width="100%" height="100%" xmlns:xlink="http://www.w3.org/1999/xlink" onload="loadsvgcaller(evt)">';
			
		//skript na centrovanie a focus
		$result.= '<script type="text/ecmascript"> <![CDATA[
		var popisky = new Array();
		';
		$i=0;
		foreach ($graph->nodes as &$node){ //vyrobime pole s popiskami
			$result.= 'popisky['.$i++.']="'.$node->name.'";';
		}
		$result.='
		function loadsvgcaller(evt) {
			var p;
			for (p in popisky) center(document.getElementById(popisky[p])); //vsetky vycentrujem
			focus();
		}
		function center( targetElement ) { //vycentruje 1 popisok
			var bbox = targetElement.getBBox(); 
			var xcor = bbox.x-bbox.width/2;
			targetElement.setAttributeNS(null,"x",xcor);
		}
		//focus - focus sa pozrie na jednotlive popisky na obrazku, a nastavi viewbox tak, aby boli vsetky viditelne
		function focus(){
			var minX = document.getElementById(popisky[0]).getBBox().x;
			var maxX = minX;
			var minY = document.getElementById(popisky[0]).getBBox().y;
			var maxY = minY;
			var p;
			for (p in popisky){ //najdeme okraje tj. min a max x/y
				if (document.getElementById(popisky[p]).getBBox().x<minX) minX = document.getElementById(popisky[p]).getBBox().x;
		        if (document.getElementById(popisky[p]).getBBox().x+document.getElementById(popisky[p]).getBBox().width>maxX)
					maxX = document.getElementById(popisky[p]).getBBox().x+document.getElementById(popisky[p]).getBBox().width;
				if (document.getElementById(popisky[p]).getBBox().y<minY) minY = document.getElementById(popisky[p]).getBBox().y;
				if (document.getElementById(popisky[p]).getBBox().y+document.getElementById(popisky[p]).getBBox().height>maxY)
					maxY = document.getElementById(popisky[p]).getBBox().y+document.getElementById(popisky[p]).getBBox().height;
			}
			var mx = minX-5+" ";
			var my = minY-5+" ";
			var width = 5+(maxX-minX)+" ";
			var height = 5+(maxY-minY)+""; 
			var viewBox=mx+my+width+height;
			document.getElementById("root").setAttribute("viewBox",viewBox);
		}
		]]> </script>';

		
		$padding = 10;
		$paddingC = 100-$padding; //velkost efektivnej plochy
		foreach ($graph->edges as &$edge){
			$result.= '<line x1="'.($padding+$edge->nodes[0]->x*$paddingC).
						 '%" y1="'.($padding+$edge->nodes[0]->y*$paddingC).
						 '%" x2="'.($padding+$edge->nodes[1]->x*$paddingC).
						 '%" y2="'.($padding+$edge->nodes[1]->y*$paddingC).
						 '%" style="stroke:rgb(200,200,200);stroke-width:1"/>';	
			$result.= "\n";
	    }
		
		$maxSize = $graph->nodes[0]->size;
		$minSize = $graph->nodes[0]->size;
		foreach ($graph->nodes as &$node){
			if ($node->size > $maxSize) $maxSize = $node->size;
			if ($node->size < $minSize) $minSize = $node->size;
		}
		foreach ($graph->nodes as &$node){
			$nodeSize = ($node->size - $minSize)/($maxSize - $minSize+1);
			$result.='<a xlink:href="?tag='.$node->name.'" target="_parent">';
			$result.='<text id="'.$node->name.'" x="'.($padding+$node->x*$paddingC).
						'%" y="'.($padding+$node->y*$paddingC).
						'%" font-family="Verdana" font-size="'.(80+100*$nodeSize).'%" fill="green" >'.$node->name.'</text>';
			
			$result.= "</a>\n";
		}
		/*if (LOCAL) {
		$result .= '<!--'.$graph->debug.'-->';
		$result .= '<text x="0%" y="100%" font-family="Verdana" font-size="100%" fill="red" >Iterations:'
		.$graph->iterations.', time:'.$graph->generationTime.'</text>';
		}
		*/
		$result .=  "</svg>";
		
		header("Content-type: image/svg+xml");  //HACK!!!
		return $result;
		
  }  
}
