<?php
/************************************************************************
  			Topics.php - Copyright Martin Rejda
**************************************************************************/



/**
 * class Topicss
 * Topics manages topics in posts, User created topic and global topics.
 */
class Topics extends DataSource
{

  /**
   * @access private
   */

   /*** Attributes: ***/
  public $userID;
  private $xml="<blank />";

  /**
   *
   * @param int userID 
   * @return 
   * @access public
   */
  public function __construct($params)
  {
    return;
    $this->userID = $params['userID'];	/* id usera, ktoreho blog pozerame */
    $topic1 = array_key_exists("topic1",$_POST) ? $_POST['topic1'] : "";
    $topic2 = array_key_exists("topic2",$_POST) ? $_POST['topic2'] : "";
    $name = array_key_exists("name",$_POST) ? $_POST['name'] : "";
    $action = array_key_exists("action",$_POST) ? $_POST['action'] : "";
    if (array_key_exists('type',$params))
      switch($params['type'])
      {
	case "addPost":
	case "editPost":
	{
	  $this->deletePostTopics($params['postID']);
	  $topics=array();
	  if ($topic1) $topics[]=$topic1;
	  if ($topic2) $topics[]=$topic2;
	  $this->addPostTopics($params['postID'],$topics);
	}
	case "changeCategories":
	{
	  if ($action=='delete') {
	  	$this->deleteTopic($topic1, $this->userID);
	  }

	  if ($action=='add') {
		$this->addTopic($name, $this->userID);
	  }

	  if ($action=='setVisibility') {
	  	$this->addTopicsFromGlobal($_POST['topics'], $this->userID);
	  }

	  $this->xml = $this->getUserSettings($this->userID);

	}
      }
      
  } // end of member function __construct
 public function getData()
  {
    $data = new DOMDocument();
    if (!empty($this->xml))
      $data->loadXML($this->xml);
    return $data;
  }

 public function getUserSettings($userID=0){
 	if (empty($userID)) return "</blank>";
	$xquery = '
        let $user := collection("weblog")/user[@ID="'.$userID.'"]/blog/topics,
	$global := collection("weblog")/topics,
	$title := collection("weblog")/user[@ID="'.$userID.'"]/blog/title,
	$nick := collection("weblog")/user[@ID="'.$userID.'"]/info/*
        return
        <settingsCategories>
	  {$title}
	  {$nick}
	  <userCategories>
          {$user/*}
	  </userCategories>
	  <globalCategories>
	  {$global/*}
	  </globalCategories>
    	</settingsCategories>';
    return $GLOBALS['system']->getDB()->fetchNode($xquery);    

 }

 public function addTopicsFromGlobal($topics, $userID){
 	// ak je userID prazdny, dame to do globalneho scope
	if (!empty($userID)) {
		$query = 'update delete collection("weblog")/user[@ID="'.formatText($userID, false).'"]/blog/topics/topic[@scope="global"]';
		$GLOBALS['system']->getDB()->fetchNode($query);
		if (empty($topics)) return;
		foreach ($topics as $key=>$item){
			$query = 'update insert collection("weblog")/topics/topic[@id="'.formatText($key, false).'"] into collection("weblog")/user[@ID="'.formatText($userID).'"]/blog/topics';
			$GLOBALS['system']->getDB()->fetchNode($query);
		}
	}
 }

 public function getMaxID(){
	// priradenie postu do temy
	$xquery = "max(collection('weblog')//topic/number(substring-after(@id,'topic')))";
	return $GLOBALS['system']->getDB()->fetchNode($xquery);
 }

 public function getTopic($topicID){
 	$query = 'collection("weblog")/topics/topic[@id="'.formatText($topicID, false).'"] | collection("weblog")/user/blog/topics/topic[@id="'.formatText($topicID).'"]';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function addPostTopics($postID, $topicsID){
	// priradenie postu do temy/tem - max 1 globalna / jedna privatna
	$topics=array();
	foreach ($topicsID as $key=>$item){
		$xml = $this->getTopic($item);
		ereg('.*scope="([^"]*)".*', str_replace("\n",'',$xml), $res);
//		var_dump($res);flush();
		if (!isset($res[1])) $res[1] = 0;
		if ($xml && !isset($topics[$res[1]])) $topics[$res[1]] = $xml;
		unset($xml);
		unset($res);
	}
	foreach ($topics as $key=>$item){
		$query = 'update insert '.$item.' into collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/topics';
		$GLOBALS['system']->getDB()->fetchNode($query);
		var_dump($query);flush();
	}
 }

 public function deletePostTopic($postID, $topicID){
	// priradenie postu do temy
	$query = 'update delete collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/topics/topic[@id="'.formatText($topicID, false).'"]';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function deletePostTopics($postID){
	// priradenie postu do temy
	$query = 'update delete collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/topics/topic';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function addTopic($name, $userID=0){
 	// ak je userID prazdny, dame to do globalneho scope
	$id=$this->getMaxID()+1;
	if (empty($userID)) $query = 'update insert <topic id="topic'.formatText($id).'" scope="global"><name>'.formatText($name).'</name></topic> into collection("weblog")/topics';
	else $query = 'update insert <topic id="topic'.formatText($id).'"><name>'.formatText($name).'</name></topic> into collection("weblog")/user[@ID="'.formatText($userID, false).'"]/blog/topics';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function renameTopic($topicID, $name){
 	// premenovanie topicu
	$query = 'update replace $i in collection("weblog")//topic[@id="'.formatText($topicID, false).'"]/name
		 with <name>'.formatText($name).'</name>';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function voteTopic($postID, $topicID){
 	//hlasovanie o priradeni postu ku nejakemu topicu

 }

 public function deleteTopic($topicID, $userID=0){
 	//zmazat topic-y a vsetky ich vyskyty
	if (empty($userID)) $query = 'update delete collection("weblog")//topic[@id="'.formatText($topicID, false).'"]';
	else $query = 'update delete collection("weblog")/user[@ID="'.formatText($userID, false).'"]//topic[@id="'.formatText($topicID, false).'"]';

	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function getPostTopics($postID){
	$query = 'collection("weblog")/user/blog/post[@ID="'.formatText($postID, false).'"]/topics';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

 public function getTopics($userID=0){
 	//vrati array[cislo]["id" | "name"]
	//pre $userID==0 vratime globalne topicy
	if (empty($userID)) $query='collection("weblog")/topics';
	else $query='collection("weblog")/user[@ID="'.formatText($userID, false).'"]/blog/topics';
	return $GLOBALS['system']->getDB()->fetchNode($query);
 }

} // end of BlogWriter
?>
