<?php
/************************************************************************
  			User.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
This file was generated on Po júl 16 2007 at 10:21:08
The original location of this file is /web/diplomovka/generated/User.php
**************************************************************************/

require_once 'Session.php';


/**
 * class User
 * Class User edits and retrieves user data from DB.
 */
class User
{


  /**
   * @access private
   */
  private $ID;
  
  /**
  * @access private
  */
  private $nick;

  /**
   * @access private
   */
  private $email;
  
  private $realname;
  private $type;


  /**
   * If ID is valid existing user ID, then load data from DB.
   * Else create new user, and call new Blog constructor.
   *
   * @param int ID 
   * @return 
   * @access public
   */
  public function __construct($ID)
  {
    $this->ID = $ID;
    $query = "collection('weblog')/user[@ID='".formatText($ID, false)."']/info";
    $info = $GLOBALS['system']->getDB()->fetchNode($query);
    $info = simplexml_load_string($info);
    if ($info)
    {
      $this->nick = current($info->nick);
      $this->email = current($info->email);
      $this->realname = current($info->realName);
    }
    //dump($this);
  } // end of member function __construct

  /**
   *
   * @return 
   * @access public
   */
  public function __destruct() {
    
  } // end of member function __destruct

  /**
   * @return user id
   * @access public
   */
  public function getID()
  {
    return $this->ID;
    
  } // end of member function getID

  /**
   * @return email
   * @access public
   */
  public function getEmail() {
    return $this->email;
    
  } // end of member function getEmail

  /**
  * @return realName
  * @access public
  */
  public function getRealName() {
    return $this->realname;

  } // end of member function getEmail

  /**
  * @return Nick
  * @access public
  */
  public function getNick()
  {
    return $this->nick;
  } // end of member function getNick

  /**
   * @access public
   */
  public function setEmail($email)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/info/email with <email>'.formatText($email).'</email>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setEmail
  
  /**
  * @access public
  */
	public function setIdentity($identity)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/info/identity with <identity>'.formatText($identity).'</identity>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setIdentity

  /**
  * @access public
  */
  public function setRealName($realName)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/info/realName with <realName>'.formatText($realName).'</realName>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setRealName
      
   /**
   * @access public
   */
      public function setLastName($realName)
      {
        $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/info/lastName with <lastName>'.formatText($realName).'</lastName>';
        $GLOBALS['system']->getDB()->fetchNode($query);
      } // end of member function setRealName

  /**
  * @access public
  */
  public function setAbout($about)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/info/about with <about>'.formatText($about).'</about>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setRealName
    
  /**
  * @access public
  */
  public function setPassword($newPassword,$oldPassword)
  {
    $query = 'collection("weblog")/user[@ID="'.$this->getID().'"]/account/password/text()';
    $pass = $GLOBALS['system']->getDB()->fetchNode($query);
    //if (strcmp($pass,md5($oldPassword))) throw new Exception("Chybné staré heslo",WRONG_PASSWORD);
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/account/password with <password>'.md5($newPassword).'</password>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setPassword
      
      

  /**
  * @access public
  */
  public function setCSS($style)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/blog/@css with "'.formatText($style).'"';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setCSS
  
  /**
  * @access public
  */
  
  //pozor na manualne doplnanie atributov :( 
  public function setTemplate($template)
  {
    $query = 'UPDATE
		    replace $t in collection("weblog")/user[@ID="'.$this->getID().'"]/blog
		    with
        		<blog template="'.$template.'">
        		{$t/@css}
        		{$t/node()}
        		</blog>';
        		
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setTemplate
     
  /**
   * @return 
   * @access public
   */
  public function getUserRank() {
    
  } // end of member function getUserRank
      
  /**
  * @return 
  * @access public
  */
  public function getUserType() 
  {
    if (empty($this->type)) {
    	$query = 'data(collection("course")/courses/course[@year="2009/2010"]/users/user[@ref="'.$this->getNick().'"]/@type)';
      $this->type = html_entity_decode($GLOBALS['system']->getDB()->fetchNode($query), ENT_QUOTES);
    }  

    if (empty($this->type)) {
	    $query = 'data(collection("weblog")/user[@ID="'.$this->getID().'"]/@type)';
	    $this->type= html_entity_decode($GLOBALS['system']->getDB()->fetchNode($query), ENT_QUOTES);
    }
 
//  	debug_print_backtrace();
       return $this->type;
  } // end of member function getUserType
  
  public function isInCourse() 
  {
    	$query = 'data(collection("course")/courses/course[@year="2009/2010"]/users/user[@ref="'.$this->getNick().'"]/@type)';
	$res = html_entity_decode($GLOBALS['system']->getDB()->fetchNode($query), ENT_QUOTES);
	if ($res!='') return true;
	return false;

    /*
    $type = $this->getUserType();
    //prazdny retazec ak nie je v ziadnej z collection a test na 'admin' je z toho dovodu ze na weblogu existuju 4 useri [!],
    //maju urceny atribut type a vsetci ho maju nastaveny na 'admin'.
    if ($type == '' || $type == 'admin') {
      return false;
    } else {
    	 return true;
    } */
  } // end of member function isInCourse
  
  
  /**
  * @return 
  * @access public
  */
  public function whenWasStudent() 
  {
  	if (!$this->isInCourse()) {
   	$query = 'data(collection("course")/courses/course[users/user/@ref="'.$this->getNick().'"]/@year)';
	 $year = html_entity_decode($GLOBALS['system']->getDB()->fetchNode($query), ENT_QUOTES);
	 $year = str_replace('/', '-', $year);
      return substr($year, 0, 9);
     } else {return '';}    
         
  } // end of member function whenWasStudent
  
  /**
  * @access public
  */
  
  
  public function getTemplate()
  {
    		$xquery = 'data(collection("weblog")/user[@ID="'.$this->getID().'"]/blog/@template)';		
        $template = html_entity_decode($GLOBALS['system']->getDB()->fetchNode($xquery), ENT_QUOTES);
    				    
    	return $template;
    	
  } // end of member function getTemplate

  /**
  * @access public
  */
  
  
  public function getArchiveTemplate()
  {   		 		    
    		$template =  '/home/www/blog.matfyz.sk/htdocs/archive/course/'.$this->whenWasStudent().'/files/'.$this->getNick().'/blog.xsl';    		
    		return $template;    		
    	
  } // end of member function getArchiveTemplate
   
  /**
  * @return bool
  * @access public
  */
  public function uploadFile($tmpName, $newName, $oldName)
  {
    if (empty($newName)) $newName = $oldName;
    if (!preg_match('@^[a-zA-Z0-9\_\.-]+$@', $newName)) throw new Exception('Filename must consist only of letters, numbers, dash, underscore and dot.');
    @mkdir('files/'.$this->getNick());
    move_uploaded_file($tmpName, 'files/'.$this->getNick().'/'.$newName);
    chmod('files/'.$this->getNick().'/'.$newName,0777);
  }

  /**
  * @access public
  */
  public function setUserType($type)
  {
    /* Kvoli ochrane keby sa menil aj admin v buducnosti */
    if (empty($type)) return ;
    switch ($type)
    {
      case "student" : 
      { 
        $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/@type with attribute type {"student"}';
        $GLOBALS['system']->getDB()->fetchNode($query);
        $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/blog/@template with attribute template {""}';
        $GLOBALS['system']->getDB()->fetchNode($query);
        break; 
      }
      case "admin" :
      {
        $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->getID().'"]/@type with attribute type {"admin"}';
        $GLOBALS['system']->getDB()->fetchNode($query);
      }
      default : { $type="";break; }
    }
    
  } // end of member function setPassword

	public function getUserPermissions($what='') {
		switch ($what){
			case "": {
				//tu by sa patrilo spravit dotaz na DB a vratit prislusny inode
				if ($this->getUserType()=='admin') {
					$xml = "
					<permissions>
						<canDeleteOthersComments/>
						<canEditOthersPosts/>
						<canMakeTop/>
						<canEditOthersSettings/>
					</permissions>
					";
				}
				else $xml="<permissions/>";
				return $xml;

/*				$doc = new DOMDocument;
				$doc->loadXml($xml);
				return $doc;*/
				break;
			}
			case "canDeleteOthersComments" :
			case "canEditOthersPosts" :
			case "canEditOthersSettings" :
			case "canMakeTop" :
			default : {
				if ($this->getUserType()=='admin') return true;
				else return false;
			}
		}
	}

} // end of User
?>
