<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:my="http://blog.matfyz.sk"
	xmlns:func="http://exslt.org/functions"
	extension-element-prefixes="my func">

<xsl:template match="module[@name='Articles']">
	<div class="portlet articlePortlet">
		<!-- TOP5 POSTY OBALENE SPECIALNYM DIVOM -->
		<div id="top5naTitulke">
			<xsl:for-each select="newPosts/post[dateTop][not(dateTopOut)]">
				<xsl:apply-templates select="." />
			</xsl:for-each>
		</div>
		
		<!-- OSTATNE POSTY -->
		<xsl:for-each select="newPosts/post[not(dateTop) or dateTopOut]">
			<xsl:apply-templates select="." />
		</xsl:for-each>
	</div>
	
	<!-- CISTY NENAFORMATOVANY OBSAH -->
	<!--<xsl:copy-of select="."/>-->
</xsl:template>


<!-- PRE KAZDY POST -->
<xsl:template match="post">
	<xsl:variable name="lastpost"><xsl:if test="position() = last()"> last</xsl:if></xsl:variable>
	<div class="post{$lastpost}">
		<div class="date">
			<xsl:if test="dateTop">
				<xsl:attribute name="class">date dateTop</xsl:attribute>
			</xsl:if>			
			<p>
				<xsl:if test="@lang">
					<img src="./css/flags/{@lang}.png" width="16" height="11" alt="{@lang} flag" class="flag"/>
					|
				</xsl:if>
				<span class="created">
					<xsl:value-of select="substring(date,9,2)" />.
					<xsl:value-of select="substring(date,6,2)" />.
					<xsl:value-of select="substring(date,1,4)" /><xsl:text> </xsl:text>
					<xsl:value-of select="substring(date,12,2)" />:<xsl:value-of select="substring(date,15,2)" />
				</span>
				<xsl:if test="lastUpdate">
					(<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Changed'"/>
					</xsl:call-template>: <xsl:value-of select="substring(lastUpdate,9,2)" />.
					<xsl:value-of select="substring(lastUpdate,6,2)" />.
					<xsl:value-of select="substring(lastUpdate,1,4)" /><xsl:text> </xsl:text>
					<xsl:value-of select="substring(lastUpdate,12,2)" />:<xsl:value-of select="substring(lastUpdate,15,2)" />)
				</xsl:if>
				<xsl:if test="dateTop">
					<span class="display_none"> | </span>
					<span class="markTopPost">
						<xsl:if test="dateTop and dateTopOut">
							<xsl:attribute name="class">markTopPost markTopPostOut</xsl:attribute>
						</xsl:if>
						<xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'topPost'"/>
						</xsl:call-template>
					</span>
					<img class="imageTopPost" src="./css/topPost.gif" alt="top post" title="top post" />
				</xsl:if>
			</p>
			<div class="clear"></div>
		</div>
	
		<xsl:variable name="nazov" select="my:urlpostfix(title)" />
		
		
		<xsl:variable name="sstr">
			<xsl:if test="$q">?q=<xsl:value-of select="$q" /></xsl:if>
			<xsl:if test="not($q)"></xsl:if>
		</xsl:variable>
		
		<div class="postContent">
			<h2><a href="http://{user/nick}.{$base}/{@ID}-{$nazov}{$sstr}"><xsl:value-of select="title" /><xsl:if test="(string-length(subtitle) &gt; 0) and (string-length(subtitle) &lt; 100) ">: <xsl:copy-of select="subtitle/node()" /></xsl:if></a></h2>
			<xsl:choose>
				<xsl:when test="contains(content,'--break--')">
					<xsl:copy-of select="substring-before(content/node(),'--break--')" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="content/p">
						<div class="para searchhighlight">
							<xsl:variable name="preview" select="content/p[1]/node()" />
							<xsl:choose> 
								<xsl:when test="string-length(content/*[1]) &lt; 350">
									<xsl:copy-of select="content/p[1]" />
								</xsl:when>
								<xsl:otherwise>
									 <xsl:value-of select="substring(normalize-space(content/p[1]),1,250)" />...
								</xsl:otherwise>
							</xsl:choose>
						</div>
					</xsl:if>
					<xsl:if test="not(content/p)">
							<xsl:copy-of select="substring(content/node(),1,150)" />...
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<div class="clear"></div>
			<a href="http://{user/nick}.{$base}/{@ID}-{$nazov}" class="raquo"><xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'WholePost'"/>
			</xsl:call-template></a>
		</div>
		
		<div class="status">
			<span>
				<a href="http://{user/nick}.{$base}/"><xsl:value-of select="user/realName" /></a> |
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Views'"/>
				</xsl:call-template>: <span class="accesscount"><xsl:value-of select="@accessCount" /></span>
				|
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Reactions'"/>
				</xsl:call-template>: <span class="react"><xsl:value-of select="count(.//comment)" /></span>
				<xsl:if test="ranks/reputationScore > 0">
				| 
				 <xsl:call-template name="getString">
					 <xsl:with-param name="stringName" select="'Score'"/>
				 </xsl:call-template>: 
				 <xsl:value-of select="ranks/reputationScore" />
				</xsl:if>
			</span>
		</div>
	</div>
</xsl:template>
	
</xsl:stylesheet>