<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:my="http://blog.matfyz.sk"
	xmlns:func="http://exslt.org/functions"
	extension-element-prefixes="my func">

<xsl:template match="module[@name='Articles']">
	<div class="portlet articlePortlet">
		<!-- TODO - exportovat z articles.php parametre $loggedUser, $loggedUserID, $userID -->	
		<xsl:apply-templates match="newPosts/post[(@status='published') or ($loggedUser and $loggedUserID = $userID)]" />
	</div>
</xsl:template>

<xsl:template match="post">
	<div class="post">
		<div class="date">
			<xsl:if test="dateTop">
				<xsl:attribute name="class">date dateTop</xsl:attribute>
			</xsl:if>			
			<p>
				<xsl:if test="@lang">
					<img src="./css/flags/{@lang}.png" width="16" height="11" alt="{@lang} flag" class="flag"/>
					|
				</xsl:if>
				<span class="created">
					<xsl:value-of select="substring(date,9,2)" />.
					<xsl:value-of select="substring(date,6,2)" />.
					<xsl:value-of select="substring(date,1,4)" /><xsl:text> </xsl:text>
					<xsl:value-of select="substring(date,12,2)" />:<xsl:value-of select="substring(date,15,2)" />
				</span>
				<xsl:if test="lastUpdate">
					(<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Changed'"/>
					</xsl:call-template>: <xsl:value-of select="substring(lastUpdate,9,2)" />.
					<xsl:value-of select="substring(lastUpdate,6,2)" />.
					<xsl:value-of select="substring(lastUpdate,1,4)" /><xsl:text> </xsl:text>
					<xsl:value-of select="substring(lastUpdate,12,2)" />:<xsl:value-of select="substring(lastUpdate,15,2)" />)
				</xsl:if>
				<xsl:if test="dateTop">
					<span class="display_none"> | </span>
					<span class="markTopPost">
						<xsl:call-template name="getString">
							<xsl:with-param name="stringName" select="'topPost'"/>
						</xsl:call-template>
					</span>
					<img class="imageTopPost" src="./css/topPost.gif" alt="top post" title="top post" />
				</xsl:if>													
		</p>
		<div class="clear"></div>
	</div>
		<h2 class="posting"><div class="formatted"><xsl:value-of select="title" /></div></h2><!-- nazov clanku -->
		
		<div class="bordering"><xsl:value-of select="subtitle" /></div>
		
		<div>
			<xsl:element name="div">
				<xsl:if test="@type='xhtml'">
					<xsl:attribute name="class">xhtml</xsl:attribute>
				</xsl:if>
				<xsl:if test="not(@type)">
					<xsl:attribute name="class">formatted</xsl:attribute>
				</xsl:if>
				<xsl:copy-of select="content/node()" />
			</xsl:element>
			<a href="javascript:location.href='http://vybrali.sme.sk/submit.php?url='+encodeURIComponent(location.href)" title="vybrali.sme.sk" >
			<img src="http://zena.sme.sk/storm/imgs/toolbar/doasdf_c.gif" alt="pošli na vybrali.sme.sk" border="0"  /> Pošli článok do vybrali.sme.sk</a>
			<div class="clear"/>
			<div class="status">
				<span>
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Views'"/>
					</xsl:call-template>: <span class="accesscount"><xsl:value-of select="@accessCount" /></span>
					|
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Reactions'"/>
					</xsl:call-template>: <span class="react"><xsl:value-of select="count(.//comment)" /></span>
			 
					 <xsl:if test="ranks">
					| 
					 <xsl:call-template name="getString">
						 <xsl:with-param name="stringName" select="'Score'"/>
					 </xsl:call-template>: 
					 <xsl:value-of select="ranks/reputationScore" />
					</xsl:if>
					| <xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Vote'"/>
						</xsl:call-template>
						: <a href="./?type=vote&amp;postID={$postID}&amp;value=-1"><img src="css/votesmall-.png" height="12px" style="margin-right:10px"/></a>
					<a href="./?type=vote&amp;postID={$postID}&amp;value=1"> <img src="css/votesmall+.png" height="12px" /></a>
				</span>
			</div>
		</div>
	</div>
	<xsl:apply-templates select="comments"/>
</xsl:template>	










	
</xsl:stylesheet>