<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';

class Layout implements Portlet {
	
	public function init($params) {
	}
	
	public function getXML($params) {
		$data="";
		
		//pre rss nam netreba tieto informacie
		if ($params['type']=='rss')
			return "";
		
		//rozvrhnutie layoutu usera
		if (isset($params['userID'])) {
			
		}
		
		//blogView, postView - zoradenie portletov
		if (in_array($params['type'], array('postView', 'blogView', 'loginForm', 'vote')) && isset($params['userID'])) 
			$data = "
			<module name='Layout'>
				<portlet name='TagBrowser' col='2' row='1'/>
				<portlet name='Articles' col='2' row='2'/>
				<portlet name='Login' col='3' row='1'/>				
				<portlet name='PostActions' col='3' row='2'/>
				<portlet name='BestRated' col='3' row='3'/>
				<portlet name='MostRead' col='3' row='4'/>
			</module>
			";

		//userPosts - zoradenie portletov
		if (in_array($params['type'], array('userPosts', 'settingsForm', 'uploadForm')))
			$data = "
			<module name='Layout'>
				<portlet name='Upload' col='1' row='4'/>
				<portlet name='Settings' col='1' row='3'/>
				<portlet name='PostActions' col='1' row='2'/>
				<portlet name='Articles' col='1' row='1'/>
			</module>
			";
		
		if (in_array($params['type'], array('postForm')))
			$data = "
			<module name='Layout'>
				<portlet name='PostActions' col='1' row='1'/>
				<portlet name='TagCloud' col='1' row='2'/>
			</module>
			";

		//titulka - zoradenie portletov
		if (in_array($params['type'], array('portalView', 'search')))
			$data = "
			<module name='Layout'>
				<portlet name='Users' col='1' row='1'/>
				<portlet name='TagBrowser' col='2' row='1'/>
				<portlet name='Articles' col='2' row='2'/>
				<portlet name='Campaigns' col='3' row='1'/> 
				<portlet name='BestRated' col='3' row='2'/>
				<portlet name='MostRead' col='3' row='3'/>
				<portlet name='TagCloud' col='3' row='4'/>
			</module>
			";
		
		return $data;
	}
	
	public function getXSLlist($params) {
		$layout = array();
		if (in_array($params['type'], array('portalView', 'search', 'postView')))
			$layout = array('classes/modules/layout3Col.xsl');
	
		if ($params['type']=='rss')
			$layout = array('classes/modules/layoutRSS.xsl');
		
		if (in_array($params['type'], array('blogView', 'loginForm', 'vote')))
			$layout = array('classes/modules/layout2Col.xsl');
		
		if (in_array($params['type'], array('userPosts', 'settings')))
			$layout = array('classes/modules/layout1Col.xsl');
		
		if (in_array($params['type'], array('postForm')))
			$layout = array('classes/modules/layoutPostForm.xsl');
		
		return array_merge($layout);
	}
	
	public function getXSLParams($params) {
		return array('base'=>BASE, 'lang' => $_SESSION['session']->getLang(), 'user'=>$params['user'], 'q'=>$params['q']);
	}
}

$GLOBALS['controler']->registerPortlet(Layout);

?>
