<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:my="http://blog.matfyz.sk"
	xmlns:func="http://exslt.org/functions"
	extension-element-prefixes="my func">
<xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />	
<xsl:template match="/">

<html>
<head>
	<title><!-- TITLE pridat sem --></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta name="description" content="" /><!-- DESCRIPTION pridat sem -->
	<meta name="keywords" content="" /><!-- KEYWORDS pridat sem -->
	<link rel="stylesheet" href="./css/style.css" type="text/css" media="screen" />
	<link rel="stylesheet" href="./css/languages.css" type="text/css" media="screen" />
	<link rel="stylesheet" href="./css/main.css" type="text/css" media="screen" />
	
	<!-- rozne dizajny pre rozne stavy -->
	<!-- TODO prehodit toto rozhodovanie do articles.php -->
	<xsl:if test="$type='blogView' or $type='postView' or $type='loginForm'">
		<link rel="stylesheet" href="./css/style_2column_narrow.css" type="text/css" media="screen" />				
	</xsl:if>
	<xsl:if test="$type='userPosts' or $type='uploadForm' or $type='editPost' or $type='commentForm' or $type='addPost'">
		<link rel="stylesheet" href="./css/style_1column_wide.css" type="text/css" media="screen" />				
	</xsl:if>
	<xsl:if test="$type='settingsForm'">
		<link rel="stylesheet" href="./css/style_1column_narrow.css" type="text/css" media="screen" />				
	</xsl:if>	

	<!-- RSS LINKS pridat sem -->
	<!--
	<xsl:if test="$nick != ''">
		<link rel="alternate" href="http://{$nick}.{$base}/?type=rss" type="application/rss+xml" />
		<link rel="alternate" href="http://{$nick}.{$base}/?type=rss&amp;lang=en" type="application/rss+xml" />
		<link rel="alternate" href="http://{$nick}.{$base}/?type=rss&amp;lang=ensk" type="application/rss+xml" />
	</xsl:if>
	
	<link rel="alternate" href="http://{$base}/?type=rss" type="application/rss+xml" />
	<link rel="alternate" href="http://{$base}/?type=rss&amp;lang=en" type="application/rss+xml" />
	<link rel="alternate" href="http://{$base}/?type=rss&amp;lang=ensk" type="application/rss+xml" />
	-->
	<script type="text/javascript" src="ajax/preview.js"></script>
	<script type="text/javascript" src="ajax/tags.js"></script>
	<script type="text/javascript" src="ajax/sort.js"></script>
	<link rel="shortcut icon" href="./css/favicon.png"/>
	<script type="text/javascript" src="ajax/checkUserName.js" />
</head>
<body>
	
	<!-- design: white round corners -->
	<div class="wrap-t lt">
		<span class="rt">
			<span class="i"></span>
		</span>
	</div>

		<!-- design: header + content vystredeny -->
		<div class="wrap-env">
		<div class="wrap">
      
			<!-- design: black round corners -->
			<div class="wheader f1">
				<div class="l">
					<div class="t">
						<div class="b">
							<div class="r">
								<div class="lt">
									<div class="lb">
										<div class="rt">
											<div class="rb wmenu">
											
												<div id="header">	
													<!-- LOGO -->
													<div id="logo-wrapper"><h1 id="logo"><a href="http://{$base}">blog.matfyz.sk<span></span></a></h1></div>

													<!-- Google Analytics -->
													<script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script>
													<script type="text/javascript">
														_uacct = "UA-965430-2";
														urchinTracker();
													</script>
													
													<!-- LOGIN -->
													<xsl:apply-templates select="/output/module[@name='Login']" mode="top"/>
													
													<!-- SEARCHBOX -->
													<xsl:apply-templates select="/output/module[@name='Search']"/>
												</div>  
												
												<div id="menu"> 
													<div class="wmenu2">
														<div class="wmenu3">
															<div class="wmenu4">
																<div class="wmenuLeft">
																	<!-- LANGUAGE SELECTOR -->
																	<xsl:apply-templates select="/output/module[@name='Lang']"/>
																</div>
																<div class="wmenuRight">
																	<!-- MENU -->
																	<xsl:apply-templates select="/output/module[@name='Menu']"/>
																</div>
															</div>
														</div>
													</div>
												</div><!-- \\\END OF menu -->
															
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<!-- HEADER usera pridat sem -->
			</div>

			
			
			









<!-- 3 column layout-->
<div id="outer-column-container">
	<div id="inner-column-container">
		<div id="page-container">
			
			<!-- 3column design skidoo -->
			<div id="source-order-container">

				<!-- (1) MIDDLE COLUMN -->
				<div id="middle-column">
					<div class="inside">					
						<xsl:for-each select="output/module[@name='Layout']/portlet[@col='2']">
							<xsl:sort select="@row"/>
							<xsl:variable name="name" select="@name"/>
							<xsl:apply-templates select="/output/module[@name=$name]"/>
						</xsl:for-each>
					</div>
				</div>
				<!-- end of MIDDLE -->
				
				<!-- (2) LEFT COLUMN -->
				<div id="left-column">
					<div class="inside">
						<xsl:for-each select="output/module[@name='Layout']/portlet[@col='1']">
							<xsl:sort select="@row"/>
							<xsl:variable name="name" select="@name"/>
							<xsl:apply-templates select="/output/module[@name=$name]"/>
						</xsl:for-each>
					</div>
				</div>
				<!-- end of LEFT -->
				
				<div class="clear-columns"><!-- do not delete --></div>
			</div><!-- end of source-column-container - tento div spaja 1. + 2. div (middle+left) -->

			<!-- (3) RIGHT COLUMN -->
			<div id="right-column">
				<div class="inside">
					<xsl:for-each select="output/module[@name='Layout']/portlet[@col='3']">
						<xsl:sort select="@row"/>
						<xsl:variable name="name" select="@name"/>
						<xsl:apply-templates select="/output/module[@name=$name]"/>
					</xsl:for-each>
				</div>
			</div>
			<!-- end of RIGHT -->
			
			<div class="clear-columns"><!-- do not delete - needed for 3 column layout --></div>
		</div><!-- \\\END OF page-container -->																	
	</div><!-- \\\END OF source-order-container -->
</div><!-- \\\END OF outer-column-container -->
<!-- \\\END OF 3 column layout-->











				<div class="clear"></div>
			</div><!-- END OF wrap -->
		</div><!-- END OF wrap-env -->

	<!-- rounded corners - bottom of 3 column layout -->
	<div class="wrap-b lb">
		<span class="rb">
			<span class="i"></span>
		</span>
	</div>
	
	<!-- FOOTER start-->			
		
	<!-- rounded corners - top of footer -->
	<div class="wrap-t lt">
		<span class="rt">
			<span class="i"></span>
		</span>
	</div>
	<div class="wrap-env">
	<div class="wrap">
		<div class="f1">
			<div class="l">
				<div class="t">
					<div class="b">
						<div class="r">
							<div class="lt">
								<div class="lb">
									<div class="rt">
										<div class="rb">
											<div id="footer">
												<div id="footer-menu">
													<a href="http://{$base}"><img alt="blog.matfyz.sk" src="css/logo-160.png" width="160" height="55" /></a>
													<div>
														
														<!-- FOOTER MENU pridat sem-->
														
													</div>
												</div>
												
												<p>
													http://blog.matfyz.sk/
													<br />© <a href="http://team.matfyz.sk/">team matfyz.sk</a>, 2007-2010<br /><br />
													
													<!-- LANGUAGE SELECTOR 2 -->
													<xsl:apply-templates select="/output/module[@name='Lang']"/>
													
												</p>
												
												<div style="height:6px;font-size:0;clear:both;"></div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	</div><!--wrap-->
	
	<div class="wrap-b lb">
		<span class="rb">
			<span class="i"></span>
		</span>
	</div>
	<div>
		<a href="http://modis.ispras.ru/sedna/" title="Sedna, native XML database"><img src="/css/sedna_logo.gif" alt="Sedna" /></a>
	</div>				
	
	</body>
</html>



</xsl:template>

</xsl:stylesheet>