<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';
require_once 'classes/User.php';
require_once 'settings.php';
require_once 'classes/SimpleOpenID.php';
require_once 'classes/HookManager.php';


class Login implements Portlet {

	private $when=array('blogView', 'commentForm', 'loginForm', 'portalView', 'postForm', 'postView', 'registration', 'search', 'settingsForm', 'uploadForm', 'userPosts', 'vote');
	
	public function init($params) {
		$GLOBALS['hooks']->registerHook('logout', doLogout, $this);
		$GLOBALS['hooks']->registerHook('login', doLogin, $this);
	}
	
	public function doLogout($params){
		if ($_SESSION['session']->isLogged()) $_SESSION['session']->logout();
		if (isset($params['returnto']))
			redirect("http://wiki.matfyz.sk/ssid.php",array("next"=>$params['returnto']));
		else
			redirect("http://wiki.matfyz.sk/ssid.php",array("next"=>"http://".BASE));
	}
	
	public function doLogin($params){
		/* OpenID login */
		$openID_mode = array_key_exists("openid_mode",$params) ? $params['openid_mode'] : "";
		$openID_action = array_key_exists("openid_action",$_POST) ? $_POST['openid_action'] : "";

		if ($openID_action == "login") {
			$openid = new SimpleOpenID;
			$openid->SetIdentity($_POST['openid_url']);
			$openid->SetTrustRoot('http://' . $_SERVER["HTTP_HOST"]);
			$openid->SetRequiredFields(array('email','fullname'));
			$openid->SetOptionalFields(array('dob','gender','postcode','country','language','timezone'));

			if ($openid->GetOpenIDServer()){
				$openid->SetApprovedURL('http://' . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]);
				$openid->Redirect();
			} else {
				$error = $openid->GetError();
				$str = "ERROR CODE: " . $error['code'] . "<br>";
				$str .= "ERROR DESCRIPTION: " . $error['description'] . "<br>";
				die($str);
			}
		} else if ($openID_mode == "id_res") {
			$openid = new SimpleOpenID;
			$openid->SetIdentity($params['openid_identity']);
			$openid_validation_result = $openid->ValidateWithServer();
			if ($openid_validation_result == true) {
				$identity = substr($params['openid_identity'],strpos($params['openid_identity'],"//")+2);
				if ($_SESSION['session']->openIDlogin($identity)){
					//redirect("http://wiki.matfyz.sk/ssid.php",array("ssid"=>session_id(),"next"=>"http://".$_SESSION['session']->getUser()->getNick().".".BASE));
					redirect("http://wiki.matfyz.sk/ssid.php",array("ssid"=>session_id(),"next"=>$_POST['returnto']));
				}
			} else if ($openid->IsError() == true) {
				$error = $openid->GetError();
				$str = "ERROR CODE: " . $error['code'] . "<br>";
				$str .= "ERROR DESCRIPTION: " . $error['description'] . "<br>";
				die($str);
			} else {
				die("INVALID AUTHORIZATION");
			}
		} else if ($openID_mode == 'cancel') {
			die("USER CANCELED REQUEST");
		}
		/* Default login */
		if ($_SESSION['session']->login($_POST['user'],$_POST['password'])) {
			redirect("http://wiki.matfyz.sk/ssid.php",array("ssid"=>session_id(),"next"=>$_POST['returnto']));	//posielat session id v GET je nebezpecne.
		}
	}
	
	public function getXML($params) {
		$data="";
		if (in_array($params['type'], $this->when))
			if ($_SESSION['session']->isLogged()){
				$data="<module name='Login'>";
				$data.="<user ID='".$_SESSION['session']->getUser()->getID()."'>";
				$data.="<nick>".$_SESSION['session']->getUser()->getNick()."</nick>";
				$data.="<email>".$_SESSION['session']->getUser()->getEmail()."</email>";
				$data.="<realname>".$_SESSION['session']->getUser()->getRealName()."</realname>";
				$data.=$_SESSION['session']->getUser()->getUserPermissions();
				$data.="</user>";
				$data.="</module>";
			} else {
				$data="<module name='Login'>
					<user ID='0'>
					<permissions/>
					</user>
					</module>
					";
			}
		return $data;
	}
	
	public function getXSLlist($params) {
		if ($params['type']=='loginForm'){
			return array('classes/modules/login.xsl', 'classes/modules/loginForm.xsl');
		}
		if (in_array($params['type'], $this->when))
			return array('classes/modules/login.xsl');
		return array();
	}
	
	public function getXSLParams($params) {
		if ($params['type']=='loginForm')
			return array('base'=>BASE, 'returnto'=>$params["returnto"]);
		if (in_array($params['type'], $this->when))
			return array('base'=>BASE, 'returnto'=>"http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]);
		return array();
	}
}

$GLOBALS['controler']->registerPortlet(Login);

?>
