<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';
require_once 'classes/Filters.php';
require_once 'classes/SortQueries.php';

class MostRead implements Portlet {
	private $when=array('portalView', 'search');
	
	public function init($params) {
	}
	
	public function getXML($params) {
		$data="";
		if (in_array($params['type'], $this->when))
				$data = $this->getMostReadPosts($params, array(new PublishedFilter(), new LangFilter(), new TagFilter(), new AccessFilter()), new VisitorsSortQuery());
		return $data;
	}
	
	public function getXSLlist($params) {
		if (in_array($params['type'], $this->when))
			return array('classes/modules/mostRead.xsl');
		return array();
	}
	
	public function getXSLParams($params) {
		if (in_array($params['type'], $this->when))
			return array('base'=>BASE);
		return array();
	}
	
	private function getMostReadPosts($params, $filter, $sort, $count=10) {
		$xquery = '
			subsequence(
				(for $i in collection("weblog")/user/blog/post';
		foreach ($filter as $key=>$item)
			$xquery .= $item->getQuery($params);
				
		$xquery .='
				let $user := $i/ancestor::user
				';
		$xquery .= $sort->getQuery($params);
		$xquery .='
				return
				<post>{$i/@ID}{$i/@lang}{$i/@accessCount}
				<user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName}
				</user>
				{$i/title}
				{$i/subtitle}
				</post>)
			,1,'.$count.')';
		$result= $GLOBALS['system']->getDB()->fetchNode($xquery);
		//dumpxml($result);
		return '<module name="MostRead"><mostViewedPosts>'.$result.'</mostViewedPosts></module>';
	}
}

$GLOBALS['controler']->registerPortlet(MostRead);

?>