<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:my="http://blog.matfyz.sk"
	xmlns:func="http://exslt.org/functions"
	extension-element-prefixes="my func">

<xsl:import href="../../XSL/functions.xsl" />

<xsl:param name="postID"/>
<xsl:param name="user"/>
<xsl:param name="base"/>

<xsl:template match="module[@name='PostActions']">
    
<div class="portlet postFormPortlet">
	<input type="hidden" name="postID" value="{$postID}" />
	<fieldset>

	<div class="postFormSection">
		<label for="title" class="indentLabel"><xsl:call-template name="getString">
			<xsl:with-param name="stringName" select="'Title'"/>
		</xsl:call-template>: <xsl:call-template name="questionMark"/></label>
		<input type="text" name="title" id="title" class="input_large" value="{post/title}" onkeyup="checkPost(this.value)" />
		<br />

		<!-- Podnadpis -->	
		<!--
		<xsl:choose>
			<xsl:when test='string-length(/postView/post/subtitle)=0'>
				<div id="subtitleBox" class="disabled">
					<label for="subtitle" class="indentLabel"><xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Subtitle'"/>
					</xsl:call-template>? 
					<input type="checkbox" id="enableBox" onchange="enableMe(this)"/><xsl:call-template name="questionMark"/></label>
					<input type="text" name="subtitle" id="subtitle" class="input_large" value="" disabled="true" />
				</div>
			</xsl:when>
			<xsl:otherwise>
				<div id="subtitleBox" class="enabled">
					<label for="subtitle" class="indentLabel"><xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'Subtitle'"/>
					</xsl:call-template>?
					<input type="checkbox" id="enableBox" checked="checked" onchange="enableMe(this)"/></label>
					<input type="text" name="subtitle" id="subtitle" class="input_large" value="{/postView/post/subtitle}" />
				</div>
			</xsl:otherwise>
		</xsl:choose>
		-->
		
		<!--<xsl:copy-of select="string-length(/postView/post/subtitle/text())"></xsl:copy-of>-->
	
		<!--
		<xsl:if test="/postView/post/subtitle=''">
			<script type="text/javascript">
				enableMe(document.getElementById("enableBox"));
			</script>
		</xsl:if>
		<br />
		-->	
		
		<label for="language" class="indentLabel"><xsl:call-template name="getString">
			<xsl:with-param name="stringName" select="'Language'"/>
		</xsl:call-template>: <xsl:call-template name="questionMark"/></label>
		<select name="language" class="input_large">
			<xsl:element name="option">
				<xsl:attribute name="value">sk</xsl:attribute>
				<xsl:if test="post/@lang='sk'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
				slovenský
			</xsl:element>
			<xsl:element name="option">
				<xsl:attribute name="value">en</xsl:attribute>
				<xsl:if test="post/@lang='en' or ($Lang='en' and not(post/@ID))"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
				english
			</xsl:element>
		</select>
	</div>
				
	<div class="postFormSection">
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Preview'"/>
        </xsl:call-template><xsl:text> </xsl:text><xsl:call-template name="questionMark"/></h3>
        <div id="preview" class="preview">
          <xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'Preview'"/>
					</xsl:call-template>
        </div>
	<!--
        <div id="timeline"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'postSendTo'"/>
        </xsl:call-template><xsl:text> </xsl:text><iframe src="/renewSession.php" scrolling="no"/>//--><!--<xsl:value-of select="$timeout" />--><!--</div>//-->
        <label for="content"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'postText'"/>
        </xsl:call-template>: <xsl:call-template name="questionMark"/></label><br />
				
				<!-- ak ma post atribut type="xhtml" (cize bol pisany byvalym studentom) umozni zapnut XML editor -->				
				<!--
				<xsl:if test="/postView/post[@type='xhtml']">
					<script src="./xml_editor/prototype.js" type="text/javascript"></script>					
					<script src="./xml_editor/main.js" type="text/javascript" charset="utf-8"></script>
					<input type="checkbox" id="xml_editor_checkbox" onchange="change('article_content', 'xml_editor_checkbox');" />
					<xsl:call-template name="getString">
						<xsl:with-param name="stringName" select="'xmlEditorLabel'"/>
					</xsl:call-template>
				</xsl:if>
				-->
				
				<div id="article_content">
					<textarea id="postContent" name="postContent" class="megaBox" onkeyup="getPreview(document.getElementById('postContent').value)">
						<xsl:text> </xsl:text><xsl:copy-of select="post/content/node()" />
					</textarea>
				</div>
        <script type="text/javascript">update();</script>
		
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Hints'"/>
        </xsl:call-template><xsl:text> </xsl:text><xsl:call-template name="questionMark"/></h3>
				<table class="docuwikitable">
					<thead>
						<tr>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsWrite'"/>
							</xsl:call-template>:</th>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsView'"/>
							</xsl:call-template>:</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><kbd>**bold**</kbd></td>
							<td><strong>bold</strong></td>
						</tr>
						<tr>
							<td><kbd>//italic//</kbd></td>
							<td><em>italic</em></td>
						</tr>
						<tr>
							<td><kbd>[[http://matfyz.sk|<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsLink'"/>
							</xsl:call-template>]]</kbd></td>
							<td><a href="http://matfyz.sk">
								<xsl:call-template name="getString">
									<xsl:with-param name="stringName" select="'hintsLink'"/>
								</xsl:call-template>
							</a></td>
						</tr>
					</tbody>
				</table>
			
				<table class="docuwikitable">
					<thead>
						<tr>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsWrite'"/>
							</xsl:call-template>:</th>
							<th>
							<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsView'"/>
							</xsl:call-template>:</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><kbd>=====<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 2=====</kbd></td>
							<td><h3 class="noMargin"><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 2</h3></td>
						</tr>
						<tr>
							<td><kbd>====<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 3====</kbd></td>
							<td><h4 class="noMargin"><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 3</h4></td>
						</tr>
						<tr>
							<td><kbd>===<xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 4===</kbd></td>
							<td><h5 class="noMargin"><xsl:call-template name="getString">
								<xsl:with-param name="stringName" select="'hintsTitle'"/>
							</xsl:call-template> 4</h5></td>
						</tr>						
					</tbody>
				</table>
				<div class="clear"></div>
								
				<p>
          <xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'cutText1'"/>
          </xsl:call-template>
					<xsl:text> </xsl:text><strong>--break--</strong><xsl:text> </xsl:text>
					<xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'cutText2'"/>
          </xsl:call-template>
				</p>
        <ul>
          <li><a href="http://stettner.{$base}/p1-syntax-i">Syntax formátovania textu</a></li>
          <li><a href="http://stettner.{$base}/p3-syntax-ii">Zdrojové kódy - Zoznamy - Obsah</a></li>
          <li><a href="http://stettner.{$base}/p6-latex">Matfyzak bez latexu?</a></li>
        </ul>
				<div class="clear"></div>
	</div>

<!-- Kategorie -->	
<!--
	<div class="postFormSection">
	<p>
	<select name="topic1">
	  <option value="0">(Nezaradene)</option>
	  <xsl:for-each select="/postView/globalTopics/topic | /postView/topics/topic">
	  <option value="{@id}">
	    <xsl:if test="@id=/postView/post/topics/topic[1]/@id">
	      <xsl:attribute name="selected">selected</xsl:attribute>
	    </xsl:if>
	    <xsl:value-of select="name"/>
	    <xsl:if test="@scope='global'">
	    	(globalna kategoria) - prelozit
	    </xsl:if>
	  </option>
	  </xsl:for-each>
	</select>

	<select name="topic2">
	  <option value="0">(Nezaradene)</option>
	  <xsl:for-each select="/postView/globalTopics/topic">
	  <option value="{@id}">
	    <xsl:if test="@id=/postView/post/topics/topic[2]/@id">
	      <xsl:attribute name="selected">selected</xsl:attribute>
	    </xsl:if>
	    <xsl:value-of select="name"/>
	    <xsl:if test="@scope='global'">
	    	(globalna kategoria) - prelozit
	    </xsl:if>
	</option>
	</xsl:for-each>
	</select>

	</p>
	</div>//-->
      </fieldset>

	<div class="postFormSection">
      <div id="checkForm"><xsl:text> </xsl:text></div>
			<label for="private" style="padding-right: 1em; text-align:left;">
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'showPost'"/></xsl:call-template>:
			</label>
			<div>
				<input type="radio" name="postStatus" value="notPrivate">
					<!-- ak bude php overovanie radiobuttonov tak podmienku "or not(/postView/post/@ID)" vyhodit -->
					<xsl:if test="(post/@status='published' and not(post/@private='yes')) or not(post/@ID)">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'postStatusNotPrivate'"/></xsl:call-template>
				<xsl:text> </xsl:text>
				<xsl:call-template name="questionMark"/>
				
				<br />
				<input type="radio" name="postStatus" value="private">
					<xsl:if test="post/@status='published' and post/@private='yes'">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'postStatusPrivate'"/></xsl:call-template>
				<xsl:text> </xsl:text>
				<xsl:call-template name="questionMark"/>
				
				<br />
				<input type="radio" name="postStatus" value="asDraft">
					<xsl:if test="post/@status='draft'">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:call-template name="getString"><xsl:with-param name="stringName" select="'postStatusDraft'"/></xsl:call-template>
				<xsl:text> </xsl:text>
				<xsl:call-template name="questionMark"/>				
			</div>			



		
			<!-- Stary checkbox na "Zobraz iba na mojom blogu" -->
			<!--
			<input type="checkbox" name="private" value="1">
				<xsl:if test="/postView/post/@private='yes'">
					<xsl:attribute name="checked">checked</xsl:attribute>
				</xsl:if>
			</input>
			
			-->			
			<!-- Stary button -->
			<!--
			<input type="submit" name="status" id="status" class="submit" value="published" onclick="alert('jou');" />
			<input type="submit" name="status" class="submit" value="draft" />
			
			Save and publish
			Save as draft
			-->			
      
	</div>			
</div>
</xsl:template>

<xsl:template name="questionMark">
	<a href="http://saiffer.{$base}/post-p12545" title="What does it mean?" target="_blank">
		<xsl:attribute name="title">
			<xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'questionMark'"/>
			</xsl:call-template>
		</xsl:attribute>
		<img src="css/question_mark.gif" alt="question mark" class="question_mark" /></a>
</xsl:template>


</xsl:stylesheet>