<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';
require_once 'classes/User.php';
require_once 'settings.php';


class Settings implements Portlet {
	private $userID;

	public function init($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return;
		
		if (!$_SESSION['session']->getUser()->getUserPermissions('canEditOthersSettings')){
			$params['userID'] = $_SESSION['session']->getUser()->getID();
		}
		
		if (isset($_POST['saveSettings'])){
			$this->saveSettings($params);
		}
	}
	
	public function getXML($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return "";

		//tu generovat XML s postom pri edite
		$data="";
		
		switch($params['type']) {
			case "settingsForm": {
				if (!$_SESSION['session']->getUser()->getUserPermissions('canEditOthersSettings')){
					$params['userID'] = $_SESSION['session']->getUser()->getID();
				}
				$data = '<module name="Settings">';
				$data .= $this->getUserSettings($params);
				$data .= '</module>';
				break;
			}
		}
		return $data;
	}
	
	public function getXSLlist($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return array();
		
		switch($params['type']) {
			case "settingsForm": {
				return array('classes/modules/settings.xsl');
				break;
			}
		}
		return array();
	}
	
	public function getXSLParams($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return array();
		
		switch($params['type']) {
			case "settingsForm":{
				break;
			}
		}
		
		return array('base'=>BASE);
	}
	
	private function saveSettings($params){
		$user = new User($params['userID']);
		if (isset($_POST['email'])) $user->setEmail($_POST['email']);
		if (isset($_POST['openID'])) $user->setIdentity($_POST['openID']);
		if (isset($_POST['realName'])) $user->setRealName($_POST['realName']);
		if (isset($_POST['about'])) $user->setAbout($_POST['about']);
		if (isset($_POST['lastName'])) $user->setLastName($_POST['lastName']);
		if (isset($_POST['css'])) $user->setCSS($_POST['css']);
		if (isset($_POST['blogTitle'])) $this->setTitle($params, $_POST['blogTitle']);
		if (isset($_POST['enableStudentLayout']) && $_POST['enableStudentLayout'] == 'true') {
			$user->setTemplate('studentTemplate');
		} else {
			$user->setTemplate('test');	
		}
		if (array_key_exists("studentType",$_POST) && $_POST['studentType']=='on') $user->setUserType('student');
		if (!empty($_POST['newPassword']))
		if ($_POST['newPassword']==$_POST['newPasswordVerification'])
		$user->setPassword($_POST['newPassword'],$_POST['oldPassword']);
		else throw new Exception("Different passwords");
	}
	
	private function setTitle($params, $title) {
		$query = 'update replace $i in collection("weblog")/user[@ID="'.formatText($params['userID'], false).'"]/blog/title with <title>'.formatText($title).'</title>';
		$GLOBALS['system']->getDB()->fetchNode($query);
	} // end of member function setTitle
	
	private function getUserSettings($params)
	{
		$user = new User($params['userID']);
		if ($user->getTemplate() == 'studentTemplate') {$checked = 'true';} else {$checked = 'false';}      
		$xquery = '
			let $user:=collection("weblog")/user[@ID="'.$params['userID'].'"]
			return
			<settingsForm>
				{$user/blog/@css}    
				<userID type="{$user/@type}">'.$params['userID'].'</userID>
				<template checked="'.$checked.'">'.$user->whenWasStudent().'</template>
				{$user/info/*}     
				{$user/blog/title} 
			</settingsForm>';
		return $GLOBALS['system']->getDB()->fetchNode($xquery);    
	}
}

$GLOBALS['controler']->registerPortlet(Settings);

?>
