<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';
require_once 'classes/Filters.php';
require_once 'classes/SortQueries.php';

class TagCloud implements Portlet {

/*
TODO:

*/
	public function init($params) {
	}
	
	public function getXML($params) {
		$data="";
		switch ($params['type']) {
			case "vote":
			case "postView":{
				$data = '<module name="TagCloud">'. $this->getTagCloud($params, array(new ArticleFilter(), new UserFilter(), new PublishedFilter(), new LangFilter()), null).'</module>';
				break;
			}
			
			case "blogView":{
				$data = '<module name="TagCloud">'. $this->getTagCloud($params, array(new UserFilter(), new PublishedFilter(), new LangFilter()), null).'</module>';
				break;
			}
			case "search":
			case "portalView": {
				$data = '<module name="TagCloud">'. $this->getTitleTagCloud($params, array(new LangFilter()), null).'</module>';
				break;
			}
			case "postForm": {
				$data = '<module name="TagCloud">'.$this->getPostTags($params, array(new LangFilter(), new UserFilter()), null)."</module>";
				break;
			}
		}
		return $data;
	}
	
	public function getXSLlist($params) {
		switch ($params['type']) {
			case "vote":
			case "postView":
			case "blogView":
			case "search":
			case "portalView": {
				return array('classes/modules/tagCloud.xsl');
				break;
			}
			case "postForm":{
				return array('classes/modules/tagCloudPostForm.xsl');
				break;
			}
		}
		return array();
	}
	
	public function getXSLParams($params) {
		switch ($params['type']) {
			case "vote":
			case "postView":
			case "blogView":
			case "search":
			case "portalView": {
				return array('base'=>BASE);
				break;
			}
		}
		return array();
	}
	
	
	
	private function getTagCloud($params, $filter, $sort, $count=50) {
		$xquery ='let $tags := for $tags in collection("weblog")/user/blog/post';
		foreach ($filter as $key=>$item)
			$xquery .= $item->getQuery($params);	
		$xquery.='/tags,
				$tag in distinct-values($tags/tag),
				$tagCanonical in collection("weblog")/tags/tag[alt=$tag][normalize-space(data(@canonical))!=""]
                        return <tag id="{$tagCanonical/@id}">{normalize-space(data($tagCanonical/@canonical))}</tag>
			let $tags:=subsequence(
				(for 
					$tag in distinct-values($tags)
                        order by count($tags[.=$tag]) descending
                        return 
					<tag id="{subsequence($tags[.=$tag]/@id,1,1)}" count="{count($tags[.=$tag])}">{$tag}</tag>
				),1,'.$count.')
			let $maxTagCount := max($tags/@count)
			let $minTagCount := min($tags/@count)
			let $tagsResult:= for 
					$tag in $tags
                                  order by lower-case($tag/text()) ascending
                                  return  
				  	<tag percent="{(($tag/@count - $minTagCount)div ($maxTagCount - $minTagCount+1))}">{$tag/text()}</tag>
			return 
				$tagsResult
		';
	}

	private function getTitleTagCloud($params, $filter, $sort, $count=50) {
		$xquery = 'subsequence(
			    (for $tag in collection("weblog")/tags/tag';
				foreach ($filter as $key=>$item)
			$xquery .= $item->getQuery($params);
			$xquery .=
				'order by $tag/@strength
				return <tag strength="{$tag/@strength}">{data($tag/@canonical)}</tag>
			    ),1,50)
		';
		$result= $GLOBALS['system']->getDB()->fetchNode($xquery);
		return '<tagCloud>'.$result.'</tagCloud>';
	}
	
	private function getPostTags($params, $filter){
		$xquery = '
		let $tags:=
			for $tag in collection("weblog")/user/blog/post';
		
		foreach ($filter as $key=>$item)
			$xquery .= $item->getQuery($params);
		
		$xquery .= '/tags/tag,
		$canonical in collection("weblog")/tags/tag[alt=$tag]
				return
					<tag>{$tag}</tag>
		for $tag in distinct-values($tags)
			return <tag>{$tag}</tag>
		';
		$tags = $GLOBALS['system']->getDB()->fetchNode($xquery);
		
		$browser = new TagBrowser($this->params);
		if ($_SESSION['session']->isLogged()) {
				$userTags = $browser->getUserTags($_SESSION['session']->getUser()->getID());	 //nefunguje postView pre neprihlaseneho cloveka pretoze nema session - preto ta podmienka o riadok vyssie
		} else {				
				$userTags = $browser->getUserTags($params['userID']);
		}
		
		return '<tags>'.$tags.'</tags>
				<userTags>'.$userTags.'</userTags>';
	}
}

$GLOBALS['controler']->registerPortlet(TagCloud);

?>
