<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';
require_once 'classes/User.php';
require_once 'settings.php';


class Upload implements Portlet {
	private $userID;

	public function init($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return;
		
		if (!$_SESSION['session']->getUser()->getUserPermissions('canEditOthersSettings')){
			$params['userID'] = $_SESSION['session']->getUser()->getID();
		}
		
		if (isset($_POST['upload'])){
			$user = new User($params['userID']);
			$user->uploadFile($_FILES['file']['tmp_name'],$_POST['filename'],$_FILES['file']['name']);
		}
	}
	
	public function getXML($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return "";

		if (!$_SESSION['session']->getUser()->getUserPermissions('canEditOthersSettings')){
			$params['userID'] = $_SESSION['session']->getUser()->getID();
		}

		//tu generovat XML s postom pri edite
		$data="";
		
		switch($params['type']) {
			case "uploadForm": {
				$data = '<module name="Upload">';
				$data .= $this->getUserFiles($params);
				$data .= '</module>';
				break;
			}
		}
		return $data;
	}
	
	public function getXSLlist($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return array();
		
		switch($params['type']) {
			case "uploadForm": {
				return array('classes/modules/upload.xsl');
				break;
			}
		}
		return array();
	}
	
	public function getXSLParams($params) {
		//neprihlaseny? ani nas nezaujima
		if (!$_SESSION['session']->getUser()) return array();
		
		switch($params['type']) {
			case "uploadForm":{
				break;
			}
		}
		
		return array('base'=>BASE);
	}

	private function getUserFiles($params){
		$user = new User($params['userID']);
		$sum=0;
		$dir = "./files/".$user->getNick();
		$files = @scandir($dir);
		$filesXML="";
		unset($files[0]);
		unset($files[1]);
		if (is_array($files))
			foreach($files as $file){
				$filesize = filesize($dir.'/'.$file);
				$sum +=$filesize;
				$filesize = size_readable($filesize);
				$filesXML .="<file size=\"{$filesize}\">".formatText($file)."</file>";
			}

		$filesXML = "<userFiles size=\"".size_readable($sum)."\">".$filesXML."</userFiles>"; 

		$xquery = '
			let $user:=collection("weblog")/user[@ID="'.formatText($user->getID()).'"]
			return
				<uploadForm> {$user/blog/@css}
				<userID>'.formatText($this->userID).'</userID>
				{$user/info/*}
				{$user/blog/title}
				'.$filesXML.'
				</uploadForm>';
		return $GLOBALS['system']->getDB()->fetchNode($xquery);
	}
}

$GLOBALS['controler']->registerPortlet(Upload);

?>
