<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:my="http://blog.matfyz.sk"
	xmlns:func="http://exslt.org/functions"
	extension-element-prefixes="my func">

<xsl:import href="../../XSL/functions.xsl" />

<xsl:param name="base"/>

<xsl:template match="module[@name='Upload']">

<xsl:variable name="title" >
	<xsl:call-template name="getString">
		<xsl:with-param name="stringName" select="'uploadFiles'"/>
	</xsl:call-template>
</xsl:variable>
<xsl:variable name="blogTitle" select="uploadForm/title" />
<xsl:variable name="nick" select="uploadForm/nick" />
<xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />

<form  action="{$blogURL}/upload" method="post" enctype="multipart/form-data" class="frm">
	<input type="hidden" name="upload"/>
	<label for="file">
			<xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'file'"/>
			</xsl:call-template>:</label>
	<input type="file" name="file" /><br /><br />
	<label for="file">
			<xsl:call-template name="getString">
				<xsl:with-param name="stringName" select="'saveAs'"/>
			</xsl:call-template>:</label>
	<input type="input" name="filename" /><br /><br />
	<input type="submit" name="submit" id="submit" class="submit" value="Upload">
			<xsl:attribute name="value">
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'upload'"/>
				</xsl:call-template>
			</xsl:attribute>
		</input>
		<br />
</form>
<h3>
		<xsl:call-template name="getString">
			<xsl:with-param name="stringName" select="'yourFiles'"/>
		</xsl:call-template>
	</h3>
<table cellspacing="1" cellpadding="0" class="table">
	<thead>
	<tr>
		<th>
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'fileName'"/>
				</xsl:call-template>
				</th>
		<th>
				<xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'fileSize'"/>
				</xsl:call-template>
				</th>
	</tr>
	</thead>
	<tbody>
	<xsl:for-each select ="uploadForm/userFiles/file">
		<tr>
		<td><a href="{$blogURL}/{.}"><xsl:value-of select="." /></a></td>
		<td><xsl:value-of select="./@size" /></td>
		</tr>
	</xsl:for-each>
	</tbody>
	<tfooter>
	<tr>
		<td><xsl:call-template name="getString">
					<xsl:with-param name="stringName" select="'sum'"/>
				</xsl:call-template>:</td>
		<td><xsl:value-of select="uploadForm/userFiles/@size" /></td>
	</tr>
	</tfooter>
</table>

</xsl:template>

</xsl:stylesheet>