<?php

require_once 'classes/Session.php';
require_once 'classes/Controler.php';
require_once 'classes/Portlet.php';
require_once 'classes/Sedna.php';

class Users implements Portlet {
	
	private $when=array('portalView', 'search');
	
	public function init($params) {
	}
	
	public function getXML($params) {
		$data="";
		if (in_array($params['type'], $this->when))
			$data = $this->getNewUsers($params);
		return $data;
	}
	
	public function getXSLlist($params) {
		if (in_array($params['type'], $this->when))
			return array('classes/modules/users.xsl');
		return array();
	}
	
	public function getXSLParams($params) {
		if (in_array($params['type'], $this->when))
			return array('base'=>BASE);
		return array();
	}
	
	private function getNewUsers($params)
	{
		$xquery ='for $i in collection("weblog")/user
			let $lastName:=if ($i/info/lastName!="") then lower-case(translate($i/info/lastName/text(),"áéíóuýčďľĺňôřšťžÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ","aeiouycdllnorstzaeiouycdllnorstz"))
			else $i/info/nick/text(),
			$realName:=if ($i/info/realName!="") then $i/info/realName/text() else $i/info/nick/text()
			
			where count($i/blog/post[contains("'.$_SESSION['session']->getLang().'",@lang)])>0
			
			order by $lastName ascending
			return
			<user>      
		{$i/info/nick}
		{$i/info/email}
		<realName>{$realName}</realName>
		<lastName>{$lastName}</lastName>
			</user>';
		$result= $GLOBALS['system']->getDB()->fetchNode($xquery);
		return '<module name="Users"><newUsers>'.$result."</newUsers></module>";
	} // end of member function getNewUsers
}

$GLOBALS['controler']->registerPortlet(Users);

?>