<?php

/**
*  Nejak pomocne funkcie, ktore sa mozu casom presunut
**/

/** Autoload tried */
require_once "classes/Session.php";

/*function __autoload($className) {
	debug_print_backtrace();
	$file = CESTA ."classes/{$className}.php";
	if (file_exists($file))
	  require_once $file;
}*/

/** Veci */
function myIP() {
  return $_SERVER['REMOTE_ADDR'];
}
function UserAgent() {
  return isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : null;
}

/** Generator */
function generateID() {
  return "sess".md5(uniqid());
}

function getUserPermissions($param='') {
  if ($_SESSION['session']->isLogged())
  return $_SESSION['session']->getUser()->getUserPermissions($param);
}

/** Vytvorenie sedenia */
function makeSession($text = "", $restore = false)
{
  if ($restore && session_is_registered("session"))
    unset($_SESSION['session']);
  $newid = generateID();
  @session_start();
  if (!session_is_registered("session")) {
    session_destroy();
    session_id($newid);
    session_start();
    $_SESSION['session'] = new Session(session_id());
    if ($restore && $text)
      if (DEBUG) echo '<div style="color: red;">'.$text.'</div>' . "\n";
    if ($restore) redirect('http://'.BASE);
  } else checkSession();

}

/** Flawed secutiry **/
function checkSession() {
  try {
    // TODO: blocker default exception handler
    if (is_array($_SESSION) && array_key_exists("ip",$_SESSION) && $_SESSION['ip'] == myIP());
    else
      // throw new Exception("IP conflict. Restart your browser.");
      makeSession("IP conflict. Restarting session...", true);
    if (is_array($_SESSION) && array_key_exists("ua",$_SESSION) && $_SESSION['ua'] == UserAgent());
    else
      // throw new Exception("UserAgent conflict. Restart your browser.");
      makeSession("UserAgent conflict. Restarting session...", true);
    if (!ereg("^[[:alnum:]]+$", session_id()))
      // throw new Exception("Invalid sessionid format. Restart your browser.");
      makeSession("Invalid sessionid format. Restarting session...", true);
  } catch (Excetion $e) {
    session_destroy();
    makeSession($e->getMessage(), true);
  }

}

/** Presmerovanie stranky, ale len v pripade, ze cielova stranka je z nasho portalu,
 * alebo $outer == true.
 *
 * @param string $url Cielova stranka.
 * @param array $vars Parametre v poli pre GET.
 * @param boolean $outer Ak je true, tak cielova stranka musi byt doveryhodna.
 */
function redirect($url, $vars=false, $outer=false)
{
	if (is_array($vars))
	{
		$urlVars = Array();
		foreach ($vars as $key=>$value)
		{
      $urlVars[] = urlencode($key).'='.urlencode($value);
		}
		$url .= "?".implode("&",$urlVars);
	}
  if (!$outer && !preg_match('@^(https?:)?//([^\./]*\.)?(?:'.preg_quote(BASE, '@').'|wiki\.matfyz\.sk)(/.*)?$|^(?!([a-zA-Z0-9\+\-\.]+?:|//)).*$@', $url))
  {
    if (DEBUG) throw new Exception('Pouzitie tejto funkcie na redirekt mimo nas portal je z bezpecnostneho hladiska zakazane! (ciel="'.htmlspecialchars($url, ENT_QUOTES, 'utf-8').'")');
    $url = 'http://'.BASE;
  }
  if (DEBUG && $_GET['type']!='getFile') die('forced redirect to: <a href="'.htmlspecialchars($url, ENT_QUOTES, 'utf-8').'">'.htmlspecialchars($url, ENT_QUOTES, 'utf-8').'</a>');
  session_write_close();
  header("Cache-Control: no-cache, must-revalidate");
  header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  header("Location: {$url}");
  // Niektori boti nereaguju na header()
  $url =
	  '<meta http-equiv="refresh" content="5;url='.htmlspecialchars($url, ENT_QUOTES, 'utf-8').'" />' .
	  "\n" . $url;
  die($url);
}

/** Generator nahodnych hesiel **/
function makePassword($length)
{
  srand((double)microtime()*100000); 
  $znaky = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-";
  $string = "";
  do
  {
    $string .= substr($znaky, rand()%(strlen($znaky)),1);
  }
  while(strlen($string)< $length);
  return($string);
}

function sendMail($email, $subject, $content)
{
  require_once('mailer/class.phpmailer.php');
  $mailer = new PHPMailer();
  $mailer->From = "blogportal@matfyz.sk";
  $mailer->FromName = "Matfyz Blogportal";
  $mailer->AddAddress($email);
  $mailer->WordWrap = 50; // set word wrap to 50 characters
  $mailer->IsHTML(false); // set email format to HTML
  $mailer->Subject = $subject;
  $mailer->Body    = $content;
  if(!$mailer->Send()) throw new Exception("Unable to send mail");
}

function formatText($text, $escapeBraces = true) {
  if ($escapeBraces)
  {
    $text = str_replace("{",'{{',$text);
    $text = str_replace("}",'}}',$text);
  }
  $text = stripslashes($text);
  return trim(htmlspecialchars($text,ENT_QUOTES,"utf-8"));
}

function size_readable($size, $retstring = null)  {
  $sizes = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
  if ($retstring === null) { $retstring = '%01.2f %s'; }
  $lastsizestring = end($sizes);
  foreach ($sizes as $sizestring)
  {
    if ($size < 1024) { break; }
    if ($sizestring != $lastsizestring) { $size /= 1024; }
  }
  if ($sizestring == $sizes[0]) { $retstring = '%01d %s'; } 
  return sprintf($retstring, $size, $sizestring);
}

function my_highlighter($matches) {
  return '<span class="highlight">' . $matches[0] . '</span>';
}

function highlightKeywords($text, $keywords) {
  return $text;
}

/** Validatory **/
function isWF() {
   return
     ereg("^65\.61\.165\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^128\.30\.52\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^193\.51\.208\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^133\.27\.228\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^207\.234\.146\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^80\.190\.243\.77",$_SERVER["REMOTE_ADDR"])
     || ereg("^212\.100\.224\.155",$_SERVER["REMOTE_ADDR"]) 
     //total validator
     || ereg("^87\.194\.148\.98",$_SERVER["REMOTE_ADDR"])
     //achecker.ca
     || ereg("^142\.150\.154\.17",$_SERVER["REMOTE_ADDR"])
  ;
}

/** Preformatuje text na iba cisla, pismena, medzery **/
function formatSString($text) {
	$out = "";
	for ($i=0;$i<strlen($text);$i++) {
	  if (ereg("[[:alnum:]]", $text[$i]) || ereg("[[:space:]]", $text[$i]))
	    $out .= $text[$i];
	}
	return $out;
}

?>
