//alert('command loaded');

/* definujem strukturu na ukladanie akcie */
Command = function() {}
Command.prototype.description = "";
Command.prototype.modelFunction = function() {}
Command.prototype.modelUndo = function() {}
Command.prototype.viewFunction = function() {}
Command.prototype.viewUndo = function() {}

Command.prototype.undo = function() 
{
  this.modelUndo();
  this.viewUndo();
}

Command.prototype.redo = function() 
{
  this.modelFunction();
  this.viewFunction();	
}

CursorEditCommand = function(/*Nodes*/ cursorTag, /* string */ content)
{
  var me = this;
  this.args = arguments;
  this.description = "Vyroba text nody";
  
  var newText = document.createTextNode(content).template();
  newText.editable = true;
  newText.tag = newText.parentNode;  		
  this.parentN = cursorTag.parentNode;

  this.modelUndo = function() 
  { 
    me.parentN.model.removeChild(newText.model);
  } 

  this.modelFunction = function() 
  {
    me.parentN.model.insertBefore(newText.model, cursorTag.model);
  }

  this.viewUndo = function() 
  { 
    me.parentN.removeChild(newText);
    var sel = window.getSelection();
    document.controller.blurAllNodes();
    selCollapse(sel, cursorTag, 0);	
  }

  this.viewFunction = function() 
  {
    me.parentN.insertBefore(newText, cursorTag);
    var sel = window.getSelection();
    document.controller.blurAllNodes();
    selCollapse(sel, newText, 1);	
  }

}

CursorEditCommand.prototype = new Command();
/***************************/

TextAddCommand = function(cursorPlace, newContent) 
{
  var me = this;
  this.args = arguments;
  this.description = "Pridanie textu";

  this.novyText = newContent;
  this.cursorPlace = cursorPlace;
  
  this.modelUndo = function() 
  {
    me.novyModelParent.removeChild(me.novyModel);
  }
  
  this.modelFunction = function() 
  {
    me.novyModel = document.createTextNode(me.novyText);
    me.novyModelParent = me.cursorPlace.tag ? me.cursorPlace.tag: me.cursorPlace.previousSibling.tag;
    me.novyModelParent.appendChild(me.novyModel);
  }
  
  this.viewUndo = function() 
  {
    me.novySpanText.parentNode.removeChild(me.novySpanText);
    var sel = window.getSelection();
    selCollapse(sel, me.cursorPlace, 0);
  }
  
  this.viewFunction = function() 
  {
    me.novySpanText = me.novyModel.template(me.novyModel);
    var sel = window.getSelection();
  
    if (me.cursorPlace.deleteParent) // ak mame deleteparent znamena to ze vkladame pred 
    { 
      me.cursorPlace.parentNode.insertBefore(me.novySpanText, me.cursorPlace);
    } 
    else 
    {
      if(me.cursorPlace.nextSibling)
      {
        me.cursorPlace.parentNode.insertBefore(me.novySpanText, me.cursorPlace.nextSibling);
      }
      else
      {  	
        me.cursorPlace.parentNode.appendChild(me.novySpanText);
      }
    }  
    selCollapse(sel, me.novySpanText.firstChild, 1); 		
  }
}
TextAddCommand.prototype = new Command();

/*******************************************/  
/* editovanie textovej Node - nie zmazanie */  
TextEditCommand = function(/*span.text*/text, /*String*/oldContent, /*String*/newContent, /*int*/oldOffset, /*int*/ newOffset) // offset je offset selekcie
{
  var me = this;
  this.args = arguments;
  this.description = "Editácia textu";
  
  this.text = text;
  this.textNode = this.text.firstChild;
  
  this.modelUndo = function() 
  {
    me.text.model.nodeValue = me.args[1]; // oldContent
  }

  this.modelFunction = function() 
  {
    me.text.model.nodeValue = me.args[2]; // newContent
  }

  this.viewUndo = function() 
  {
    var sel = window.getSelection();
    me.args[0].textContent = me.args[1]; 		// oldContent
    // preco firstChild?, bo to musi byt TextNode inak to rata offset po Nodach a nie po znakoch
    // super bug - midas automaticky odstranuje textnodu ked je prazdna, kto vie preco
    // musime tam vlozit odlozenu
    if(!me.textNode) 
    {
      var node = textNode.cloneNode(true);
      node.nodeValue = "";
      me.text.appendChild(node);
    }
    selCollapse(sel, me.args[0].firstChild, me.args[3]); 	// oldOffset 
  }

  this.viewFunction = function() 
  {
    me.args[0].textContent = me.args[2]; // newContent
    //alert(me.args[0].className);
    var sel = window.getSelection();
    // super bug - midas automaticky odstranuje textnodu ked je prazdna, kto vie preco
    // musime tam vlozit odlozenu
    if(!me.textNode) 
    {
      var node = textNode.cloneNode(true);
      node.nodeValue = "";
      me.text.appendChild(node);
    }
    selCollapse(sel, me.text.firstChild, me.args[4]);	
  }

}
TextEditCommand.prototype = new Command();

/***************************/
/* zmazanie textovej Node  */
TextDeleteCommand = function(/*span.text*/text, /*Node*/newFocusNode, oldOffset) // offset je offset selekcie
{
  var me = this;
  this.args = arguments;
  this.description = "Zmazanie textu";
  
  this.text = this.args[0];
  var textNode = this.text.firstChild;
  var textParent = me.args[0].parentNode;
  var textNextSibling = me.args[0].nextSibling;  	
  var textModelParent = me.args[0].model.parentNode;
  var textModelNextSibling = me.args[0].model.nextSibling;
  var new_cursor = create_cursor(textParent);
  
  this.modelUndo = function() 
  {
    if(textModelNextSibling) 
    {
      textModelParent.insertBefore(me.args[0].model, textModelNextSibling);
    } 
    else 
    {
      textModelParent.appendChild(me.args[0].model);
    }	
  }

  this.modelFunction = function() 
  {
    textModelParent.removeChild(me.args[0].model);
  }

  this.viewUndo = function() 
  {
    textParent.insertBefore(me.args[0], textNextSibling);
    var sel = window.getSelection();
    // super bug - midas automaticky odstranuje textnodu ked je prazdna, kto vie preco
    // musime tam vlozit odlozenu
    if(!me.text.firstChild) 
    {
      var node = textNode.cloneNode(true);
      node.nodeValue = "";
      me.text.appendChild(node);
    }
    selCollapse(sel, me.args[0].firstChild, me.args[2]);
  }
  
  this.viewFunction = function() 
  {
    textParent.insertBefore(new_cursor, me.args[0]);
    textParent.removeChild(me.args[0]);
    //textParent.replaceChild(me.args[0], new_cursor);
    var sel = window.getSelection();
    selCollapse(sel, new_cursor/*me.args[1]*/, 0); 	
  }
}
TextDeleteCommand.prototype = new Command();

/*******************************************/  
/* editovanie atributovej Node - nie zmazanie */  
AttributeValueEditCommand = function(/*span.atributeValue*/text, /*String*/oldContent, /*String*/newContent, 
/*int*/oldOffset, /*int*/ newOffset) { // offset je offset selekcie
var me = this;
this.args = arguments;
this.description = "Editácia hodnoty atribútu";

this.text = this.args[0];
var textNode = this.text.firstChild;

this.modelUndo = function() {
var attribute = this.args[0].model;
var oldValue = this.args[1];
attribute.nodeValue = oldValue; // oldContent	
} 

this.modelFunction = function() {
var attribute = this.args[0].model;
var newValue = this.args[2];
attribute.nodeValue = newValue;
}

this.viewUndo = function() {
var sel = window.getSelection();
me.args[0].textContent = me.args[1]; 		// oldContent
// preco firstChild?, bo to musi byt TextNode inak to rata offset po Nodach a nie po znakoch
// super bug - midas automaticky odstranuje textnodu ked je prazdna, kto vie preco
// musime tam vlozit odlozenu
if(!me.text.firstChild) {
var node = textNode.cloneNode(true);
node.nodeValue = "";
me.text.appendChild(node);
}  	  
selCollapse(sel, me.args[0].firstChild, me.args[3]); 	// oldOffset 
}

this.viewFunction = function() {
me.args[0].textContent = me.args[2]; // newContent
var sel = window.getSelection();
// super bug - midas automaticky odstranuje textnodu ked je prazdna, kto vie preco
// musime tam vlozit odlozenu
document.controller.blurAllNodes();
if(!me.text.firstChild) {
var node = textNode.cloneNode(true);
node.nodeValue = "";
me.text.appendChild(node);
}
selCollapse(sel, me.text.firstChild, me.args[4]);	
}

}
AttributeValueEditCommand.prototype = new Command();

/***************************/
AttributeAddCommand = function(menoAtributu, replaceViewNode, modelOwnerElement, attributeValue) {
var me = this;
this.args = arguments;
this.description = "Pridanie atribútu";

var menoAtributu = menoAtributu;
var replaceViewNode = replaceViewNode;
var modelOwnerElement = modelOwnerElement;
var attributeValue = attributeValue == undefined ? "" : attributeValue;
var novyAtribut = document.createAttribute(menoAtributu); novyAtribut.nodeValue = attributeValue;
var novyAtributView = novyAtribut.template(novyAtribut); novyAtributView.model = novyAtribut;


this.modelUndo = function() {
modelOwnerElement.removeAttributeNode(novyAtribut);
}

this.modelFunction = function() {
modelOwnerElement.setAttributeNode(novyAtribut);
}

this.viewUndo = function() {
novyAtributView.parentNode.removeChild(novyAtributView);
replaceViewNode.blur();
selCollapse(window.getSelection(), replaceViewNode.firstChild, 0);
}
this.viewFunction = function() {
replaceViewNode.parentNode.insertBefore(novyAtributView, replaceViewNode);
//document.controller.blurAllNodes();
selCollapse(window.getSelection(), novyAtributView.firstChild.nextSibling.firstChild, 1); // preco fc.ns? lebo je to meno atributu
return novyAtributView;
}

}
AttributeAddCommand.prototype = new Command();

/***************************/
AttributeDeleteCommand = function(/*span.attribute*/text, /*Node*/newFocusNode, oldFocusNode, oldOffset) { // offset je offset selekcie
var me = this;
this.args = arguments;
this.description = "Zmazanie textu";
this.attributeLabel = me.args[0];
this.attributeModel = me.attributeLabel.model;
this.oldFocusNode = oldFocusNode;
this.oldOffset = oldOffset;
this.newFocusNode = newFocusNode;
this.ownerElement = me.attributeModel.ownerElement; // owner element sa strati kedze atribut vyberieme zo stromu
this.parentNode = me.attributeLabel.parentNode; // to iste plati aj pre parentNode
this.nextSibling = me.attributeLabel.nextSibling;

this.modelUndo = function() {
me.ownerElement.setAttributeNode(me.attributeModel);
}

this.modelFunction = function() {
me.ownerElement.removeAttributeNode(me.attributeModel);
}

this.viewUndo = function() {
me.parentNode.insertBefore(me.attributeLabel, me.nextSibling);

var sel = window.getSelection();
if(me.newFocusNode)
selCollapse(sel, me.oldFocusNode, me.oldOffset);
}
this.viewFunction = function() {
me.attributeLabel.parentNode.removeChild(me.attributeLabel);
var sel = window.getSelection();
if(me.newFocusNode)
selCollapse(sel, me.newFocusNode, 0); 	
}

}
AttributeDeleteCommand.prototype = new Command();

/*******************************************/  
/* editovanie atributovej Node - nie zmazanie */  
AttributeLabelEditCommand = function(/*span.atributeLabel*/attributeLabel, /*String*/oldContent, /*String*/newContent, 
/*int*/oldOffset, /*int*/ newOffset, newValue) { // offset je offset selekcie
var me = this;
this.args = arguments;
this.description = "Editácia mena atribútu";

this.attributeLabel = attributeLabel;
this.newModelContent = newContent.match(ATTRIBUTE_NAME_REGEX) ? newContent : VIEW_NAMESPACE + newContent;
this.newOffset = newOffset;
this.oldOffset = oldOffset;
this.attributeValue = attributeLabel.model.nodeValue;

var sel = window.getSelection();
var nfn = document.controller.findFirstEditableRight(me.attributeLabel.parentNode);
var oe = me.attributeLabel.parentNode.model.ownerElement;
var attribute = me.attributeLabel.parentNode;

if(!me.attributeValue) {
me.attributeValue = "";
}
var addCom = new AttributeAddCommand(me.newModelContent, attribute, oe, me.attributeValue);
var delCom = new AttributeDeleteCommand(attribute, sel.focusNode, sel.focusNode, me.oldOffset);  	  	

this.modelUndo = function() {
delCom.modelUndo();
addCom.modelUndo(); 
} 

this.modelFunction = function() {
addCom.modelFunction(); 
delCom.modelFunction();
}

this.viewUndo = function() {
delCom.viewUndo();
addCom.viewUndo();
var sel = window.getSelection();
selCollapse(sel, me.attributeLabel.firstChild, me.oldOffset); 
}

this.viewFunction = function() {
var a = addCom.viewFunction(); 
delCom.viewFunction();
var sel = window.getSelection();
selCollapse(sel, a.firstChild.nextSibling.firstChild, me.newOffset);
}

}
AttributeLabelEditCommand.prototype = new Command();

/*TempDeleteCommand = function(spanTemp) {
var me = this;
this.args = arguments;


}
TempDeleteCommand.prototype = new Command();*/

TempAddCommand = function(focusNode, offset) {
var me = this;
this.args = arguments;
this.description = "Zapnutie rozhrania pre pridávanie komponentov";

var focus = focusNode;
var focusNode = focusNode;
if (focusNode.nodeValue == null)
{ focusNode = focusNode.firstChild;}

var parent = focusNode.parentNode.parentNode;
var offset = offset;

var temp = new Temp();
var temp_node = temp.template(TEMP_NONE);
temp_node.model = temp;

var text = new Array();
text = split_text(focusNode.nodeValue, offset);

var text_before = document.createTextNode(text[0]).template();
//var text_beforeView = text_before.template(); 
//text_beforeView.model = text_before;

var text_after  = document.createTextNode(text[1]).template();
//var text_afterView = text_after.template(); 
//text_afterView.model = text_after;

function split_text(nodeText, offset)
{  		
var splited_text = new Array();

len = nodeText.length;

if (offset == 0)
{
splited_text[0] = '';
splited_text[1] = nodeText;
}
else if (offset == len)
{
splited_text[0] = nodeText;
splited_text[1] = '';
}
else
{
splited_text[0] = nodeText.substring(0, offset);
splited_text[1] = nodeText.substring(offset);
}

return splited_text;
}

this.modelUndo = function() {
parent.model.removeChild(text_before.model);
parent.model.replaceChild(focusNode.parentNode.model, text_after.model);
} 

this.modelFunction = function() {
parent.model.replaceChild(text_after.model, focusNode.parentNode.model);
parent.model.insertBefore(text_before.model, text_after.model);
}

this.viewUndo = function() {
parent.removeChild(text_before);
parent.removeChild(temp_node);
parent.insertBefore(focusNode.parentNode, text_after);
parent.removeChild(text_after);
var sel = window.getSelection();
selCollapse(sel, focusNode, offset);
}

this.viewFunction = function() {
parent.replaceChild(text_before, focusNode.parentNode);
parent.insertBefore(temp_node, text_before.nextSibling);
parent.insertBefore(text_after, temp_node.nextSibling);

var sel = window.getSelection();
selCollapse(sel, temp_node.firstChild, 0);
}  	

function hasChild(parent, child)
{
for (i = 0; i < parent.model.childNodes.length; i++)
{
if (parent.model.childNodes[i] == child.model)
{
return true;
}
}

return false;
}

}
TempAddCommand.prototype = new Command();

TempDeleteCommand = function(spanTemp) {
var spanTemp = spanTemp;
var spanTempParent = spanTemp.parentNode;

var spanTextFirstChild;
var spanTextLastChild;
var spanTextTempChild;
var spanNew;

this.viewUndo = function() {
if(spanTextTempChild && spanTextLastChild) {
spanTempParent.insertBefore(spanTextFirstChild, spanNew);
spanTempParent.insertBefore(spanTextTempChild, spanNew);
spanTempParent.insertBefore(spanTextLastChild, spanNew);

//alert(spanNew);
spanTempParent.removeChild(spanNew);

spanTemp = spanTextTempChild;
spanTempParent = spanTemp.parentNode;

var sel = window.getSelection();
selCollapse(sel, spanTextTempChild.firstChild.nextSibling.firstChild, 0);	  	
}	
}

function viewSplitText(_spanTextBefore, _offset) {
if(_offset == 0) {
return _spanTextBefore;
}

var _spanTextAfter = document.createDocumentFragment();
var t1 = document.createTextNode(_spanTextBefore.textContent.substring(0, _offset));
var t2 = document.createTextNode(_spanTextBefore.textContent.substring(_offset));
viewT1 = t1.template();
viewT2 = t2.template();
_spanTextAfter.appendChild(viewT1);
_spanTextAfter.appendChild(viewT2);
return _spanTextAfter;
}

function viewMergeText(t1, t2) {
//alert(t1 + "$" + t2);
t1.textContent += t2.textContent;
t2.parentNode.removeChild(t2);
return t1;		
}

this.viewFunction = function() {
var sel = window.getSelection();
if(spanTemp.previousSibling.text && spanTemp.nextSibling.text) { // ak je pred a za temp text zmerguj ho
spanTextFirstChild = spanTemp.previousSibling.cloneNode(true);
spanTextLastChild = spanTemp.nextSibling.cloneNode(true);
spanTextTempChild = spanTemp.cloneNode(true);
var offset = spanTemp.previousSibling.textContent.length; 
var node = viewMergeText(spanTemp.previousSibling, spanTemp.nextSibling);
selCollapse(sel, node.firstChild, offset);  	  	
}
spanTempParent.removeChild(spanTemp);

spanNew = node;
//alert(spanNew.textContent);
return spanNew;

//spanTempParent = _spanTempParent;*/  	    	 
} 

}
TempDeleteCommand.prototype = new Command();

/**********************************************************/

ElementDeleteCommand = function(/*Node*/oldFocusNode)
{
var me = this;
this.args = arguments;
this.description  = "Zmazanie elementu";
this.oldFocusNode = oldFocusNode;
this.next = oldFocusNode.model.nextSibling;
this.nextView = oldFocusNode.nextSibling;
this.childsModel = oldFocusNode.model.childNodes;
this.childsView = oldFocusNode.childNodes;

this.newFocusNode = document.controller.findFirstEditableLeft(me.oldFocusNode).parentNode; // najblizsi lavy surodenec 
this.model = oldFocusNode.model;
this.ownerElement = me.oldFocusNode.model.parentNode; // owner element sa strati kedze atribut vyberieme zo stromu
this.parentNode   = me.oldFocusNode.parentNode; // to iste plati aj pre parentNode

this.modelUndo = function() {
for (i = 0; i < me.childsModel.length; i++)
{
me.oldFocusNode.model.appendChild(me.childsModel[0]);
}

me.ownerElement.insertBefore(me.oldFocusNode.model, me.next.model);
}

this.modelFunction = function() {
me.ownerElement.removeChild(me.oldFocusNode.model);
}

this.viewUndo = function() 
{
for (i = 0; i < me.childsView.length; i++)
{
me.oldFocusNode.appendChild(me.childsView[0]);
}
me.parentNode.replaceChild(me.oldFocusNode, me.nextView);
var sel = window.getSelection();
if(me.newFocusNode)
{
selCollapse(sel, me.oldFocusNode, 0);
}
}

this.viewFunction = function() 
{
var sel = window.getSelection();
if(me.newFocusNode)
selCollapse(sel, me.newFocusNode, 0); 	
canSelect = false;
me.oldFocusNode.parentNode.removeChild(me.oldFocusNode);
}

}
ElementDeleteCommand.prototype = new Command();

/**********************************************************/

ElementAddCommand = function(menoElementu, replace, childs) {
var me = this;
this.args = arguments;
this.description = "Pridanie elementu";

this.menoElementu = menoElementu;
var replaceNode = replace;
this.childs = childs;

var modelOwnerElement = replaceNode.parentNode.model;
var model = replaceNode.nextSibling.model;
var parentNode = replaceNode.parentNode;

var novyElement = document.model.createElement(menoElementu);
var cursor = document.createTextNode('');
novyElement.appendChild(cursor);
var novyElementView = novyElement.template(novyElement); 

novyElementView.model = novyElement;

this.modelUndo = function() 
{
modelOwnerElement.replaceChild(model, novyElementView.model);
}

this.modelFunction = function() 
{
modelOwnerElement.insertBefore(novyElementView.model, model);
}

this.viewUndo = function() 
{
parentNode.replaceChild(replaceNode, novyElementView);

var sel = window.getSelection();
selCollapse(sel, replaceNode.firstChild, 0);
}

this.viewFunction = function() {
parentNode.replaceChild(novyElementView, replaceNode);

var sel = window.getSelection();
selCollapse(sel, novyElementView.firstChild.firstChild.nextSibling, 1);
}

}
ElementAddCommand.prototype = new Command();

/*******************************************/  
/* editovanie elementName Node - nie zmazanie */  
ElementValueEditCommand = function(/*Nodes*/ selectTagName, startTagName, endTagName, /*String*/oldContent, newContent, 
/*int*/oldOffset, /*int*/ newOffset) { // offset je offset selekcie
var me = this;
this.args = arguments;
this.description = "Editácia mena elementu";
this.startTagName = startTagName;
this.endTagName = endTagName;
this.selected = selectTagName;
this.textNode = this.selected.firstChild;

this.replaceEl = selectTagName.parentNode;

while (this.replaceEl.className != 'tag')
{
this.replaceEl = this.replaceEl.parentNode;
}

var newModelContent = newContent.match(ELEMENT_NAME_REGEX) ? newContent : VIEW_NAMESPACE + newContent;
var newElement = document.model.createElement(newModelContent).template();
var model = newElement.model;
var oldModel = me.startTagName.model;

this.childs = new Array();
this.attributes = new Array();

this.modelUndo = function() 
{
me.childs = model.childNodes;
me.attributes = model.attributes;
while (me.childs.length > 0)
{
var ch = me.childs[0];
oldModel.appendChild(ch);
}

for (i = 0; i < me.attributes.length; i++)
{
oldModel.setAttribute(me.attributes[i].nodeName, me.attributes[i].textContent);
}

me.replaceEl.model.parentNode.replaceChild(oldModel, model);

me.replaceEl.model = oldModel;
me.startTagName.model = oldModel;
me.endTagName.model = oldModel;
} 

this.modelFunction = function() 
{
me.childs = oldModel.childNodes;
me.attributes = oldModel.attributes;
for (i = me.childs.length - 1; i >= 0 ; i--)
{
var ch = me.childs[0];
model.appendChild(ch);
}

for (i = 0; i < me.attributes.length; i++)
{
model.setAttribute(me.attributes[i].nodeName, me.attributes[i].textContent);
}

me.replaceEl.model.parentNode.replaceChild(model, oldModel);

me.startTagName.model = model;
me.endTagName.model = model;
me.replaceEl.model = model;
}

this.viewUndo = function() {
me.startTagName.firstChild.nodeValue = oldContent;
me.endTagName.firstChild.nodeValue = oldContent;

var elName = getSelNode(me.selected);//me.selected.firstChild;
var sel = window.getSelection();
selCollapse(sel, elName, oldOffset); 
}

this.viewFunction = function() {
me.startTagName.firstChild.nodeValue = newContent;
me.endTagName.firstChild.nodeValue = newContent;

var elName = getSelNode(me.selected);
var sel = window.getSelection();
selCollapse(sel, elName, newOffset);
}

function getSelNode(node)
{
if (node.className.indexOf('meno') != -1)
{
return node.firstChild;
}

if (node.parentNode.className.indexOf('meno') != -1)
{
return node;
}

if ((node.className.indexOf('startTag el') > -1) || (node.className.indexOf('endTag el') > -1))
{
return getSelNode(node.firstChild);
}

var nnode = node;
while ((nnode.className.indexOf('meno') < 0))
{
nnode = nnode.nextSibling;
}
return nnode.firstChild;
}
}
ElementValueEditCommand.prototype = new Command();

/*******************************************/  
/* vytvaranie komentara */  
CommentAddCommand = function(/* text */newValue, /* node */replaceNode) 
{
var me = this;
this.args = arguments;
this.description = "Vyroba komentaru";
this.replace = replaceNode;
this.parent = replaceNode.parentNode;

var comment = document.createComment('  ').template();
//var commentView = comment.template(replaceNode.parentNode.model);
//commentView.model = comment;

var modelOwnerElement = replaceNode.parentNode.model;
var model = replaceNode.nextSibling.model;

this.modelUndo = function() 
{
modelOwnerElement.removeChild(comment.model);
} 

this.modelFunction = function() 
{
modelOwnerElement.insertBefore(comment.model, model);
}

this.viewUndo = function() 
{
me.parent.replaceChild(me.replace, comment);

var sel = window.getSelection();
selCollapse(sel, me.replace, 0);
}

this.viewFunction = function() {
me.parent.replaceChild(comment, me.replace);

var sel = window.getSelection();
selCollapse(sel, comment.firstChild/*.nextSibling.firstChild.firstChild*/, 1);
}
}

CommentAddCommand.prototype = new Command();

/*******************************************/  
/* vytvaranie komentara */  
CommentDeleteCommand = function(/* text */oldValue, /* node */commentNode) 
{
var me = this;
this.args = arguments;
this.description = "Vyroba komentaru";
this.comment = commentNode;
this.next = me.comment.nextSibling;

this.modelUndo = function() 
{
} 

this.modelFunction = function() 
{
}

this.viewUndo = function() 
{
me.parent.replaceChild(me.replace, commentView);

var sel = window.getSelection();
selCollapse(sel, me.replace, 0);
}

this.viewFunction = function() {
me.parent.replaceChild(commentView, me.replace);

var sel = window.getSelection();
selCollapse(sel, commentView.firstChild.nextSibling, 1);
}
}

CommentDeleteCommand.prototype = new Command();

/*******************************************/  
/* vytvaranie PI */  
ProcInstAddCommand = function(replaceNode) 
{
var me = this;
this.args = arguments;
this.description = "Vyroba komentaru";
this.comment = commentNode;
this.next = me.comment.nextSibling;

this.modelUndo = function() 
{
} 

this.modelFunction = function() 
{
}

this.viewUndo = function() 
{
}

this.viewFunction = function() 
{
}
}

ProcInstAddCommand.prototype = new Command();