//alert('controller loaded');

ShowModel = function(mmodel)
{
	var serializer = new XMLSerializer();
	this.model = mmodel;

	showModelF = function() 
	{
		alert(serializer.serializeToString(this.model));
		return false;    
	}
}

/*
* Model bude odvodeny od (xml) documentu
*/ 

Model = function(filename) 
{
	var me = this;
	this.parser = new DOMParser();
	this.doc = me.parser.parseFromString(filename, 'text/xml');
	this.async = false;
	//this.load(filename);

	function formTextNodes(curNode) 
	{
		for(var i=0; i<curNode.childNodes.length; i++) 
		{
			formTextNodes(curNode.childNodes.item(i));
		}

		if(curNode.nodeType != Node.TEXT_NODE) return;

		var s = curNode.textContent;
		var df = document.createDocumentFragment();
		var t = '';
		for(var i=0; i<s.length; i++) 
		{
			var ch = s.charAt(i); 
			if((ch == "\t")||(ch == "\n")) 
			{
				if(t != '') 
				{
					df.appendChild(document.createTextNode(t));
					t = '';
				}
				
				df.appendChild(document.createTextNode(ch));
			} 
			else 
			{
				t += s.charAt(i);	
			}
		}

		if(t != '') 
		{
			df.appendChild(document.createTextNode(t));
		}
		
		curNode.parentNode.insertBefore(df, curNode);
		curNode.parentNode.removeChild(curNode);	    
	}
	
	formTextNodes(this.doc);  	
}  

// UndoStack
UndoStack = function() 
{
	var commands = new Array();
	var vrch = -1; // index kde sa nachádza najvrchnejší command, - najprv ziadny

	this.add = function(/*Command*/command) 
	{
		if(vrch != commands.length - 1) 
		{ // ak pridame akciu po redo
			commands.splice(vrch+1,commands.length - vrch + 1);    		
		}
	
		commands.push(command);
		vrch++;
	} 

	this.setVrch = function(v) 
	{
		vrch = v;
	}

	this.getVrch = function() 
	{
		return vrch;
	}

	this.getLastCommand = function() 
	{
		return vrch >= 0 ? commands[vrch]: null;
	}

	this.undo = function() 
	{
		if(vrch >= 0) 
		{
			var c = commands[vrch];
			c.undo();
			vrch--;
		}
	}	

	this.redo = function() 
	{
		if(commands.length - 1 >= vrch + 1) 
		{
			vrch++;
			var c = commands[vrch];
			c.redo();
		}    	
	}
}

//  Controller
Controller = function() 
{  
	// eventy
	me = this;
	me.oldSelFocusNode = null;
	me.oldSelFocusOffset = null;
	me.firstSelFocusNode = null;
	me.firstSelFocusOffset = null;
	me.keyRepeat = 0; // kolkokrat bol autorepeat na key
	me.lastKeyRepeat = 0;
	
	this.events = new Object();
	this.events.keyPressKeyCode = null; // tu sa ulozi co sa stlacilo pri keypress enter sipka atd
	this.events.keyPressCharCode = null // pismenka, ciselka atd.
	this.events.focusNode = null;   // tu si pamatame poslednu selekciu
	this.events.focusOffset = null; // tu si pamatame poslednu selekciu

	var selDown, selPress;

	function findLeft(n) 
	{
		function findRightest(n) 
		{
			if(n.lastChild == null) 
			return n;

			return findRightest(n.lastChild);
		}

		if(n == null) return null; // ak uz nie je nic nalavo vrat null
		if(n.previousSibling) return findRightest(n.previousSibling);
		return findLeft(n.parentNode); 
	}

	function findRight(n) 
	{
		function findLeftest(n) 
		{
			if(n.firstChild == null) return n;

			return findLeftest(n.firstChild);
		}

		if(n == null) return null; // ak uz nie je nic napravo vrat null
		if(n.nextSibling) return findLeftest(n.nextSibling);
		return findRight(n.parentNode);  
	}  

	function addKeyboardShortcuts(e) 
	{
		var undoKey = e.ctrlKey && (String.fromCharCode(e.charCode).toLowerCase() == "z");
		var redoKey = e.ctrlKey && (String.fromCharCode(e.charCode).toLowerCase() == "y");
		var viewModel = e.ctrlKey && (String.fromCharCode(e.charCode).toLowerCase() == "q");
		var copyKey = e.ctrlKey && (String.fromCharCode(e.charCode).toLowerCase() == "c");
		var pasteKey = e.ctrlKey && (String.fromCharCode(e.charCode).toLowerCase() == "v");
		var cutKey = e.ctrlKey && (String.fromCharCode(e.charCode).toLowerCase() == "x");

		if(undoKey)
		{
			document.undoStack.undo();
			e.preventDefault();
		}
		
		if(redoKey)
		{
			document.undoStack.redo();
			e.preventDefault();
		}

		if(viewModel) 
		{
			document.model.showModel();
			e.preventDefault();
			e.stopPropagation();
			return false;
		}

		if(copyKey)
		{
			e.preventDefault();
		}
		
		if(cutKey)
		{
			e.preventDefault();
		}
		
		if(pasteKey)
		{
			e.preventDefault();
		}
	}

	// ked si klikneme na dokument alebo sa pohybujeme klavesnicou
	// keypress 
	function setSelection(event) 
	{
		var sel = window.getSelection();
		if(event.type == "mousedown") 
		{
			me.oldSelFocusNode = sel.focusNode;
			me.oldSelFocusOffset = sel.focusOffset;			
			return;
		}

		me.keyRepeat++;
		if(!me.firstSelFocusNode) 
		{
			me.firstSelFocusNode = sel.focusNode;
			me.lastKeyRepeat = 0;
		}	 
	
		if(!me.firstSelFocusOffset) 
    {
      me.firstSelFocusOffset = sel.focusOffset;
    }
	}

	function clearFirstSelection() 
	{
		me.oldSelFocusNode = me.firstSelFocusNode;
		me.oldSelFocusOffset = me.firstSelFocusOffset;
		me.firstSelFocusNode = null;
		me.firstSelFocusOffset = null;
	}

	function clearKeyRepeat() 
	{
		me.lastKeyRepeat = me.keyRepeat;
		me.keyRepeat = 0;
	}

	function simulateBlur(event) 
	{	
		function setChildBlur(n) 
		{
			if(n) 
			{
				for(var i=0; i<n.childNodes.length; i++) 
				{
					if(n.childNodes[i].onblur) 
					{
						n.childNodes[i].onblur(event);
					}
					
					setChildBlur(n.childNodes[i]);
				}
			}
		}	

		function setParentBlur(n) 
		{
			if(n) 
			{	
				var par = n.parentNode; 
				if(par) 
				{
					if(par.onblur) 
					{ 
						par.onblur(event);
					}  
					
					setParentBlur(par.parentNode);
				}
			}	
		}				

		var sel = window.getSelection();
		if(sel.focusNode != me.oldSelFocusNode) 
		{
			var node = me.oldSelFocusNode;
			// bubleme event
			setChildBlur(node);
			setParentBlur(node);
		}
	}

	this.events.onfocus = function() 
	{
		document.designMode = "on";
	}

	this.blurAllNodes = function(e) 
	{
		function blurAll(node) 
		{
			if(node.onblur) 
			{
				node.onblur(e);
			}
			
			for(var i = 0; i<node.childNodes.length; i++) 
			{
				blurAll(node.childNodes[i]);
			}
		}
		
		var sel = window.getSelection();
		blurAll(document.documentElement);		
	}

	this.events.onblur = function(e) 
	{
		me.blurAllNodes(e);
	}

	for(property in this.events) 
	{
		if(property.indexOf('on') == 0) 
		{
			var action = property.substr(2); 
			document.addEventListener(action, this.events[property], false);
		}
	}

	function callKeyHandlers(e) 
	{
		var sel = window.getSelection();
		var node = sel.focusNode;
		// zavolaj specificke handlery
		if(node.onkeypress) 
		{ 
			node.onkeypress(e);
		}

		if(node.parentNode && node.parentNode.onkeypress)
		{ 
			node.parentNode.onkeypress(e);
		}
		// zavolaj vseobecne handlery

		if(node.parentNode && node.parentNode.cursorPlace) 
		{ 
			cursorPlaceOnkeypress(e, node.parentNode);
		}
	}

	this.findFirstEditableLeft = function(node) 
	{
		var left = findLeft(node);
		if(left) 
		{
			if(left.parentNode.editable == false)	return me.findFirstEditableLeft(left);
			return left;
		}
		return null;
	}

	this.findFirstEditableRight = function(node) 
	{
		var right = findRight(node);
		if(right) 
		{
			if(right.parentNode.editable == false) return me.findFirstEditableRight(right);
			return right;
		}
		return null;
	}

	function whereToJumpLeft(currentNode) 
	{
		var node = currentNode;
		var left = me.findFirstEditableLeft(node);
		var lefter = me.findFirstEditableLeft(left);
		var realLeft = findLeft(node);
		var realLefter = findLeft(left);
		var node = left;

		if(left == null) return null;

		if(left && lefter) 
		{
			// ak su dve prazdne vedla seba skoc do lavej
			if(left.parentNode.cursorPlace && realLefter.parentNode.cursorPlace)
			{
				node = realLefter;
			}
			
			// ak sme na prechode z textu tj. nalavo je cursorPlace, skoc do najblizsej editovatelnej za cursorPlace
			if(currentNode.parentNode.text && left.parentNode.cursorPlace) 
			{
				if(lefter.parentNode.linebreak) // ak sme na prechode riadkov zostan na nom
				{
					node = left;
				}
				else
				{
					node = lefter;
				}  
			}
			 
			// ak sme na prechode do textu tj nalavo je cursorPlace a za nim text skoc do textu  
			if(left.parentNode.cursorPlace && realLefter.parentNode.text) 
			{
				node = realLefter;
			}
			
			// ak sme v cursorPlace a nalavo je cursorSpace nechod do nej
			if(currentNode.parentNode.cursorPlace && realLeft.parentNode.cursorPlace) 
			{
				node = lefter;
			}   
		}
		return node;   			
	}

	function whereToJumpRight(currentNode) 
	{
		var node = currentNode;
		var right = me.findFirstEditableRight(node);
		var righter = me.findFirstEditableRight(right);
		var realRight = findRight(node);
		var realRighter = findRight(right); // pravy od right /editovatelneho praveho/

		node = right;

		if(right == null) 
		{
			return null;
		}

		if(right && righter) 
		{
			// ak su dve prazdne vedla seba skoc do pravej
			if(right.parentNode.cursorPlace && realRighter.parentNode.cursorPlace)
			{
				node = realRighter;
			}
			
			// ak sme na prechode z textu tj. napravo je cursorPlace, skoc do najblizsej editovatelnej za cursorPlace
			if(currentNode.parentNode.text && right.parentNode.cursorPlace) 
			{
				node = righter;
			}
			 
			// ak sme na prechode do textu tj napravo je cursorPlace a za nim text skoc do textu  
			if(right.parentNode.cursorPlace && realRighter.parentNode.text) 
			{
				node = realRighter;
			}
			
			// ak sme v cursorPlace a napravo je cursorPlace tak ju preskoc
			if(currentNode.parentNode.cursorPlace && realRight.parentNode.cursorPlace) 
			{
				node = righter;
			}   
		}
		return node;			
	}
	
	function fixPageUpDown(e) 	
	{
		if(e.ctrlKey) return;
		
		if((e.keyCode == e.DOM_VK_PAGE_UP) || (e.keyCode == e.DOM_VK_PAGE_DOWN)) 
		{
			var sel = window.getSelection();
			
			if(sel.focusNode.parentNode.editable) return;

			var leftDis = distanceLeft(sel.focusNode, sel.focusOffset);
			var rightDis = distanceRight(sel.focusNode, sel.focusOffset);
			var dolava = leftDis < rightDis; 

			if(dolava) 
			{
				var node = whereToJumpLeft(sel.focusNode);
			} 
			else 
			{
				var node = whereToJumpRight(sel.focusNode);
			}

			var offset = dolava ? node.textContent.length : 0;
			selCollapse(sel, node, offset);

			e.preventDefault();
		}	
	}

	function fixHomeEnd(e) 
	{
		if(e.keyCode == e.DOM_VK_HOME) 
		{
			var sel = window.getSelection();
			// ctrl + home funguje dobre
			if(e.ctrlKey) return;
		
			var where = me.findFirstEditableLeft(sel.focusNode);
			
			// strasny hack; ale skakalo to do predchadzajuceho riadku
			where = whereToJumpRight(where);
			// koniec strasneho hacku
			
			selCollapse(sel, where, 0);			
			e.preventDefault();
		}

		if(e.keyCode == e.DOM_VK_END) 
		{
			var sel = window.getSelection();

			// ctrl + end funguje dobre
			if(e.ctrlKey) return;

			var where = me.findFirstEditableLeft(sel.focusNode);
			if(!where.parentNode.linebreak)
			{
				var where = me.findFirstEditableRight(sel.focusNode);
			}

			selCollapse(sel, where, where.textContent.length);
			e.preventDefault();
		}		
	}

	function fixLeftRightArrows(e) 
	{
		if(e.keyCode == e.DOM_VK_LEFT) 
		{
			// najdi najblizsieho najpravsieho lista nalavo ;)
			var sel = window.getSelection();
			var currentNode = sel.focusNode;
			var offset = sel.focusOffset;    		
			if(offset == 0) 
			{
				var node = currentNode;
				node = whereToJumpLeft(node);

				if(node == null) 
				{
					e.preventDefault();
					return;
				} 	
		
				var carretOffset = node.textContent.length;
				selCollapse(sel, node, carretOffset);
				e.preventDefault();
			}  
			
			if (node == null) 
			{
				node = currentNode;
			} 

			curPos = getCount(node, offset);
		}

		if(e.keyCode == e.DOM_VK_RIGHT) 
		{
			// najdi najblizsieho najlavsieho lista napravo ;)
			var sel = window.getSelection();
			var currentNode = sel.focusNode;
			var offset = sel.focusOffset;    		
			if (offset == sel.focusNode.textContent.length) 
			{
				var node = whereToJumpRight(currentNode);
				if(node == null) 
				{
					e.preventDefault();
					return;
				}

				var carretOffset = 0;
				selCollapse(sel, node, carretOffset);
				e.preventDefault();	
			}
	
			if (node == null) {node = currentNode;}
			curPos = getCount(node, offset);  	
		}
	}

	function distanceLeft(sourceNode, sourceOffset) 
	{	
		var leftNode = me.findFirstEditableLeft(sourceNode);
		var toLeft = sourceNode.textContent.substring(0,sourceOffset).length;
		var left = sourceNode;

		while ((left = findLeft(left)) != leftNode) 
		{
			if (left.textContent != null)
			{
				toLeft += left.textContent.length;
			}      		  	
		}  	

		return toLeft;
	}

	function distanceRight(sourceNode, sourceOffset) 
	{
		var rightNode = me.findFirstEditableRight(sourceNode);
		var toRight = sourceNode.textContent.substring(sourceOffset).length;
		var right = sourceNode;
		
		while ((right = findRight(right)) != rightNode) 
		{
			toRight += right.textContent.length;      		  	
		}
		  	
		return toRight;
	}

	function fixClick(e) 
	{
		var sel = window.getSelection();
		var node = sel.anchorNode;
		var offset = sel.anchorOffset;

		canSelect = true;
		if (node.nodeValue == null)
		{ 
			canSelect = false; 	
		}

		if (offset == 0) return;
		curPos = getCount(node, offset);
		
		if(node.parentNode.editable != false) return;

		var leftNode = me.findFirstEditableLeft(node);
		var rightNode = me.findFirstEditableRight(node);
		var toLeft = distanceLeft(node, offset);
		var toRight = distanceRight(node, offset); 	
		var doprava = (toRight < toLeft) && (node.parentNode.linebreak);
		node = doprava ? rightNode : leftNode;

		/*
		if(doprava) 
		{ 
			node = whereToJumpRight(node);
		} 
		else 
		{ 
			node = whereToJumpLeft(node);
		}
		
		if(doprava) // ak ideme doprava podme vzdy do najpravsej vhodnej nody
		{
			if(node.parentNode.outter) 
			{
				var right = findRight(node);
				if(right && (right.parentNode.outter || right.parentNode.text)) 
				{ 
					node = right;
				}
			} 	
		} 
		else 
		{
			if(node.parentNode.outter) 
			{
				var left = findLeft(node); 
				if(left && (left.parentNode.outter || left.parentNode.text)) 
				{ 
					node = left;
				}
			}      		  	
		}
		*/


		var carretOffset = doprava ? 0 : node.textContent.length;
		selCollapse(sel, node, carretOffset);
		e.preventDefault();	
	}

	function fixUpDownArrows(e) 
	{
		if((e.keyCode == e.DOM_VK_UP) || (e.keyCode == e.DOM_VK_DOWN)) 
		{ 
			// najdi najblizsieho najlavsieho lista napravo ;)
			var sel = window.getSelection();
			var currentNode = sel.focusNode;
			var offset = sel.focusOffset; 		

			//ako daleko je od zaciatku
			count = getCount(currentNode, offset);
			//end = currentNode;
			//start = (currentNode.parentNode.className == 'linebreak') ? findLeft(currentNode) : currentNode;
			start_node = currentNode;

			/*
			while (end.parentNode.className != 'linebreak')
			{ 
				end = findRight(end);
			}
	
			lineCount = getCount(findLeft(end));*/

			ok = true;
		//if (curPos < lineCount)
		//{
				if (count < curPos)
				{
					while ((ok) && (count < curPos))
					{
						count += trim(start_node.nodeValue).length;
						debuging(count + ' / ' + curPos + ' --- ' + start_node.nodeValue);
					/*	if (findRight(start))
						{
							start = findRight(start);
						}	
						else 
						{
							ok = false;
						}*/
					} 
				}
				else if (count > curPos)
				{
					while ((count > curPos) && (ok))
					{	
						count -= trim(start_node.nodeValue).length;
						debuging(count + ' / ' + curPos + ' --- ' + start_node.nodeValue);
						/*if (findLeft(start) != null)
						{
							start = findLeft(start);
						}
						else 
						{
							ok = false;
						} */
					}
				}
		/*}
			else 
			{ 
				start = end;
			}
		*/
			currentNode = start_node; 
	
			if(currentNode.parentNode.editable == false) 
			{
				var node = currentNode;
				var leftNode = me.findFirstEditableLeft(node);
				var rightNode = me.findFirstEditableRight(node);
				var toLeft = distanceLeft(node, offset);
				var toRight = distanceRight(node, offset); 
				var doprava = (toRight < toLeft) && (currentNode.parentNode.linebreak);
				node = doprava ? rightNode : leftNode;

				if(doprava) 
				{ // ak ideme dolava podme vzdy do najlavsej vhodnej nody
					if(node.parentNode.outter) 
					{
						var right = findRight(node);
						if(right && (right.parentNode.outter || right.parentNode.text)) 
						{
							node = right;
						}
					} 	
				} 
				else 
				{
					if ((node != null) && (node.parentNode.outter)) 
					{
						var left = findLeft(node); 
						if(left && (left.parentNode.outter || left.parentNode.text)) 
						{
							node = left;
						}
					}      		  	
				}

				var carretOffset = (doprava) ? 0 : node.textContent.length;
				selCollapse(sel, node, carretOffset);
				e.preventDefault();
			}	
		} 
	}

	// pocitanie pozicie
	function getCount(curNode, offset)
	{
		var from = curNode;
		var node = '¶';
		var count = offset;
	
		if (from.parentNode.className.indexOf('attributeValue') != -1)
		{
			count += 2;
			from = findLeft(from);
		}
	
		while ((from != null) && ((from.nodeValue != node) || (from.className != 'linebreak')))
		{                 
			par = from.parentNode;
			
			if (from.nodeValue != null) 
			{
				count += trim(from.nodeValue).length;
			}
	    
			if (par.className == undefined) 
			{
				par.className = '';
			}  
			
			if (par.className == 'tabulator' || par.className.indexOf('endTagSpaceBefore') != -1) 
			{ 
				count += 2; 
			}
			else if (par.className.indexOf('startTagSpaceBefore') != -1 || 
				par.className.indexOf('startTagSpaceAfter') != -1 || par.className.indexOf('endTagSpaceAfter') != -1) 
			{
				count += 1;
			}
			else if (par.className.indexOf('attributeValue') != -1)
			{
				count += 3;
			}               
			// plus 3 ak skoci do hodnoty attributu
			
			debuging(par.className + ' - ' + par.nodeValue + ' - '  + par.textContent + ' - ' + count);
			from = findLeft(from);
			if (from.className.indexOf('cursorPlace') != -1)
			{
         from = findLeft(from);
      }
		}
	
    return count;
	}

	function simulateFocus(event) 
	{
		function setParentFocus(n) 
		{
			if(n) 
			{	
				var par = n.parentNode; 
				if(par) 
				{
					if(par.onfocus) 
					{ 
						par.onfocus(event);
					}  

					setParentFocus(par.parentNode);
				}
			}	
		}

		function setChildFocus(n) 
		{
			if(n) 
			{
				for(var i=0; i<n.childNodes.length; i++) 
				{
					if(n.childNodes[i].onfocus) 
					{
						n.childNodes[i].onfocus(event);
					}
					
					setChildFocus(n.childNodes[i]);
				}
			}
		}

		var sel = window.getSelection();
		var node = sel.focusNode;
		
		// zavolame focus pre aktualnu Node
		if(node) 
		{
			if(node.onfocus) 
			{
				node.onfocus(event);
			}
		}
		
		// bubleme event smerom nahor
		setParentFocus(node);
		// bubleme event smerom nadol
		setChildFocus(node);
	}

	/*
	function simulateBlur(event) 
	{
		var podstromKoren;

		function distributeBlur(root) 
		{
			for(var i=0; i<root.childNodes.length; i++) 
			{
				var child = root.childNodes[i];
				if(child != podstromKoren) 
				{
					if(child.onblur) 
					{
					//child.onblur(event);
					}  
				}
				distributeBlur(child);
			}
		}

		var sel = window.getSelection();
		var selNode = sel.focusNode;
		
		// hladame syna documentElementu, ktory ma v podstrome selNode
		// prenho nebudeme volat onblur
		podstromKoren = selNode;

		while(podstromKoren.parentNode != document.body) 
		{
			podstromKoren = podstromKoren.parentNode;
		}		

		// bubleme event
		var node = document.body; 
		distributeBlur(node);
	}
	*/
	
	//key up
	document.addEventListener('keyup', clearFirstSelection, false);
	document.addEventListener('keyup', clearKeyRepeat, false);
	document.addEventListener('keyup', simulateBlur, false);
	document.addEventListener('keyup', fixPageUpDown, false);
	document.addEventListener('keyup', fixHomeEnd, false);
	document.addEventListener('keyup', fixUpDownArrows, false);
	document.addEventListener('keyup', simulateFocus, false);
	
	//keypress
	document.addEventListener('keypress', addKeyboardShortcuts, false);
	document.addEventListener('keypress', setSelection, false);
	document.addEventListener('keypress', callKeyHandlers, false);
	document.addEventListener('keypress', fixLeftRightArrows, false);
	
	//mouse down
	document.addEventListener('mousedown', setSelection, false);
	
	//click
	document.addEventListener('click', simulateBlur, false);
	document.addEventListener('click', fixClick, false);
	document.addEventListener('click', simulateFocus, false);
}