/**
 * Editor
 * @param {type} area 
 */
 var Consts = {
   EDITOR_ID: "editor",
   EDITOR_FRAME_SRC: "frame.html"
 }
 
var BASE = './xml_editor/';
var editor;
var checkbox_id_global = '';
var textarea_id_global = '';
 
function change(id, checkbox_id)
{
	checkbox_id_global = checkbox_id;
	textarea_id_global = id;
	var check = $(checkbox_id);
	var to_editor = check.checked;
	
	if (to_editor)
	{
		// kontrola ci ma firefox		
		var browser = navigator.userAgent;
		if (browser.indexOf('Firefox') > 0)
		{
			editor = new Editor(id);
		}
		else
		{
			alert('Pre spustenie editora je potrebné mať prehliadač Mozilla Firefox verzia 3.5 a vyššie');
		}
	}
	else
	{
		// zrusime editor a vratime sa do textarey
		var source_div = $(id);
		var ifr_div = source_div.select('.iframe_div')[0];
		var ifr = ifr_div.select('iframe')[0];
		var textarea = source_div.select('textarea')[1];
		
		var serializer = new XMLSerializer();
		var text = serializer.serializeToString(ifr.contentDocument.model);		
		
		ifr_div.setStyle({display: 'none'});
		
		textarea.value = text;
		textarea.setStyle({display: 'inline'});
		
		source_div.removeChild(ifr_div);
	}
}
 
function close_editor(model)
{
	var checkbox = $(checkbox_id_global);
	checkbox.checked = false;
	
	var source_div = $(textarea_id_global);
	var ifr_div = source_div.select('.iframe_div')[0];
	var ifr = ifr_div.select('iframe')[0];
	var textarea = source_div.select('textarea')[0];
	
	ifr_div.setStyle({display: 'none'});
	textarea.setStyle({display: 'inline'});
	
	source_div.removeChild(ifr_div);
	
	var serializer = new XMLSerializer();
	text = serializer.serializeToString(model);
	
	text = text.substr(text.indexOf('<parser'));
	
	text = text.replace('parsererror xmlns="http://www.mozilla.org/newlayout/xml/parsererror.xml"', 'div id="error_div"');
	text = text.replace('parsererror', 'div');
	text = text.replace('sourcetext', 'pre');
	text = text.replace('/sourcetext', '/pre');
	
	var err_div = document.createElement('div');
	err_div.setAttribute('style', 'background: yellow;');
	err_div.innerHTML = text;
	source_div.insertBefore(err_div, textarea);
//	error = model.getElementsByTagName('parsererror')[0].childNodes[4].data;
//	alert(error);
	
	//alert('Editor sa nepodarilo spustiť, lebo Váš text nespĺňa podmienky well-formed dokumentu.');
}

var Editor = Class.create({
 
	textarea_div_id: '',
	undo_img: BASE + 'css/pics/undo.png',
	redo_img: BASE + 'css/pics/redo.png',
	paragraph_img: BASE + 'css/pics/paragraph.png',
	model_img: BASE + 'css/pics/model.png',

	initialize: 
		function(div_id) 
		{
			this.textarea_div_id = div_id;
			this.startPage();
		},   
	
	make_editor_html: 
		function()
		{		
			var toolbar = document.createElement('div');
 			toolbar.setAttribute('id', 'toolbar');
 			
 			var group1 = document.createElement('div');
 			group1.setAttribute('class', 'group');
 			
 			var but_redo = document.createElement('button');
 			but_redo.setAttribute('id', 'butRedo');	
 			but_redo.setAttribute('onclick', 'return false;');
 			but_redo.setAttribute('type', 'button');
 			var but_redo_img = document.createElement('img');
 			but_redo_img.setAttribute('src', this.redo_img);
 			but_redo_img.setAttribute('alt', 'Redo');
 			but_redo_img.setAttribute('title', 'Redo');
 			
 			var but_undo = document.createElement('button');
 			but_undo.setAttribute('id', 'butUndo');
 			but_undo.setAttribute('onclick', 'return false;');
 			but_undo.setAttribute('type', 'button');
 			var but_undo_img = document.createElement('img');
 			but_undo_img.setAttribute('src', this.undo_img);
 			but_undo_img.setAttribute('alt', 'Undo');
 			but_undo_img.setAttribute('title', 'Undo');
 			 			
 			but_redo.appendChild(but_redo_img);
 			but_undo.appendChild(but_undo_img);
 			group1.appendChild(but_redo);
 			group1.appendChild(but_undo);
 			
 			var group2 = document.createElement('div');
 			group2.setAttribute('class', 'group');
 			
 			var but_para = document.createElement('button');
 			but_para.setAttribute('id', 'butPara');
 			but_para.setAttribute('onclick', 'return false;');
 			but_para.setAttribute('type', 'button');
 			var but_para_img = document.createElement('img');
 			but_para_img.setAttribute('src', this.paragraph_img);
 			but_para_img.setAttribute('alt', 'Paragraph');
 			but_para_img.setAttribute('title', 'Paragraph');
 			
 			but_para.appendChild(but_para_img);
 			group2.appendChild(but_para);
 			
 			var group3 = document.createElement('div');
 			group3.setAttribute('class', 'group');
 			
 			var but_model = document.createElement('button');
 			but_model.setAttribute('id', 'butModel');
 			but_model.setAttribute('onclick', 'return false;');
 			but_model.setAttribute('type', 'button');
 			var but_model_img = document.createElement('img');
 			but_model_img.setAttribute('src', this.model_img);
 			but_model_img.setAttribute('alt', 'Model');
 			but_model_img.setAttribute('title', 'Model');
 			
 			but_model.appendChild(but_model_img);
 			group3.appendChild(but_model);
 			
 			var group4 = document.createElement('div');
 			group4.setAttribute('class', 'group');
 			
 			var div_status_bar = document.createElement('div');
 			div_status_bar.setAttribute('id', 'status_bar');
 			div_status_bar.setAttribute('class', 'status_bar');
 			div_status_bar.setAttribute('style', 'width: 100%; height: 100%;');
 			
 			var div_status = document.createElement('div');
 			div_status.setAttribute('id', 'status');
 			div_status.setAttribute('class', 'status');
 			div_status.setAttribute('style', 'width: 100%; height: 100%;');
 			
 			div_status_bar.appendChild(div_status);
 			group4.appendChild(div_status_bar);
			 
			toolbar.appendChild(group1);
			toolbar.appendChild(group2);
			toolbar.appendChild(group3);
			toolbar.appendChild(group4);
			
			var new_ifr = document.createElement('iframe');
 			new_ifr.setAttribute('src', './xml_editor/frame.html');   			
 			new_ifr.setAttribute('id', 'iframe');
 			new_ifr.setStyle({width: '99%', height: '350px'});
 			
 			var new_debug_text = document.createElement('textarea');
 			new_debug_text.setAttribute('id', 'textarea_debug');
 			new_debug_text.setStyle({width: '99%', height: '150px', display: 'none'});
			
 			var new_div = document.createElement('div');
 			new_div.setAttribute('class', 'iframe_div');  
 			
 			new_div.appendChild(toolbar);
 			new_div.appendChild(new_ifr);
 			new_div.appendChild(new_debug_text);
 			
			return new_div;
		},
   
	startPage: 
		function()
 		{ 				
 			var source_div = $(this.textarea_div_id);
 			var textarea = source_div.select('textarea')[0];
 			
 			var error = $('error_div');
 			if (error)
 			{
 			  error.parentNode.removeChild(error);
      }
 			
 			if (textarea.innerHTML == '')
 			{
				var example = $('example');
				textarea.innerHTML = example.innerHTML;
			}
 			
			var new_div = this.make_editor_html();
 			
 			var xsl_template = textarea.value;
 			
 			textarea.parentNode.insertBefore(new_div, textarea);
 			textarea.setStyle({display: 'none'});
 			
			var ifr = $('iframe');
			
			$("butUndo").onclick = function() 
			{
				ifr.contentDocument.undoStack.undo();
			}
			
			$("butRedo").onclick = function() 
			{
				ifr.contentDocument.undoStack.redo();
			}
			
			$("butModel").onclick = function() 
			{
				var serializer = new XMLSerializer();
			    alert(serializer.serializeToString(ifr.contentDocument.model));
			}
			
			$("butPara").onclick = function() 
			{	    
				var linebreakRuleOff = ".linebreak { visibility: hidden; }";
				var linebreakRuleOn = ".linebreak { visibility: visible; }";
				var tabulatorRuleOff = ".tabulator { visibility: hidden; }";
				var tabulatorRuleOn = ".tabulator { visibility: visible; }";
				
				this.turnOff = this.turnOff == undefined ? true : (this.turnOff ? false : true); 
			
				if (this.turnOff) 
				{
					ifr.contentDocument.styleSheets[0].insertRule(tabulatorRuleOff, ifr.contentDocument.styleSheets[0].cssRules.length);
					ifr.contentDocument.styleSheets[0].insertRule(linebreakRuleOff, ifr.contentDocument.styleSheets[0].cssRules.length);
				} 
				else 
				{
					ifr.contentDocument.styleSheets[0].insertRule(tabulatorRuleOn, ifr.contentDocument.styleSheets[0].cssRules.length);
					ifr.contentDocument.styleSheets[0].insertRule(linebreakRuleOn, ifr.contentDocument.styleSheets[0].cssRules.length);	
				}  
			}
		}
})