<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:variable name="title" >Nový komentár</xsl:variable>
  <xsl:variable name="blogTitle" select='//title' />
  <xsl:variable name="nick" select='//nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
 </xsl:template>
 
 <xsl:template match="/*">
    <script type="text/javascript" src="http://{$base}/ajax/preview.js" />
    <script type="text/javascript">
      var RecaptchaOptions = {
      theme: 'custom',
      lang: 'en',
      custom_theme_widget: 'recaptcha_widget'}
      function check(form)
      {
      if (form.title.value.length==0)
      {
      alert('Je nutné vyplniť predmet');
      return false;
      }
      }
    </script>

   <xsl:apply-templates select="comment"/>
   <h3>Náhľad</h3>
   <div id="preview" class="preview">
     Text
   </div>
   <form action="{$blogURL}/?type=addComment" method="post" class="frm" onsubmit="return check(this)">
     <input type="hidden" name="commentID" value="{/commentForm/comment/@ID}" />
     <input type="hidden" name="postID" value="{//postID}" />
     <input type="hidden" name="userID" value="{//userID}" />
     <fieldset>
       <label for="title">Predmet: </label>
       <xsl:if test="/commentForm/comment/title">
         <input type="text" name="title"  id="title" class="input_large" value="RE: {/commentForm/comment/title}" />
       </xsl:if>
       <xsl:if test="not(/commentForm/comment/title)">
         <input type="text" name="title" id="title" class="input_large" value="" />
       </xsl:if>
       <br />
       <xsl:if test="not($loggedUser)">
         <label for="guest">Meno: </label>
         <input type="text" name="guest" class="input_large" /><br />
       </xsl:if>
       
       <label for="comment">Text: </label>
       <textarea cols="80" rows="8" name="comment" id="commentContent" class="megaBox" onkeyup="getPreview(document.getElementById('commentContent').value)"></textarea>
     </fieldset>
     <xsl:if test="not($loggedUser)">
       <xsl:call-template name="recaptcha" />
     </xsl:if>
     <div class="center">
       <input type="submit" class="submit" value="Odošli" />
     </div>
    </form>
    <h3>Pôvodný článok</h3>
    <div class="preview scrollbar">
      <h2><xsl:copy-of select="/postView/post/title/node() | /commentForm/post/title/node()" /><xsl:if test="string-length(/postView/post/subtitle/node()) > 0 or string-length(/commentForm/post/subtitle/node())">: <xsl:copy-of select="/postView/post/subtitle/node() | /commentForm/post/subtitle/node()" /></xsl:if></h2>
      <div class="formatted">
        <xsl:copy-of select="/postView/post/content/node() | /commentForm/post/content/node()" />
      </div>
    </div>
   
 </xsl:template>
 
 <xsl:template match="comment" name="comment">
      <h3>Reakcia na komentár od  
        <xsl:if test="author[@guest]">
          <xsl:if test="not(author/text())">Anonym</xsl:if>
            <xsl:value-of select="author" />
          </xsl:if>
        <xsl:if test="author[not(@guest)]">
          <em>
            <a href="http://{author/nick}.{$base}">
              <xsl:value-of select="author/realName" />
            </a>
          </em>
        </xsl:if>:
      </h3>
      <div class="formatted">
        <xsl:copy-of select="/commentForm/comment/content/node()" />
      </div>
 </xsl:template>

</xsl:stylesheet>