<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:date="http://exslt.org/dates-and-times"
                xmlns:math="http://exslt.org/math"
                xmlns:my="http://blog.matfyz.sk"
                exclude-result-prefixes="math xsl"
                extension-element-prefixes="my date">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:param name="from" />
  <xsl:variable name="title">Login</xsl:variable>
  <xsl:variable name="redirect">
    <xsl:choose>
      <xsl:when test="not(contains($from,'http://'))">http://<xsl:value-of select="$base" /></xsl:when>
      <xsl:otherwise><xsl:value-of select="$from" /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>

  <xsl:template match="portalView">
    <div id="portal">
      <div id="left">
        <div class="cpad">
          <h2>BlogMatfyz <xsl:call-template name="getStringDefault">
            <xsl:with-param name="stringName" select="'Login'"/>
          </xsl:call-template></h2>
          <div class="loginArea">
            <form method="post" action="http://{$base}/?type=login" class="frm" name='loginForm'>
              <fieldset>
                <legend><xsl:call-template name="getStringDefault">
                  <xsl:with-param name="stringName" select="'Login'"/>
                </xsl:call-template><xsl:text> </xsl:text><xsl:value-of select="$base" /></legend>
                <input type="hidden" name="url" value="{$redirect}" />
                <label for="user"><xsl:call-template name="getString">
                  <xsl:with-param name="stringName" select="'Username'"/>
                </xsl:call-template>:</label>
                <input type="text" name="user" id="user" value="" class="input_large" />
                <br />
                <label for="password"><xsl:call-template name="getString">
                  <xsl:with-param name="stringName" select="'Password'"/>
                </xsl:call-template>:</label>
                <input type="password" class="input_large" name="password" id="password" value="" />
                <br />
                <div class="center">
                  <input type="submit" name="login"  class="submit" value="Login" />
                </div>
              </fieldset>
            </form>
          </div>  
          <script type="text/javascript">
            document.loginForm.user.focus();
          </script>
          <h3>OpenID</h3>
          <div class="loginArea">       
            <form action="http://{$base}/?type=login" method="post" onsubmit="this.login.disabled=true;" class="frm">
              <fieldset>
                <legend><xsl:call-template name="getStringDefault">
                  <xsl:with-param name="stringName" select="'Login'"/>
                </xsl:call-template><xsl:text> </xsl:text><xsl:call-template name="getString">
                  <xsl:with-param name="stringName" select="'via'"/>
                </xsl:call-template> OpenID</legend>
                <input type="hidden" name="openid_action" value="login" />
                <input type="hidden" name="url" value="{$from}/" />
                <label for="openid_url">URL:</label>
                <input type="text" name="openid_url" id="openid_url" class="inputbox" />
                <br />
                <div class="center">
                  <input type="submit" name="login"  class="submit" value="Login" />
                </div>
               </fieldset>
             </form>
           </div>
           <div>
             <div>
               <p><xsl:call-template name="getStringDefault">
                 <xsl:with-param name="stringName" select="'Registration'"/>
               </xsl:call-template>: <a href="http://{$base}/registration" class="raquo">Staň sa blogerom práve teraz</a></p>
             </div>
             <p>Čo je OpenID? <a href="http://www.myopenid.com/" class="raquo">Získať OpenID</a></p>
           </div>
        </div>
      </div>
      <div id="right">
        <div class="cpad">
          <h3>OpenID účet</h3>
          <p>S OpenID sa nemusíte registrovať a prihlasovať do každého webového portálu s novým užívateľským menom a heslom. Jednoducho si <a href="http://www.myopenid.com/" >vytvoríte</a> jednu openID identitu, s ktorou sa môžete prihlasovať do rôzných portálov a stránok po celom webe.</p>
          <h3>Problémy s prihlásením</h3>
          <p>A máte akýkoľvek problém s prihlasovaním sa do nášho portálu, dajte nám vedieť na adresu <a href="mailto:webmaster@matfyz.sk">webmaster@matfyz.sk</a></p>
          <!--
          Preco je to zakomentovane?
          <br /><br />
          <a href="http://www.exist-db.org/"><img src="http://www.exist-db.org/resources/powered.gif" alt="Powerd by eXist" /></a>
          -->
        </div>
      </div>
      <div class='spacer'></div>
    </div>
  </xsl:template>
  
  
</xsl:stylesheet>
