<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:param name="timeout" /> 
  <xsl:variable name="title" >
    <xsl:if test="not(/postView/post/@ID)">Nový príspevok</xsl:if>
    <xsl:if test="/postView/post/@ID">Upraviť príspevok</xsl:if>
  </xsl:variable>
  <xsl:variable name="type" >
    <xsl:if test="not(/postView/post/@ID)">addPost</xsl:if>
    <xsl:if test="/postView/post/@ID">editPost</xsl:if>
  </xsl:variable>
  <xsl:variable name="blogTitle" select='/postView/title' />
  <xsl:variable name="nick" select='/postView/nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  <xsl:template match="/*">
    <script type="text/javascript">
      function update() {
        getPreview(document.getElementById('postContent').value);
        // var t=setTimeout("update()",1000);
      }
      function enableMe(obj) {
        var sBox = document.getElementById("subtitleBox");
        var subtitle = document.getElementById("subtitle");
        if (obj.checked) {
          sBox.className = "enabled";
          subtitle.disabled = false;
        } else {
          sBox.className = "disabled";
          subtitle.disabled = true;
          subtitle.value = "";
        }
      }
      function checkPost(val) {
        var cf = document.getElementById("checkForm");
        var st = document.getElementById("status");
        var title = document.getElementById("title").value;
        if (title != "") {
          cf.innerHTML = '<div class="ok" style="text-align: left;">Údaje boli zadané správne, príspevok môžete odoslať.</div>';
          st.className = "submit";
          st.disabled = false;
        } else {
          cf.innerHTML = '<div class="fail" style="text-align: left;">Vyplňte názov článku pred odoslaním.</div>';
          st.className = "submit disabled";
          st.disabled = true;
        }
      
      }
    </script>
    <form action="{$blogURL}/?type={$type}" method="post" class="frm">
      <input type="hidden" name="postID" value="{/postView/post/@ID}" />
      <fieldset>
        <label for="title"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Title'"/>
        </xsl:call-template></label>
      <input type="text" name="title" id="title" class="input_large" value="{/postView/post/title}" onkeyup="checkPost(this.value)" />
        <br />
        <div id="subtitleBox" class="disabled">
        <label for="subtitle"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Subtitle'"/>
        </xsl:call-template>?
        <input type="checkbox" id="enableBox" onchange="enableMe(this)"/></label>
        <input type="text" name="subtitle" id="subtitle" class="input_large" value="{/postView/post/subtitle}" disabled="true" />
        </div>
        <xsl:if test="/postView/post/subtitle=''">
          <script type="text/javascript">
            enableMe(document.getElementById("enableBox"));
          </script>
        </xsl:if>
        <br />    
        <label for="language"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Language'"/>
        </xsl:call-template></label>
        <select name="language" class="input_large">
          <xsl:element name="option">
            <xsl:attribute name="value">sk</xsl:attribute>
            <xsl:if test="/postView/post/@lang='sk'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
            slovenský
          </xsl:element>
          <xsl:element name="option">
            <xsl:attribute name="value">en</xsl:attribute>
            <xsl:if test="/postView/post/@lang='en'"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if>
            anglický
          </xsl:element>
        </select>
        <br />    
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Preview'"/>
        </xsl:call-template></h3>
        <div id="preview" class="preview">
          Preview
        </div>
        <div id="timeline"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'postSendTo'"/>
        </xsl:call-template><xsl:text> </xsl:text><xsl:value-of select="$timeout" />.</div>
        <label for="content">Text</label>
        <textarea id="postContent" name="postContent" class="megaBox" onkeyup="getPreview(document.getElementById('postContent').value)">
          <xsl:copy-of select="/postView/post/content/node()" />
        </textarea>
        <script type="text/javascript">update();</script>
        <h3 style="clear: both;"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Hints'"/>
        </xsl:call-template></h3>
        <p>
          <a href="http://stettner.{$base}/p1-syntax-i">Syntax formátovania textu</a>
          |
          <a href="http://stettner.{$base}/p3-syntax-ii">Zdrojové kódy - Zoznamy - Obsah</a>
          |
          <a href="http://stettner.{$base}/p6-latex">Matfyzak bez latexu?</a>
          <br />
          <xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'cutText'"/>
          </xsl:call-template><xsl:text> </xsl:text><strong>--<span>break</span>--</strong>
        </p>
        <h3><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'tagsPropo'"/>
        </xsl:call-template></h3>
        <span id="activesort" title="name" />
        <span id="activeorder" title="asc" />
        <div class="tagArea" id="tagArea" >
          <xsl:variable name="priemer" select="sum(/postView/systemTags/tag/@percent) div count(/postView/systemTags/tag/@percent)" />
          <xsl:for-each select="/postView/systemTags/tag">
            <xsl:variable name="fontSize" select="round(@percent div $priemer * 100)" />
            <span style="font-size: {$fontSize}%;" class="tag" onclick="addTag(this.innerHTML);" title="{$fontSize}"><xsl:value-of select="." /></span>
          </xsl:for-each>
        </div>
        <p id="sortList" style="padding-right: 10px;">
          <xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'Sort by'"/>
          </xsl:call-template>:
          <a href="javascript:void();" onclick="tagSort('name',this);"  class="asc"><xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'Alphabet'"/>
          </xsl:call-template></a>
          <a href="javascript:void();" onclick="tagSort('size',this);"><xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'Size'"/>
          </xsl:call-template></a>
          <a href="javascript:void();" onclick="tagSort('length',this);"><xsl:call-template name="getString">
            <xsl:with-param name="stringName" select="'Length'"/>
          </xsl:call-template></a>
        </p>
        <div class="clear"></div>
        <label for="tags"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Tags'"/>
        </xsl:call-template></label>
        <textarea id="tags" name="tags" class="tagBox">
          <xsl:for-each select="/postView/post/tags/tag">
            <xsl:value-of select="." />
            <xsl:if test="position() != last()">
              <xsl:text>, </xsl:text>
            </xsl:if>
          </xsl:for-each>
        </textarea>
        <br />
      </fieldset>
      <div id="checkForm"></div>
      <button type="submit" name="status" id="status" class="submit" value="published"><xsl:call-template name="getString">
        <xsl:with-param name="stringName" select="'Save and publish'"/>
      </xsl:call-template></button>
      <button type="submit" name="status" class="submit" value="draft"><xsl:call-template name="getString">
        <xsl:with-param name="stringName" select="'Save as draft'"/>
      </xsl:call-template></button>
      <button type="reset" name="reset" class="submit" value="reset" onclick="return confirm('Skutočne nastaviť predvolené hodnoty vo formulári?');">Reset</button>
      <script type="text/javascript">checkPost("");</script>
    </form>
  </xsl:template>
</xsl:stylesheet>