<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:variable name="title" ><xsl:call-template name="getString">
    <xsl:with-param name="stringName" select="'Registration'"/>
  </xsl:call-template></xsl:variable>
  <xsl:variable name="blogTitle" select='/postView/title' />
  <xsl:variable name="nick" select='/postView/nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  
  <xsl:template match="/*">
    <script type="text/javascript">
      var RecaptchaOptions = {
      theme: 'custom',
      lang: 'white',
      custom_theme_widget: 'recaptcha_widget'}
      function check(form)
      {
      if (form.title.value.length==0)
      {
      alert('Je nutné vyplniť predmet');
      return false;
      }
      }
    </script>
    <form action="./?type=doRegistration" method="post" class="frm" onsubmit="return checkForm(this)">
      <fieldset>
        <label for="userName"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Username'"/>
        </xsl:call-template> (Nick): </label>
        <input type="text" name="userName" id="userName" class="input_large" onkeyup="this.value=this.value.toLowerCase();checkName(this.value)" onblur="checkName(this.value)" onkeydown="this.value=this.value.toLowerCase()"/><span class="fail">*</span><br />
        <span id="message"></span>
        <label for="realName"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Whole name'"/>
        </xsl:call-template>: </label>
        <input type="text" name="realName" id="realName" class="input_large" /><br />
        <label for="lastName"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Surname only'"/>
        </xsl:call-template>: </label>
        <input type="text" name="lastName" id="lastName" class="input_large" /><br />
        <div class="hint">
          Ak ste vyplnili <em>celé meno</em>, napíšte, prosím, ešte raz Vaše <em>priezvisko</em>, aby sme vedeli, kam Vás máme zaradiť do abecendného zoznamu blogerov.
        </div>
        <label for="email">Email: </label>
        <input type="text" name="email" id="email" class="input_large" /><span class="fail">*</span><br />
      
        <div class="hint">
          Na túto emailovú adresu vám bude zaslané heslo pre vstup do systému. Pri probléme nás <a href="mailto:anton.kohutovic@gmail.com">kontaktujete</a>.
        </div>
        <br />
        <hr class="line" />
        <label for="blogTitle"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Blog title'"/>
        </xsl:call-template>: </label>
        <input type="text" name="blogTitle" id="blogTitle" class="input_large" /><span class="fail">*</span><br />
        <hr class="line" />
        <label for="openID">openID <xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'identity'"/>
        </xsl:call-template>: </label>
        <input type="text" name="openID" id="openID" class="input_large" /><br />
        <div class="hint">
          S OpenID sa nemusíte registrovať a prihlasovať do každého webového portálu s novým užívateľským menom a heslom. Ak nemáte OpenID, túto položku jednoducho nevypĺňajte. (<a href="http://janrain.com/openid">Viac o OpenID</a> | <a href="http://www.myopenid.com/" title="get openID">Získať OpenID</a>).
          <br />Zadávajte a prihlasujte sa v tvare <em>"identita.url.tld"</em>.
        </div>
        <hr class="line" />
      
        <script type="text/javascript">
          function enableButton(obj, obj2) {
            if (obj.checked <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> obj2.checked) {
              document.getElementById('submit').disabled = false;
              document.getElementById('submit').className = 'submit';
            } else {
              document.getElementById('submit').disabled = true;
              document.getElementById('submit').className = 'submit disabled';
            }
          }
        </script>
        <label for="agreement"><span class="fail">*</span> </label>
        <input type="checkbox" name="agreement" id="agreement" class="checkbox" onclick="enableButton(this, document.getElementById('agreement2'))" />Súhlasím s <a href="http://team.blog.matfyz.sk/p655-podmienky-pouzivania-portalu-blog-matfyz-sk">podmienkami používania</a>.
        <br />
        <label for="agreement2"><span class="fail">*</span> </label>
        <input type="checkbox" name="agreement2" id="agreement2" class="checkbox" onclick="enableButton(this, document.getElementById('agreement'))" />Súhlasím s <a href="http://team.blog.matfyz.sk/p656-politika-obsahu-portalu-blog-matfyz-sk">politikou obsahu</a>.<br />
        <div class="fail">* Tieto položky je nutné vyplniť.</div><br />
      
        <xsl:call-template name="recaptcha" />
        <div class="center">
          <input type="submit" name="submit" id="submit" class="submit" value="Registruj" /><input type="reset" name="submit" class="submit" value="Reset" />
        </div>
        <script type="text/javascript">
          document.getElementById('submit').disabled = true;
          document.getElementById('submit').className = 'submit disabled';
        </script>
      </fieldset>
    </form>
  </xsl:template>

</xsl:stylesheet>