<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" />
  <xsl:variable name="title" ><xsl:call-template name="getString">
    <xsl:with-param name="stringName" select="'Settings'"/>
  </xsl:call-template></xsl:variable>
  <xsl:variable name="blogTitle" select="/settingsForm/title" />
  <xsl:variable name="nick" select="/settingsForm/nick" />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:variable name="changeButton"><xsl:call-template name="getStringDefault">
    <xsl:with-param name="stringName" select="'Change'"/>
  </xsl:call-template></xsl:variable>
  
  <xsl:template match="/*">
    <script type="text/javascript">
      function verifyPasswords(pass1,pass2)
      {
      
      if (pass1==pass2)
      {
      if (pass1.length==0)
      {
      document.getElementById("verification").innerHTML = "";
      document.getElementById("submit").disabled = false;
      }
      else
      {
      document.getElementById("verification").innerHTML = "Heslo overené";
      document.getElementById("verification").setAttribute("class","ok");
      document.getElementById("submit").disabled = false;
      }
      }
      else
      {
      document.getElementById("verification").innerHTML = "Heslá nezhodné";
      document.getElementById("verification").setAttribute("class","fail");
      document.getElementById("submit").disabled = true;
      }
      }
    </script>
    <form action="{$blogURL}/index.php?type=changeSettings" method="post" class="frm">
      <fieldset>
        <h3>Moja indentita</h3>
        
        <label for="email">Email: </label>
        <input type="text" name="email" id="email" class="input_large" value="{/settingsForm/email}"/><br />
        
        <label for="realName"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Whole name'"/>
        </xsl:call-template>: </label>
        <input type="text" name="realName" id="realName" class="input_large" value="{/settingsForm/realName}"/>
        <br />
        <label for="lastName"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Surname only'"/>
        </xsl:call-template>: </label>
        <input type="text" name="lastName" id="lastName" class="input_large" value="{/settingsForm/lastName}"/>
        <br />
        <div class="hint">
          Priezvisko je určené len účely zoraďovania. Nezobrazuje sa.
        </div>
        
        <label for="openID">openID <xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'identity'"/>
        </xsl:call-template>: </label>
        <input type="text" name="openID" id="openID" class="input_large" value="{/settingsForm/identity}"/>
        <br />
        <div class='hint'>
          Zadávajte a prihlasujte sa v tvare <em>"identita.url.tld"</em>
        </div>
        <div class="center">
          <input type="submit" name="submit" id="submit" class="submit" value="{$changeButton}" />
          <input type="reset" name="submit" id="submit" class="submit" value="Reset" />
        </div>
      </fieldset>
    </form>
    <hr class="line" />
   
    
    <form action="{$blogURL}/index.php?type=changeSettings" method="post" class="frm">
      <fieldset>    
        <h3>Zmena hesla</h3>
       <!-- <label for="about">CSS štýl: </label>
        <select name="css">
          <xsl:for-each select="/settingsForm/styles/style">
            <xsl:element name="option">
              <xsl:if test="path=/settingsForm/@css">
                <xsl:attribute name="selected" />
              </xsl:if>
              <xsl:attribute name="value">
                <xsl:copy-of select="path" />
              </xsl:attribute> <xsl:value-of select="name" />
            </xsl:element>
          </xsl:for-each>
        </select>
        <br /><br />-->
        
        
        <!--<label for="password">Staré heslo: </label>
        <input type="password" name="oldPassword" id="oldPassword" class="input_large" /><br />-->
        <label for="password">Nové heslo: </label>
        <input type="password" name="newPassword" id="pass1" class="input_large" onkeyup="verifyPasswords(this.value,document.getElementById('pass2').value)" /><br />
        <label for="passwordVerification" >Overenie nového hesla: </label>
        <input type="password" name="newPasswordVerification" id="pass2" class="input_large" value="" onkeyup="verifyPasswords(this.value,document.getElementById('pass1').value)"/><br />
        <div id="verification">
        </div>
        <br />
        <!--<xsl:if test="/settingsForm/userID/@type!='student'">
          <hr />
          <h3>Študent predmetu Moderný pristup k webdesignu</h3>
          <p>Na predmet sa môžete prihlasovať <a href="{$blogURL}?type=studentsRegistration">tu.</a></p>
          <div class="clear"></div>
          <hr />
        </xsl:if>-->
        <div class="center">
          <input type="submit" name="submit" id="submit" class="submit" value="{$changeButton}" />
        </div>
      </fieldset>
    </form>
    <hr class="line" />
    <form action="{$blogURL}/index.php?type=changeSettings" method="post" class="frm">
      <fieldset>    
        <h3>Môj blog</h3>
        <label for="userName"><xsl:call-template name="getString">
          <xsl:with-param name="stringName" select="'Blog title'"/>
        </xsl:call-template>: </label>
        <input type="text" name="blogTitle" id="blogTitle" class="input_large" value="{/settingsForm/title}" /><br />
        
        <label for="about">Niečo o tebe: </label>
        <textarea name="about" id="about" class="mediumBox" ><xsl:value-of select="/settingsForm/about"/></textarea>
        <div class="center">
          <input type="submit" name="submit" id="submit" class="submit" value="{$changeButton}" />
          <input type="reset" name="submit" id="submit" class="submit" value="Reset" />
      </div>
      </fieldset>
    </form>
    <hr class="line" />
   
    <h3>Fotografia</h3>
    <div class="center">
      <img src="{$blogURL}/avatar.jpg" style="max-width:220px;margin-bottom:1.5em"/>
    </div>
    <form  action="{$blogURL}/index.php?type=uploadFile" method="post" enctype="multipart/form-data" class="frm">
      <fieldset>  
        <input type="hidden" name="url" value="{$blogURL}/settings" />
        <input type="hidden" name="filename" value="avatar.jpg"/>
        <label for="userName">Vyberte obrázok: </label>
        <input type="file" name="file" id="file" class="input_large" accept="image/gif, image/jpeg, image/jpg"/><br />
        <div class="hint">Vkladajte obrázky vo formáte JPEG.</div>
        <div class="center">
          <input type="submit" name="submit" id="submit" class="submit" value="{$changeButton}" />
        </div>
      </fieldset>
    </form>
    <hr class="line" />
    <hr /><br />
    <div class='spacer'></div>
    <h3>Vlastný obrázok v hlavičke</h3>
    <form  action="{$blogURL}/index.php?type=uploadFile" method="post" enctype="multipart/form-data" class="frm">
      <fieldset>  
        <input type="hidden" name="url" value="{$blogURL}/settings" />
        <input type="hidden" name="filename" value="header.jpg"/>
        <label for="userName">Vyberte obrázok: </label>
        <input type="file" name="file" id="file" class="input_large" accept="image/gif, image/jpeg, image/jpg"/><br />
        <div class="hint">Vkladajte obrázky vo formáte JPEG.</div>
        <div class="center">
          <input type="submit" name="submit" id="submit" class="submit" value="{$changeButton}" />
        </div>
      </fieldset>
    </form>
  </xsl:template>
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
</xsl:stylesheet>
