<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" /> 
  <xsl:variable name="title" >
    New comment
  </xsl:variable>
  <xsl:variable name="type" >
    <xsl:if test="not(/postView/post/@ID)">addPost</xsl:if>
    <xsl:if test="/postView/post/@ID">editPost</xsl:if>
  </xsl:variable>
  <xsl:variable name="blogTitle" select='/postView/title' />
  <xsl:variable name="nick" select='/postView/nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  
  <xsl:template match="/*">
    <h2>Post comment</h2>
    <em>Please log in, if your are not. (<a href="/">Here</a>)</em><br />
    <em>Your user ID is  <xsl:value-of select="//user/@ID" />.</em><br />
    <a href="comment.dtd">DTD for your commnets</a>
    <h3>Example:</h3>
    <pre>
&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;!DOCTYPE comment SYSTEM "comment.dtd"&gt;
&lt;comment lang="en" ref="p1"&gt;
  &lt;title&gt;Wow!&lt;/title&gt;
  &lt;content&gt;&lt;p&gt;Kill your IE 6.0! Use <a href="http://opera.com">Opera</a> &lt;/p&gt;&lt;/content&gt;
&lt;/comment&gt;
    </pre>
    
    <form action="comment.php" method="post" class="frm">
      <fieldset>
        <label for="comment">Comment: </label>
        <textarea rows="20" cols="60" name="comment" class="megaBox"></textarea><br />
        <label for="redirect">Redirect to: </label>
        <input type="text" name="redirect" class="input_large"/><br /><br />
        <input type="submit" class="submit"/>
      </fieldset>
    </form>
  </xsl:template>
  
</xsl:stylesheet>