<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" /> 
  <xsl:variable name="title" >
    New post
  </xsl:variable>
  <xsl:variable name="type" >
    <xsl:if test="not(/postView/post/@ID)">addPost</xsl:if>
    <xsl:if test="/postView/post/@ID">editPost</xsl:if>
  </xsl:variable>
  <xsl:variable name="blogTitle" select='/postView/title' />
  <xsl:variable name="nick" select='/postView/nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <xsl:apply-imports />
  </xsl:template>
  <xsl:template match="/*">
    <h1>Post blogpost</h1>
    <em>Please log in, if your are not.</em><br />    
    <a href="post.dtd">DTD for your post</a>
    <h3>Example:</h3>
    <pre>
&lt;?xml version="1.0" encoding="utf-8"?&gt;  
&lt;!DOCTYPE post SYSTEM "post.dtd"&gt;
&lt;post lang="en"&gt;
  &lt;title&gt;Hello world!&lt;/title&gt;
  &lt;subtitle/&gt;
  &lt;content&gt;&lt;p&gt;Well, hello...&lt;/p&gt;&lt;/content&gt;
  &lt;tags&gt;
    &lt;tag&gt;Test tag&lt;/tag&gt;
  &lt;/tags&gt;
&lt;/post&gt;
    </pre>
    <form action="post.php" method="post" class="frm">
      <fieldset>
        <label for="post">Post: </label>
        <textarea rows="20" cols="60" name="post" class="megaBox"></textarea><br />
        <label for="post">Redirect to: </label>
        <input type="text" name="redirect" /><br />After successfull post of your XML you will be redirected to URI written in this input.<br /><br />
        <input type="submit" class="submit"/>
      </fieldset>
    </form>
  </xsl:template>
</xsl:stylesheet>