<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="layout.xsl" />
  <xsl:output omit-xml-declaration="no" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" indent="yes" encoding="utf-8" /> 
  <xsl:variable name="title" >
    Registrácia pre predmet Moderný prístup k webdizajnu.
  </xsl:variable>
   <xsl:variable name="blogTitle" select='/postView/title' />
  <xsl:variable name="nick" select='/postView/nick' />
  <xsl:variable name="blogURL" select="concat('http://',$nick,'.',$base)" />
  
  <xsl:template match="/">
    <html>
      <head>
        <title>
          <xsl:value-of select="$title" />
        </title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <xsl:if test="not(//@css)" >
          <link rel="stylesheet" href="./css/tbc/style.css" type="text/css" media="screen" />
        </xsl:if>
        <link rel="stylesheet" href="./css/languages.css" type="text/css" media="screen" />
        <link rel="stylesheet" href="./css/main.css" type="text/css" media="screen" />
        <link rel="shortcut icon" href="./css/favicon.png"/>
        <link rel="stylesheet" href="./css/tbc/style.css" type="text/css" media="screen" />
        <link rel="alternate" href="{$blogURL}?type=rss" type="application/rss+xml" />
      </head>
      <body>
        <div class="wrap-t lt">
          <span class="rt">
            <span class="i">
            </span>
          </span>
        </div>
        <div class="wrap">
          <div class="f-o">
            <div class="l">
              <div class="t">
                <div class="b">
                  <div class="r">
                    <div class="lt">
                      <div class="lb">
                        <div class="rt">
                          <div class="rb f-i">
                            <xsl:apply-imports />
                            <div id="heading">
                            </div>
                            <div id="main">
                              <div id="content">
                                <h2>Požadované údaje pre predmet Moderný prístup k webdizajnu</h2>
                                <br />
                                <form action="index.php?type=registerStudent" method="post" class="frm">
                                  
                                  <label for="submit">Ročník a odbor</label>
                                  <select name="class">
                                    <option value="1.AIN">1.AIN</option>
                                    <option value="1.mAIN">1.mAIN</option>
                                    <option value="1.mINF">1.mINF</option>
                                    <option value="1.mIKV">1.mIKV</option>
                                    <option value="1.mINF/k">1.mINF/k</option>
                                    <option value="3.INF">3.INF</option>
                                    <option value="2.AIN">2.AIN</option>
                                    <option value="3.AIN">3.AIN</option>
                                    <option value="3.MAT">3.MAT</option>
                                    <option value="4.AIN">4.AIN</option>
                                    <option value="5.IN">5.IN</option>
                                    <option value="5.MA">5.MA</option>
                                    <option value="6.IN">6.IN</option>
                                    <option value="6.FY">6.FY</option>
                                    <option value="guest">guest</option>
                                    
                                  </select><br />
                                  <input type="checkbox" name="agreement" id="agreement" onclick="if (this.checked) document.getElementById('submit').disabled=false; else document.getElementById('submit').disabled=true"> Súhlasím s <a href="http://webdesign.courses.matfyz.sk/?module=Home&amp;page=terms">podmienkami predmetu</a></input>
                                  <br /><br />
                                  <p class="fail"> Prihlásiť sa môžete iba ak súhlasíte s podmienkami účasti.</p>
                                  <input type="submit" name="submit" id="submit" class="submit" value="Registruj" disabled="true" /><br />
                                </form>
              
                                <div class='spacer'></div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="wrap-b lb">
          <span class="rb">
            <span class="i"></span>
          </span>
        </div>
        
        <div class="wrap-t lt">
          <span class="rt">
            <span class="i"></span>
          </span>
        </div>
        <div class="wrap">
          <div class="f1 f-o">
            <div class="l">
              <div class="t">
                <div class="b">
                  <div class="r">
                    <div class="lt">
                      <div class="lb">
                        <div class="rt">
                          <div class="rb f-i">
                            <div id="footer">
                              <div id="footer-menu">
                                <a href="http://{$base}"><img alt="blog.matfyz.sk" src="css/logo-160.png" width="160" height="55" /></a>
                                <!--
                                    <a href="http://blog.matfyz.sk/">hlavna stranka</a> |
                                    <a href="http://blog.matfyz.sk/about">o nas</a> |
                                    <a href="http://blog.matfyz.sk/sitemap">mapa stranok</a> |
                                    <a href="http://blog.matfyz.sk/legal">prava a zaruky</a> |
                                    <a href="http://blog.matfyz.sk/qa">kvalita</a>
                                    -->
                                  </div>
                                  <p>
                                    http://blog.matfyz.sk/<br/>
                                    (c) <a href="http://team.blog.matfyz.sk/">matfyz.sk team</a>, 2007<br/>
                                    <!-- toto tu chcem mat, ale musim si updatnut ten web najprv -->
                                    page updated: 23 September 2007
                                  </p>
                                  <img src="gif/spacer.gif" width="1" height="1" alt="" style="clear:both"/>
                                </div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <!--wrap-->
            <div class="wrap-b lb">
              <span class="rb">
                <span class="i"></span>
              </span>
            </div>
      </body>
    </html>
    
  </xsl:template>
  
</xsl:stylesheet>