<?php
/************************************************************************
  			BlogWriter.php - Copyright anton

Header file: /web/diplomovka/UML/umbrello headers/heading.php
This file was generated on Po júl 16 2007 at 10:21:08
The original location of this file is /web/diplomovka/generated/BlogWriter.php
**************************************************************************/



/**
 * class BlogWriter
 * BlogEditor modifies data in Blog. Creates new posts and comments.
 */
class BlogWriter
{

   /*** Attributes: ***/
  private $userID;

  /**
   *
   * @param int userID 
   * @return 
   * @access public
   */
  public function __construct($params)
  {
    $this->userID = $params['userID'];
    $postID = array_key_exists("postID",$_POST) ? $_POST['postID'] : 0;
    $commentID = array_key_exists("commentID",$_POST) ? $_POST['commentID'] : 0;
    $title = array_key_exists("title",$_POST) ? $_POST['title'] : "";
    $comment = array_key_exists("comment",$_POST) ? $_POST['comment'] : "";
    $content = array_key_exists("postContent",$_POST) ? $_POST['postContent'] : "";
    $tags = array_key_exists("tags",$_POST) ? explode(",",$_POST['tags']) : "";
    $description = array_key_exists("description",$_POST) ? $_POST['description'] : "";
    $subtitle = array_key_exists("subtitle",$_POST) ? $_POST['subtitle'] : "";
    $language = array_key_exists("language",$_POST) ? $_POST['language'] : "";
    $status = array_key_exists("status",$_POST) ? $_POST['status'] : "";
    if (array_key_exists('type',$params))
      switch($params['type'])
      {
        case "addComment":
        {
          $this->newComment($postID, $commentID, $title, $comment);
          break;
        }
        case "addPost":
        {
          $this->newPost($title, $content, $tags, $description, $subtitle, $language, $status);
          break;
        }
        case "editPost":
        {
          $this->editPost($postID, $title, $content, $tags, $description, $subtitle, $language, $status);
          break;
        }
        case "deleteComment":
        {
          $this->deleteComment($postID, $commentID);
          break;
        }
        case "deletePost":
        {
          $this->deletePost($postID);
          break;
        }
        case "changeSettings":
        {
          if (isset($_POST['blogTitle'])) $this->setTitle($_POST['blogTitle']);
          break;
        }
        case "changePostStatus":
        {
          $this->setStatus($postID, $_POST['status']);
        }
      }
      
  } // end of member function __construct

  /**
   *
   * @return 
   * @access public
   */
  public function newPost($title, $content, $tags, $description="", $subtitle="", $language="sk", $status='published')
  {
    $max = $GLOBALS['system']->getMaxID();
    $tagsXML = "";
    if (is_array($tags))
      foreach ($tags as $tag)
      {
        $tagsXML .= '<tag>'.trim($tag).'</tag>';
      }
    
    $query = 'update insert
        <post ID="p'.($max+1).'" accessCount="0" lang="'.$language.'" status="'.$status.'">
          <title>'.formatText($title).'</title>
          <subtitle>'.formatText($subtitle).'</subtitle>
          <content> '.formatText($content).' </content>
          <tags>'.$tagsXML.'</tags>
          <date timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</date>
          <comments />
        </post>
        into collection("weblog")/user[@ID="'.$this->userID.'"]/blog';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function newPost

  /**
   *
   * @return 
   * @access public
   */
  public function newComment($postID, $commentID, $title, $text)
  {
    $guest = array_key_exists("guest",$_POST) ? $_POST['guest'] : "Anonym";
    $max = $GLOBALS['system']->getMaxID();
    //dumpxml($query);
    if ($_SESSION['session']->isLogged()) $authorXML =
          '<author userID="'.$_SESSION['session']->getUser()->getID().'">
            {collection("weblog")/user[@ID=\''.$_SESSION['session']->getUser()->getID().'\']/info/nick}
            {collection("weblog")/user[@ID=\''.$_SESSION['session']->getUser()->getID().'\']/info/realName}
           </author>';
    else $authorXML = '<author guest="true">'.formatText($guest).'</author>';
    $query = 'update insert
        <comment ID="p'.($max+1).'">'.
           $authorXML.
          "<content> ".formatText($text).' </content>
            <title>'.formatText($title).'</title>
            <date timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</date>
        </comment>';
    if (!empty($commentID))
      $query .= 'into collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.$postID.'"]//comment[@ID="'.$commentID.'"]';
    else
      $query .= 'into collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.$postID.'"]/comments';
    $GLOBALS['system']->getDB()->fetchNode($query);
    //dumpxml($query);
    // header("Location: ?type=postView&userID=".$this->userID."&postID=$postID");
  } // end of member function newComment

  /**
   *
   * @return 
   * @access public
   */
  public function editPost($id,$title, $content, $tags, $description="", $subtitle="", $language='sk', $status='published')
  {
    if (strtolower($status)=='reset') $status='published' ; // riadi sa to podla buttonov, a je tam aj button reset, a taky stav nechceme;
    $tagsXML = "";
    if (is_array($tags))
      foreach ($tags as $tag)
        $tagsXML .= '<tag>'.trim($tag).'</tag>';
    
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.$id.'"]
        with
        <post ID="'.($id).'" accessCount="{$i/@accessCount+1}" lang="'.$language.'" status="'.$status.'">
        <title>'.formatText($title).'</title>
        <subtitle>'.formatText($subtitle).'</subtitle>
        <content> '.formatText($content).' </content>
        <tags>'.$tagsXML.'</tags>
        <lastUpdate timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</lastUpdate>
        {$i/date}
        {$i/comments}
        
        </post>';
        
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function editPost
  
   /**
   * Nastavenia stavu prispevku draft/published/held
   * @return 
   * @access public
   */    
  public function setStatus($id, $status)
  {
    if (strtolower($status)=='reset') return ; // riadi sa to podla buttonov, a je tam aj button reset, a taky stav nechceme;
    $currentStatus =  $GLOBALS['system']->getDB()->fetchNode('collection("weblog")/user/blog/post[@ID="'.$id.'"]/@status/normalize-space()');
    if ($status=='published' && $currentStatus=="draft")
    { 
      $xquery = 'update replace $i in collection("weblog")/user/blog/post[@ID="'.$id.'"]/date with  <date timestamp="'.time().'">'.date("Y-m-d\TH:i:s").'</date>';
      $GLOBALS['system']->getDB()->fetchNode($xquery);
    }

    $xquery = 'update replace $i in collection("weblog")/user/blog/post[@ID="'.$id.'"]/@status
         with attribute status {"'.$status.'"}';
    $GLOBALS['system']->getDB()->fetchNode($xquery);
  }

  /**
   * Zmazanie prispevku
   * @return 
   * @access public
   */
  public function deletePost($postID)
  {
    $query = 'update delete collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.$postID.'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);
    
  } // end of member function deletePost

  /**
  *
  * @return
  * @access public
  */
  public function deleteComment($postID,$commentID)
  {
    $query = 'update delete collection("weblog")/user[@ID="'.$_SESSION['session']->getUser()->getID().'"]/blog/post//comment[@ID="'.$commentID.'"]';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function deletePost

  /**
  * @access public
  */
  public function setTitle($title)
  {
    $query = 'update replace $i in collection("weblog")/user[@ID="'.$this->userID.'"]/blog/title with <title>'.formatText($title).'</title>';
    $GLOBALS['system']->getDB()->fetchNode($query);
  } // end of member function setTitle

  /**
  *
  * @return 
  * @access public
  */
  public function getUserData( ) {
    
  } // end of member function getUserData
      
  /**
  *
  * @return 
  * @access public
  */
  public function incPostAccessCount($postID) 
  {
    /*$xquery = "collection('weblog')/user[@ID=\"".$this->userID."\"]/blog/post[@ID=\"".$postID."\"]/@accessCount/normalize-space()";
    $count = $GLOBALS['system']->getDB()->fetchNode($xquery);
    @$count++; */
    if (empty($count)) ;//$xquery = "update insert accessCount /user[@ID=\"".$this->userID."\"]/blog/post[@ID=\"".$postID."\"]/@accessCount with $count";;
    $xquery = 'update replace $i in collection("weblog")/user[@ID="'.$this->userID.'"]/blog/post[@ID="'.$postID.'"]/@accessCount with attribute accessCount {$i+1}';
    $GLOBALS['system']->getDB()->fetchNode($xquery); 
  } // end of member function
  
   /**
  *
  * @return 
  * @access public
  */
  public function incPostVotesCount($postID) 
  {
    $xquery = "/user/blog/post[@ID=\"".$postID."\"]/votes/@count";
    $count =intval($GLOBALS['system']->getDB()->fetchNode($xquery));
    //
    if (!$count) $xquery = "update insert <votes count='1'></votes> into /user/blog/post[@ID=\"".$postID."\"]";
    else 
    {
      @$count++; 
      $xquery = "update replace /user/blog/post[@ID=\"".$postID."\"]/votes/@count with '$count'";
    }
    $GLOBALS['system']->getDB()->fetchNode($xquery); 
  } // end of member function





} // end of BlogWriter
?>
