<?php
/**
* This file contains the code for querying NXD Sedna
*
* PHP version 5
*
* @author     Anton Kohutovic
* @license    GPL
*/

/**
* Sednat Class
*
* This class is the main interface for accses to NXD Sedna
*
* @access   public
*/
require_once "NXDapi.php";

class Sedna
    implements NXDapi
{
  protected $user     = "guest";
  protected $password = "guest";
  protected $error      = "";
  protected $database;
  protected $hosta;
  protected $result;
  protected $queryTime;
  protected $debug=true;
  private $mysql;

  public function __construct($host="localhost", $database="weblog",$user="guest", $password="guest")
  {
    //dl('sedna.so');
    ini_set("sedna.verbosity","1");
    $this->user = $user;
    $this->host = $host;
    $this->password = $password;
    $this->database = $database;
    $this->mysql = new MysqlDB();
    $this->mysql->connect(DBSERVER, DBUSER, DBPASSWORD);
    $this->mysql->selectDB(DBNAME);
  }


  public function disconnect()
  {
    sedna_close();
  }

  public function connect()
  {
    if (sedna_connect($this->host,$this->database,$this->user,$this->password)) return true;
    else throw new Exception("Sedna error: Connection failed."); 
  }

  public function getError()
  {
      return $this->error;
  }

  public function execute($query)
  {
    $start=microtime(true);
    $return = sedna_execute($query);
    $time = microtime(true)-$start;
    $sql = 'INSERT INTO sedna_queries VALUES ("'.addslashes($query).'",'.$time.')';
    $this->mysql->execute($sql);
    if (!$return) die("Sedna error: ".dumpxml($query).sedna_error());
    return $return;
  }

  public function fetchNode($query)
  {
    if (!$this->execute($query)) 
    {
      die($this->getError());
    }
    else
      if (is_array($this->result=sedna_result_array())) return implode("",$this->result);
      else return $this->result;
  }

  public function getQueryTime($formatted=false)
  {
    if ($formatted) return ($this->queryTime/1000)."s";
    else  return $this->queryTime;
  }

  public function fetchArray($query)
  {
    if (!$this->execute($query)) 
    {
      die($this->getError());
    }
    else return $results = sedna_result_array();
  }

}
