<?php

/**
*  Nejak pomocne funkcie, ktore sa mozu casom presunut
**/

/** Autoload tried */
function __autoload($className) {
	$file = CESTA ."classes/{$className}.php";
	if (file_exists($file))
	  require_once $file;
}

/** Veci */
function myIP() {
  return isset($REMORE_ADDR)
    ? $REMORE_ADDR
    : isset($_SERVER['HTTP_X_FORWARDED_FOR'])
      ? $_SERVER['HTTP_X_FORWARDED_FOR']
      : @$_SERVER['REMOTE_ADDR'];
}
function UserAgent() {
  return isset($HTTP_USER_AGENT)
    ? $HTTP_USER_AGENT
    : @$_SERVER['HTTP_USER_AGENT'];
}

/** Generator */
function generateID() {
  return "sess".md5(uniqid());
}

/** Vytvorenie sedenia */
function makeSession($text = "", $restore = false)
{
  if ($restore && session_is_registered("session"))
    unset($_SESSION['session']);
  $newid = generateID();
  @session_start();
  if (!session_is_registered("session")) {
    session_destroy();
    session_id($newid);
    session_start();
    $_SESSION['session'] = new Session(session_id());
    if ($restore)
      echo '<div style="color: red;">'.$text.'</div>' . "\n";
  } else
    checkSession();
}

/** Flawed secutiry **/
function checkSession() {
  try {
    // TODO: blocker default exception handler
    if (is_array($_SESSION) && array_key_exists("ip",$_SESSION) && $_SESSION['ip'] == myIP());
    else
      // throw new Exception("IP conflict. Restart your browser.");
      makeSession("IP conflict. Restarting session...", true);
    if (is_array($_SESSION) && array_key_exists("ua",$_SESSION) && $_SESSION['ua'] == UserAgent());
    else
      // throw new Exception("UserAgent conflict. Restart your browser.");
      makeSession("UserAgent conflict. Restarting session...", true);
    if (!ereg("^[[:alnum:]]+$", session_id()))
      // throw new Exception("Invalid sessionid format. Restart your browser.");
      makeSession("Invalid sessionid format. Restarting session...", true);
  } catch (Excetion $e) {
    session_destroy();
    makeSession($e->getMessage(), true);
  }

}

/** Presmerovanie stranky **/
function redirect($url,$vars=false)
{
  if (is_array($vars))
  {
    $urlVars = Array();
    foreach ($vars as $key=>$value)
    {
      $urlVars[] = $key.'='.$value;
    }
    $url .= "?".implode("&",$urlVars);
  }
  header("Location: {$url}");
  // Niektori boti nereaguju na header()
  $url =
    '<meta http-equiv="refresh" content="5;url='.$url.'" />' .
    "\n" . $url;
  die($url);
}

/** Generator nahodnych hesiel **/
function makePassword($length)
{
  srand((double)microtime()*100000); 
  $znaky = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-";
  $string = "";
  do
  {
    $string .= substr($znaky, rand()%(strlen($znaky)),1);
  }
  while(strlen($string)< $length);
  return($string);
}

function sendMail($email, $subject, $content)
{
  require_once('mailer/class.phpmailer.php');
  $mailer = new PHPMailer();
  $mailer->From = "blogportal@matfyz.sk";
  $mailer->FromName = "Matfyz Blogportal";
  $mailer->AddAddress($email);
  $mailer->WordWrap = 50; // set word wrap to 50 characters
  $mailer->IsHTML(false); // set email format to HTML
  $mailer->Subject = $subject;
  $mailer->Body    = $content;
  if(!$mailer->Send()) throw new Exception("Unable to send mail");
}

function formatText($text) {
  //$text = nl2br($text);
  $text = str_replace("{",'{{',$text);
  $text = str_replace("}",'}}',$text);
  $text = stripslashes($text);
  return trim(htmlspecialchars($text,ENT_QUOTES,"utf-8"));
}

function size_readable($size, $retstring = null)  {
  $sizes = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
  if ($retstring === null) { $retstring = '%01.2f %s'; }
  $lastsizestring = end($sizes);
  foreach ($sizes as $sizestring)
  {
    if ($size < 1024) { break; }
    if ($sizestring != $lastsizestring) { $size /= 1024; }
  }
  if ($sizestring == $sizes[0]) { $retstring = '%01d %s'; } 
  return sprintf($retstring, $size, $sizestring);
}

function my_highlighter($matches) {
  return '<span class="highlight">' . $matches[0] . '</span>';
}

function highlightKeywords($text, $keywords) {
  return $text;
}

/** Validatory **/
function isWF() {
   return
     ereg("^65\.61\.165\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^128\.30\.52\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^193\.51\.208\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^133\.27\.228\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^207\.234\.146\.",$_SERVER["REMOTE_ADDR"])
     || ereg("^80\.190\.243\.77",$_SERVER["REMOTE_ADDR"])
     || ereg("^212\.100\.224\.155",$_SERVER["REMOTE_ADDR"]) 
  ;
}

/** Preformatuje text na iba cisla, pismena, medzery **/
function formatSString($text) {
	$out = "";
	for ($i=0;$i<strlen($text);$i++) {
	  if (ereg("[[:alnum:]]", $text[$i]) || ereg("[[:space:]]", $text[$i]))
	    $out .= $text[$i];
	}
	return $out;
}

?>